/* Application.c generated by valac 0.54.8, the Vala compiler
 * generated from Application.vala, do not modify */

/*
 * SPDX-License-Identifier: GPL-3.0-or-later
 * SPDX-FileCopyrightText: 2020-2022 Louis Brauer <louis@brauer.family>
 */

#include <gtk/gtk.h>
#include <glib-object.h>
#include <gio/gio.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <locale.h>
#include <glib/gi18n-lib.h>

#define TUNER_APPLICATION_APP_VERSION "1.5.0"
#define TUNER_APPLICATION_APP_ID "com.github.louis77.tuner"
#define TUNER_APPLICATION_STAR_CHAR "★ "
#define TUNER_APPLICATION_UNSTAR_CHAR "☆ "
#define GETTEXT_PACKAGE "com.github.louis77.tuner"
#define LOCALEDIR "/usr/share/locale"
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define TUNER_TYPE_APPLICATION (tuner_application_get_type ())
#define TUNER_APPLICATION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TUNER_TYPE_APPLICATION, TunerApplication))
#define TUNER_APPLICATION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TUNER_TYPE_APPLICATION, TunerApplicationClass))
#define TUNER_IS_APPLICATION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TUNER_TYPE_APPLICATION))
#define TUNER_IS_APPLICATION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TUNER_TYPE_APPLICATION))
#define TUNER_APPLICATION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TUNER_TYPE_APPLICATION, TunerApplicationClass))

typedef struct _TunerApplication TunerApplication;
typedef struct _TunerApplicationClass TunerApplicationClass;
typedef struct _TunerApplicationPrivate TunerApplicationPrivate;

#define TUNER_TYPE_WINDOW (tuner_window_get_type ())
#define TUNER_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TUNER_TYPE_WINDOW, TunerWindow))
#define TUNER_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TUNER_TYPE_WINDOW, TunerWindowClass))
#define TUNER_IS_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TUNER_TYPE_WINDOW))
#define TUNER_IS_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TUNER_TYPE_WINDOW))
#define TUNER_WINDOW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TUNER_TYPE_WINDOW, TunerWindowClass))

typedef struct _TunerWindow TunerWindow;
typedef struct _TunerWindowClass TunerWindowClass;

#define TUNER_TYPE_PLAYER_CONTROLLER (tuner_player_controller_get_type ())
#define TUNER_PLAYER_CONTROLLER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TUNER_TYPE_PLAYER_CONTROLLER, TunerPlayerController))
#define TUNER_PLAYER_CONTROLLER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TUNER_TYPE_PLAYER_CONTROLLER, TunerPlayerControllerClass))
#define TUNER_IS_PLAYER_CONTROLLER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TUNER_TYPE_PLAYER_CONTROLLER))
#define TUNER_IS_PLAYER_CONTROLLER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TUNER_TYPE_PLAYER_CONTROLLER))
#define TUNER_PLAYER_CONTROLLER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TUNER_TYPE_PLAYER_CONTROLLER, TunerPlayerControllerClass))

typedef struct _TunerPlayerController TunerPlayerController;
typedef struct _TunerPlayerControllerClass TunerPlayerControllerClass;
enum  {
	TUNER_APPLICATION_0_PROPERTY,
	TUNER_APPLICATION_SETTINGS_PROPERTY,
	TUNER_APPLICATION_PLAYER_PROPERTY,
	TUNER_APPLICATION_CACHE_DIR_PROPERTY,
	TUNER_APPLICATION_DATA_DIR_PROPERTY,
	TUNER_APPLICATION_NUM_PROPERTIES
};
static GParamSpec* tuner_application_properties[TUNER_APPLICATION_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

struct _TunerApplication {
	GtkApplication parent_instance;
	TunerApplicationPrivate * priv;
	TunerWindow* window;
};

struct _TunerApplicationClass {
	GtkApplicationClass parent_class;
};

struct _TunerApplicationPrivate {
	GSettings* _settings;
	TunerPlayerController* _player;
	gchar* _cache_dir;
	gchar* _data_dir;
};

static gint TunerApplication_private_offset;
static gpointer tuner_application_parent_class = NULL;
VALA_EXTERN TunerApplication* tuner_application__instance;
TunerApplication* tuner_application__instance = NULL;

VALA_EXTERN GType tuner_application_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (TunerApplication, g_object_unref)
VALA_EXTERN GType tuner_window_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (TunerWindow, g_object_unref)
VALA_EXTERN GType tuner_player_controller_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (TunerPlayerController, g_object_unref)
static void tuner_application_on_resume_window (TunerApplication* self);
static void _tuner_application_on_resume_window_gsimple_action_activate_callback (GSimpleAction* action,
                                                                           GVariant* parameter,
                                                                           gpointer self);
VALA_EXTERN TunerApplication* tuner_application_new (void);
VALA_EXTERN TunerApplication* tuner_application_construct (GType object_type);
static void tuner_application_real_activate (GApplication* base);
VALA_EXTERN TunerPlayerController* tuner_application_get_player (TunerApplication* self);
VALA_EXTERN TunerWindow* tuner_window_new (TunerApplication* app,
                               TunerPlayerController* player);
VALA_EXTERN TunerWindow* tuner_window_construct (GType object_type,
                                     TunerApplication* app,
                                     TunerPlayerController* player);
VALA_EXTERN void tuner_dbus_initialize (void);
static void tuner_application_ensure_dir (TunerApplication* self,
                                   const gchar* path);
VALA_EXTERN GSettings* tuner_application_get_settings (TunerApplication* self);
static void tuner_application_set_settings (TunerApplication* self,
                                     GSettings* value);
static void tuner_application_set_player (TunerApplication* self,
                                   TunerPlayerController* value);
VALA_EXTERN const gchar* tuner_application_get_cache_dir (TunerApplication* self);
static void tuner_application_set_cache_dir (TunerApplication* self,
                                      const gchar* value);
VALA_EXTERN const gchar* tuner_application_get_data_dir (TunerApplication* self);
static void tuner_application_set_data_dir (TunerApplication* self,
                                     const gchar* value);
VALA_EXTERN TunerApplication* tuner_application_get_instance (void);
static GObject * tuner_application_constructor (GType type,
                                         guint n_construct_properties,
                                         GObjectConstructParam * construct_properties);
VALA_EXTERN TunerPlayerController* tuner_player_controller_new (void);
VALA_EXTERN TunerPlayerController* tuner_player_controller_construct (GType object_type);
static void tuner_application_finalize (GObject * obj);
static GType tuner_application_get_type_once (void);
static void _vala_tuner_application_get_property (GObject * object,
                                           guint property_id,
                                           GValue * value,
                                           GParamSpec * pspec);
static void _vala_tuner_application_set_property (GObject * object,
                                           guint property_id,
                                           const GValue * value,
                                           GParamSpec * pspec);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

static const GActionEntry TUNER_APPLICATION_ACTION_ENTRIES[1] = {{"resume-window", _tuner_application_on_resume_window_gsimple_action_activate_callback}};

static inline gpointer
tuner_application_get_instance_private (TunerApplication* self)
{
	return G_STRUCT_MEMBER_P (self, TunerApplication_private_offset);
}

static void
_tuner_application_on_resume_window_gsimple_action_activate_callback (GSimpleAction* action,
                                                                      GVariant* parameter,
                                                                      gpointer self)
{
	tuner_application_on_resume_window ((TunerApplication*) self);
}

TunerApplication*
tuner_application_construct (GType object_type)
{
	TunerApplication * self = NULL;
	self = (TunerApplication*) g_object_new (object_type, "application-id", TUNER_APPLICATION_APP_ID, "flags", G_APPLICATION_FLAGS_NONE, NULL);
	return self;
}

TunerApplication*
tuner_application_new (void)
{
	return tuner_application_construct (TUNER_TYPE_APPLICATION);
}

static void
tuner_application_real_activate (GApplication* base)
{
	TunerApplication * self;
	TunerWindow* _tmp0_;
	self = (TunerApplication*) base;
	_tmp0_ = self->window;
	if (_tmp0_ == NULL) {
		TunerPlayerController* _tmp1_;
		TunerWindow* _tmp2_;
		TunerWindow* _tmp3_;
		_tmp1_ = self->priv->_player;
		_tmp2_ = tuner_window_new (self, _tmp1_);
		g_object_ref_sink (_tmp2_);
		_g_object_unref0 (self->window);
		self->window = _tmp2_;
		_tmp3_ = self->window;
		gtk_application_add_window ((GtkApplication*) self, (GtkWindow*) _tmp3_);
		tuner_dbus_initialize ();
	} else {
		TunerWindow* _tmp4_;
		_tmp4_ = self->window;
		gtk_window_present ((GtkWindow*) _tmp4_);
	}
}

static void
tuner_application_on_resume_window (TunerApplication* self)
{
	TunerWindow* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->window;
	gtk_window_present ((GtkWindow*) _tmp0_);
}

static const gchar*
string_to_string (const gchar* self)
{
	const gchar* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	result = self;
	return result;
}

static void
tuner_application_ensure_dir (TunerApplication* self,
                              const gchar* path)
{
	GFile* dir = NULL;
	GFile* _tmp0_;
	GError* _inner_error0_ = NULL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (path != NULL);
	_tmp0_ = g_file_new_for_path (path);
	dir = _tmp0_;
	{
		const gchar* _tmp1_;
		gchar* _tmp2_;
		gchar* _tmp3_;
		_tmp1_ = string_to_string (path);
		_tmp2_ = g_strconcat ("Ensuring dir exists: ", _tmp1_, NULL);
		_tmp3_ = _tmp2_;
		g_debug ("Application.vala:79: %s", _tmp3_);
		_g_free0 (_tmp3_);
		g_file_make_directory (dir, NULL, &_inner_error0_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp4_;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp4_ = e;
		if (!g_error_matches (_tmp4_, G_IO_ERROR, G_IO_ERROR_EXISTS)) {
			GError* _tmp5_;
			const gchar* _tmp6_;
			_tmp5_ = e;
			_tmp6_ = _tmp5_->message;
			g_warning ("Application.vala:86: dir couldn't be created: %s", _tmp6_);
		}
		_g_error_free0 (e);
	}
	__finally0:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		_g_object_unref0 (dir);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return;
	}
	_g_object_unref0 (dir);
}

GSettings*
tuner_application_get_settings (TunerApplication* self)
{
	GSettings* result;
	GSettings* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_settings;
	result = _tmp0_;
	return result;
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

static void
tuner_application_set_settings (TunerApplication* self,
                                GSettings* value)
{
	GSettings* old_value;
	g_return_if_fail (self != NULL);
	old_value = tuner_application_get_settings (self);
	if (old_value != value) {
		GSettings* _tmp0_;
		_tmp0_ = _g_object_ref0 (value);
		_g_object_unref0 (self->priv->_settings);
		self->priv->_settings = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, tuner_application_properties[TUNER_APPLICATION_SETTINGS_PROPERTY]);
	}
}

TunerPlayerController*
tuner_application_get_player (TunerApplication* self)
{
	TunerPlayerController* result;
	TunerPlayerController* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_player;
	result = _tmp0_;
	return result;
}

static void
tuner_application_set_player (TunerApplication* self,
                              TunerPlayerController* value)
{
	TunerPlayerController* old_value;
	g_return_if_fail (self != NULL);
	old_value = tuner_application_get_player (self);
	if (old_value != value) {
		TunerPlayerController* _tmp0_;
		_tmp0_ = _g_object_ref0 (value);
		_g_object_unref0 (self->priv->_player);
		self->priv->_player = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, tuner_application_properties[TUNER_APPLICATION_PLAYER_PROPERTY]);
	}
}

const gchar*
tuner_application_get_cache_dir (TunerApplication* self)
{
	const gchar* result;
	const gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_cache_dir;
	result = _tmp0_;
	return result;
}

static void
tuner_application_set_cache_dir (TunerApplication* self,
                                 const gchar* value)
{
	gchar* old_value;
	g_return_if_fail (self != NULL);
	old_value = tuner_application_get_cache_dir (self);
	if (g_strcmp0 (value, old_value) != 0) {
		gchar* _tmp0_;
		_tmp0_ = g_strdup (value);
		_g_free0 (self->priv->_cache_dir);
		self->priv->_cache_dir = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, tuner_application_properties[TUNER_APPLICATION_CACHE_DIR_PROPERTY]);
	}
}

const gchar*
tuner_application_get_data_dir (TunerApplication* self)
{
	const gchar* result;
	const gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_data_dir;
	result = _tmp0_;
	return result;
}

static void
tuner_application_set_data_dir (TunerApplication* self,
                                const gchar* value)
{
	gchar* old_value;
	g_return_if_fail (self != NULL);
	old_value = tuner_application_get_data_dir (self);
	if (g_strcmp0 (value, old_value) != 0) {
		gchar* _tmp0_;
		_tmp0_ = g_strdup (value);
		_g_free0 (self->priv->_data_dir);
		self->priv->_data_dir = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, tuner_application_properties[TUNER_APPLICATION_DATA_DIR_PROPERTY]);
	}
}

TunerApplication*
tuner_application_get_instance (void)
{
	TunerApplication* result;
	TunerApplication* _tmp0_;
	TunerApplication* _tmp2_;
	_tmp0_ = tuner_application__instance;
	if (_tmp0_ == NULL) {
		TunerApplication* _tmp1_;
		_tmp1_ = tuner_application_new ();
		_g_object_unref0 (tuner_application__instance);
		tuner_application__instance = _tmp1_;
	}
	_tmp2_ = tuner_application__instance;
	result = _tmp2_;
	return result;
}

static GObject *
tuner_application_constructor (GType type,
                               guint n_construct_properties,
                               GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	TunerApplication * self;
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	GSettings* _tmp2_;
	GSettings* _tmp3_;
	TunerPlayerController* _tmp4_;
	TunerPlayerController* _tmp5_;
	const gchar* _tmp6_;
	const gchar* _tmp7_;
	const gchar* _tmp8_;
	gchar* _tmp9_;
	gchar* _tmp10_;
	const gchar* _tmp11_;
	const gchar* _tmp12_;
	const gchar* _tmp13_;
	const gchar* _tmp14_;
	gchar* _tmp15_;
	gchar* _tmp16_;
	const gchar* _tmp17_;
	parent_class = G_OBJECT_CLASS (tuner_application_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TUNER_TYPE_APPLICATION, TunerApplication);
	setlocale (LC_ALL, "");
	bindtextdomain (GETTEXT_PACKAGE, LOCALEDIR);
	bind_textdomain_codeset (GETTEXT_PACKAGE, "UTF-8");
	textdomain (GETTEXT_PACKAGE);
	_tmp0_ = g_application_get_application_id ((GApplication*) self);
	_tmp1_ = _tmp0_;
	_tmp2_ = g_settings_new (_tmp1_);
	_tmp3_ = _tmp2_;
	tuner_application_set_settings (self, _tmp3_);
	_g_object_unref0 (_tmp3_);
	_tmp4_ = tuner_player_controller_new ();
	_tmp5_ = _tmp4_;
	tuner_application_set_player (self, _tmp5_);
	_g_object_unref0 (_tmp5_);
	_tmp6_ = g_get_user_cache_dir ();
	_tmp7_ = g_application_get_application_id ((GApplication*) self);
	_tmp8_ = _tmp7_;
	_tmp9_ = g_build_filename (_tmp6_, _tmp8_, NULL);
	_tmp10_ = _tmp9_;
	tuner_application_set_cache_dir (self, _tmp10_);
	_g_free0 (_tmp10_);
	_tmp11_ = self->priv->_cache_dir;
	tuner_application_ensure_dir (self, _tmp11_);
	_tmp12_ = g_get_user_data_dir ();
	_tmp13_ = g_application_get_application_id ((GApplication*) self);
	_tmp14_ = _tmp13_;
	_tmp15_ = g_build_filename (_tmp12_, _tmp14_, NULL);
	_tmp16_ = _tmp15_;
	tuner_application_set_data_dir (self, _tmp16_);
	_g_free0 (_tmp16_);
	_tmp17_ = self->priv->_data_dir;
	tuner_application_ensure_dir (self, _tmp17_);
	g_action_map_add_action_entries ((GActionMap*) self, TUNER_APPLICATION_ACTION_ENTRIES, (gint) G_N_ELEMENTS (TUNER_APPLICATION_ACTION_ENTRIES), self);
	return obj;
}

static void
tuner_application_class_init (TunerApplicationClass * klass,
                              gpointer klass_data)
{
	tuner_application_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &TunerApplication_private_offset);
	((GApplicationClass *) klass)->activate = (void (*) (GApplication*)) tuner_application_real_activate;
	G_OBJECT_CLASS (klass)->get_property = _vala_tuner_application_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_tuner_application_set_property;
	G_OBJECT_CLASS (klass)->constructor = tuner_application_constructor;
	G_OBJECT_CLASS (klass)->finalize = tuner_application_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), TUNER_APPLICATION_SETTINGS_PROPERTY, tuner_application_properties[TUNER_APPLICATION_SETTINGS_PROPERTY] = g_param_spec_object ("settings", "settings", "settings", g_settings_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
	g_object_class_install_property (G_OBJECT_CLASS (klass), TUNER_APPLICATION_PLAYER_PROPERTY, tuner_application_properties[TUNER_APPLICATION_PLAYER_PROPERTY] = g_param_spec_object ("player", "player", "player", TUNER_TYPE_PLAYER_CONTROLLER, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
	g_object_class_install_property (G_OBJECT_CLASS (klass), TUNER_APPLICATION_CACHE_DIR_PROPERTY, tuner_application_properties[TUNER_APPLICATION_CACHE_DIR_PROPERTY] = g_param_spec_string ("cache-dir", "cache-dir", "cache-dir", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
	g_object_class_install_property (G_OBJECT_CLASS (klass), TUNER_APPLICATION_DATA_DIR_PROPERTY, tuner_application_properties[TUNER_APPLICATION_DATA_DIR_PROPERTY] = g_param_spec_string ("data-dir", "data-dir", "data-dir", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
}

static void
tuner_application_instance_init (TunerApplication * self,
                                 gpointer klass)
{
	self->priv = tuner_application_get_instance_private (self);
}

static void
tuner_application_finalize (GObject * obj)
{
	TunerApplication * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TUNER_TYPE_APPLICATION, TunerApplication);
	_g_object_unref0 (self->priv->_settings);
	_g_object_unref0 (self->priv->_player);
	_g_free0 (self->priv->_cache_dir);
	_g_free0 (self->priv->_data_dir);
	_g_object_unref0 (self->window);
	G_OBJECT_CLASS (tuner_application_parent_class)->finalize (obj);
}

static GType
tuner_application_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (TunerApplicationClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) tuner_application_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (TunerApplication), 0, (GInstanceInitFunc) tuner_application_instance_init, NULL };
	GType tuner_application_type_id;
	tuner_application_type_id = g_type_register_static (gtk_application_get_type (), "TunerApplication", &g_define_type_info, 0);
	TunerApplication_private_offset = g_type_add_instance_private (tuner_application_type_id, sizeof (TunerApplicationPrivate));
	return tuner_application_type_id;
}

GType
tuner_application_get_type (void)
{
	static volatile gsize tuner_application_type_id__volatile = 0;
	if (g_once_init_enter (&tuner_application_type_id__volatile)) {
		GType tuner_application_type_id;
		tuner_application_type_id = tuner_application_get_type_once ();
		g_once_init_leave (&tuner_application_type_id__volatile, tuner_application_type_id);
	}
	return tuner_application_type_id__volatile;
}

static void
_vala_tuner_application_get_property (GObject * object,
                                      guint property_id,
                                      GValue * value,
                                      GParamSpec * pspec)
{
	TunerApplication * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TUNER_TYPE_APPLICATION, TunerApplication);
	switch (property_id) {
		case TUNER_APPLICATION_SETTINGS_PROPERTY:
		g_value_set_object (value, tuner_application_get_settings (self));
		break;
		case TUNER_APPLICATION_PLAYER_PROPERTY:
		g_value_set_object (value, tuner_application_get_player (self));
		break;
		case TUNER_APPLICATION_CACHE_DIR_PROPERTY:
		g_value_set_string (value, tuner_application_get_cache_dir (self));
		break;
		case TUNER_APPLICATION_DATA_DIR_PROPERTY:
		g_value_set_string (value, tuner_application_get_data_dir (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_tuner_application_set_property (GObject * object,
                                      guint property_id,
                                      const GValue * value,
                                      GParamSpec * pspec)
{
	TunerApplication * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TUNER_TYPE_APPLICATION, TunerApplication);
	switch (property_id) {
		case TUNER_APPLICATION_SETTINGS_PROPERTY:
		tuner_application_set_settings (self, g_value_get_object (value));
		break;
		case TUNER_APPLICATION_PLAYER_PROPERTY:
		tuner_application_set_player (self, g_value_get_object (value));
		break;
		case TUNER_APPLICATION_CACHE_DIR_PROPERTY:
		tuner_application_set_cache_dir (self, g_value_get_string (value));
		break;
		case TUNER_APPLICATION_DATA_DIR_PROPERTY:
		tuner_application_set_data_dir (self, g_value_get_string (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

