/* PlayerController.c generated by valac 0.54.8, the Vala compiler
 * generated from PlayerController.vala, do not modify */

/*
 * SPDX-License-Identifier: GPL-3.0-or-later
 * SPDX-FileCopyrightText: 2020-2022 Louis Brauer <louis@brauer.family>
 */

#include <glib-object.h>
#include <gst/player/player.h>
#include <glib.h>
#include <string.h>
#include <stdlib.h>
#include <gst/gst.h>
#include <float.h>
#include <math.h>

#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define TUNER_TYPE_PLAYER_CONTROLLER (tuner_player_controller_get_type ())
#define TUNER_PLAYER_CONTROLLER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TUNER_TYPE_PLAYER_CONTROLLER, TunerPlayerController))
#define TUNER_PLAYER_CONTROLLER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TUNER_TYPE_PLAYER_CONTROLLER, TunerPlayerControllerClass))
#define TUNER_IS_PLAYER_CONTROLLER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TUNER_TYPE_PLAYER_CONTROLLER))
#define TUNER_IS_PLAYER_CONTROLLER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TUNER_TYPE_PLAYER_CONTROLLER))
#define TUNER_PLAYER_CONTROLLER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TUNER_TYPE_PLAYER_CONTROLLER, TunerPlayerControllerClass))

typedef struct _TunerPlayerController TunerPlayerController;
typedef struct _TunerPlayerControllerClass TunerPlayerControllerClass;
typedef struct _TunerPlayerControllerPrivate TunerPlayerControllerPrivate;

#define TUNER_MODEL_TYPE_STATION (tuner_model_station_get_type ())
#define TUNER_MODEL_STATION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TUNER_MODEL_TYPE_STATION, TunerModelStation))
#define TUNER_MODEL_STATION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TUNER_MODEL_TYPE_STATION, TunerModelStationClass))
#define TUNER_MODEL_IS_STATION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TUNER_MODEL_TYPE_STATION))
#define TUNER_MODEL_IS_STATION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TUNER_MODEL_TYPE_STATION))
#define TUNER_MODEL_STATION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TUNER_MODEL_TYPE_STATION, TunerModelStationClass))

typedef struct _TunerModelStation TunerModelStation;
typedef struct _TunerModelStationClass TunerModelStationClass;
enum  {
	TUNER_PLAYER_CONTROLLER_0_PROPERTY,
	TUNER_PLAYER_CONTROLLER_CURRENT_STATE_PROPERTY,
	TUNER_PLAYER_CONTROLLER_STATION_PROPERTY,
	TUNER_PLAYER_CONTROLLER_VOLUME_PROPERTY,
	TUNER_PLAYER_CONTROLLER_NUM_PROPERTIES
};
static GParamSpec* tuner_player_controller_properties[TUNER_PLAYER_CONTROLLER_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) ((var == NULL) ? NULL : (var = (g_free (var), NULL)))
typedef struct _Block2Data Block2Data;
#define _gst_tag_list_unref0(var) ((var == NULL) ? NULL : (var = (gst_tag_list_unref (var), NULL)))
enum  {
	TUNER_PLAYER_CONTROLLER_STATION_CHANGED_SIGNAL,
	TUNER_PLAYER_CONTROLLER_STATE_CHANGED_SIGNAL,
	TUNER_PLAYER_CONTROLLER_TITLE_CHANGED_SIGNAL,
	TUNER_PLAYER_CONTROLLER_VOLUME_CHANGED_SIGNAL,
	TUNER_PLAYER_CONTROLLER_NUM_SIGNALS
};
static guint tuner_player_controller_signals[TUNER_PLAYER_CONTROLLER_NUM_SIGNALS] = {0};

struct _TunerPlayerController {
	GObject parent_instance;
	TunerPlayerControllerPrivate * priv;
	GstPlayer* player;
};

struct _TunerPlayerControllerClass {
	GObjectClass parent_class;
};

struct _TunerPlayerControllerPrivate {
	TunerModelStation* _station;
	GstPlayerState* _current_state;
};

struct _Block2Data {
	int _ref_count_;
	TunerPlayerController* self;
	gchar* title;
};

static gint TunerPlayerController_private_offset;
static gpointer tuner_player_controller_parent_class = NULL;

VALA_EXTERN GType tuner_player_controller_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (TunerPlayerController, g_object_unref)
VALA_EXTERN GType tuner_model_station_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (TunerModelStation, g_object_unref)
static GstPlayerState* _gst_player_state_dup (GstPlayerState* self);
VALA_EXTERN void tuner_player_controller_play_station (TunerPlayerController* self,
                                           TunerModelStation* station);
VALA_EXTERN const gchar* tuner_model_station_get_url (TunerModelStation* self);
VALA_EXTERN gboolean tuner_player_controller_can_play (TunerPlayerController* self);
VALA_EXTERN void tuner_player_controller_play_pause (TunerPlayerController* self);
static gchar* tuner_player_controller_extract_title_from_stream (TunerPlayerController* self,
                                                          GstPlayerMediaInfo* media_info);
static Block2Data* block2_data_ref (Block2Data* _data2_);
static void block2_data_unref (void * _userdata_);
static void ____lambda4_ (Block2Data* _data2_,
                   GstTagList* list,
                   const gchar* tag);
static void _____lambda4__gst_tag_foreach_func (GstTagList* list,
                                         const gchar* tag,
                                         gpointer self);
VALA_EXTERN TunerPlayerController* tuner_player_controller_new (void);
VALA_EXTERN TunerPlayerController* tuner_player_controller_construct (GType object_type);
VALA_EXTERN GstPlayerState* tuner_player_controller_get_current_state (TunerPlayerController* self);
VALA_EXTERN void tuner_player_controller_set_current_state (TunerPlayerController* self,
                                                GstPlayerState* value);
VALA_EXTERN TunerModelStation* tuner_player_controller_get_station (TunerPlayerController* self);
VALA_EXTERN void tuner_player_controller_set_station (TunerPlayerController* self,
                                          TunerModelStation* value);
VALA_EXTERN gdouble tuner_player_controller_get_volume (TunerPlayerController* self);
VALA_EXTERN void tuner_player_controller_set_volume (TunerPlayerController* self,
                                         gdouble value);
static GObject * tuner_player_controller_constructor (GType type,
                                               guint n_construct_properties,
                                               GObjectConstructParam * construct_properties);
static void _tuner_player_controller___lambda5_ (TunerPlayerController* self,
                                          GstPlayerState state);
static gboolean _gst_player_state_equal (const GstPlayerState * s1,
                                  const GstPlayerState * s2);
static void __tuner_player_controller___lambda5__gst_player_state_changed (GstPlayer* _sender,
                                                                    GstPlayerState object,
                                                                    gpointer self);
static void _tuner_player_controller___lambda6_ (TunerPlayerController* self,
                                          GstPlayerMediaInfo* obj);
static void __tuner_player_controller___lambda6__gst_player_media_info_updated (GstPlayer* _sender,
                                                                         GstPlayerMediaInfo* object,
                                                                         gpointer self);
static void _tuner_player_controller___lambda7_ (TunerPlayerController* self,
                                          GstPlayer* obj);
static void __tuner_player_controller___lambda7__gst_player_volume_changed (GstPlayer* _sender,
                                                                     gpointer self);
static void tuner_player_controller_finalize (GObject * obj);
static GType tuner_player_controller_get_type_once (void);
static void _vala_tuner_player_controller_get_property (GObject * object,
                                                 guint property_id,
                                                 GValue * value,
                                                 GParamSpec * pspec);
static void _vala_tuner_player_controller_set_property (GObject * object,
                                                 guint property_id,
                                                 const GValue * value,
                                                 GParamSpec * pspec);

static inline gpointer
tuner_player_controller_get_instance_private (TunerPlayerController* self)
{
	return G_STRUCT_MEMBER_P (self, TunerPlayerController_private_offset);
}

static GstPlayerState*
_gst_player_state_dup (GstPlayerState* self)
{
	GstPlayerState* dup;
	dup = g_new0 (GstPlayerState, 1);
	memcpy (dup, self, sizeof (GstPlayerState));
	return dup;
}

static gpointer
__gst_player_state_dup0 (gpointer self)
{
	return self ? _gst_player_state_dup (self) : NULL;
}

void
tuner_player_controller_play_station (TunerPlayerController* self,
                                      TunerModelStation* station)
{
	GstPlayer* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	GstPlayer* _tmp3_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (station != NULL);
	_tmp0_ = self->player;
	_tmp1_ = tuner_model_station_get_url (station);
	_tmp2_ = _tmp1_;
	gst_player_set_uri (_tmp0_, _tmp2_);
	_tmp3_ = self->player;
	gst_player_play (_tmp3_);
	g_signal_emit (self, tuner_player_controller_signals[TUNER_PLAYER_CONTROLLER_STATION_CHANGED_SIGNAL], 0, station);
}

gboolean
tuner_player_controller_can_play (TunerPlayerController* self)
{
	TunerModelStation* _tmp0_;
	gboolean result = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->_station;
	result = _tmp0_ != NULL;
	return result;
}

void
tuner_player_controller_play_pause (TunerPlayerController* self)
{
	GstPlayerState* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->_current_state;
	switch (*_tmp0_) {
		case GST_PLAYER_STATE_PLAYING:
		case GST_PLAYER_STATE_BUFFERING:
		{
			GstPlayer* _tmp1_;
			_tmp1_ = self->player;
			gst_player_stop (_tmp1_);
			break;
		}
		default:
		{
			GstPlayer* _tmp2_;
			_tmp2_ = self->player;
			gst_player_play (_tmp2_);
			break;
		}
	}
}

static Block2Data*
block2_data_ref (Block2Data* _data2_)
{
	g_atomic_int_inc (&_data2_->_ref_count_);
	return _data2_;
}

static void
block2_data_unref (void * _userdata_)
{
	Block2Data* _data2_;
	_data2_ = (Block2Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data2_->_ref_count_)) {
		TunerPlayerController* self;
		self = _data2_->self;
		_g_free0 (_data2_->title);
		_g_object_unref0 (self);
		g_slice_free (Block2Data, _data2_);
	}
}

static gpointer
_gst_tag_list_ref0 (gpointer self)
{
	return self ? gst_tag_list_ref (self) : NULL;
}

static void
____lambda4_ (Block2Data* _data2_,
              GstTagList* list,
              const gchar* tag)
{
	TunerPlayerController* self;
	self = _data2_->self;
	g_return_if_fail (list != NULL);
	g_return_if_fail (tag != NULL);
	if (g_strcmp0 (tag, "title") == 0) {
		gchar* _tmp0_ = NULL;
		gst_tag_list_get_string (list, tag, &_tmp0_);
		_g_free0 (_data2_->title);
		_data2_->title = _tmp0_;
	}
}

static void
_____lambda4__gst_tag_foreach_func (GstTagList* list,
                                    const gchar* tag,
                                    gpointer self)
{
	____lambda4_ (self, list, tag);
}

static gchar*
tuner_player_controller_extract_title_from_stream (TunerPlayerController* self,
                                                   GstPlayerMediaInfo* media_info)
{
	Block2Data* _data2_;
	GList* streamlist = NULL;
	GList* _tmp0_;
	GList* _tmp1_;
	GList* _tmp2_;
	const gchar* _tmp7_;
	gchar* _tmp8_;
	gchar* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (media_info != NULL, NULL);
	_data2_ = g_slice_new0 (Block2Data);
	_data2_->_ref_count_ = 1;
	_data2_->self = g_object_ref (self);
	_data2_->title = NULL;
	_tmp0_ = gst_player_media_info_get_stream_list (media_info);
	_tmp1_ = g_list_copy (_tmp0_);
	streamlist = _tmp1_;
	_tmp2_ = streamlist;
	{
		GList* stream_collection = NULL;
		GList* stream_it = NULL;
		stream_collection = _tmp2_;
		for (stream_it = stream_collection; stream_it != NULL; stream_it = stream_it->next) {
			GstPlayerStreamInfo* stream = NULL;
			stream = (GstPlayerStreamInfo*) stream_it->data;
			{
				GstTagList* tags = NULL;
				GstPlayerStreamInfo* _tmp3_;
				GstTagList* _tmp4_;
				GstTagList* _tmp5_;
				GstTagList* _tmp6_;
				_tmp3_ = stream;
				_tmp4_ = gst_player_stream_info_get_tags (_tmp3_);
				_tmp5_ = _gst_tag_list_ref0 (_tmp4_);
				tags = _tmp5_;
				_tmp6_ = tags;
				gst_tag_list_foreach (_tmp6_, _____lambda4__gst_tag_foreach_func, _data2_);
				_gst_tag_list_unref0 (tags);
			}
		}
	}
	_tmp7_ = _data2_->title;
	_tmp8_ = g_strdup (_tmp7_);
	result = _tmp8_;
	(streamlist == NULL) ? NULL : (streamlist = (g_list_free (streamlist), NULL));
	block2_data_unref (_data2_);
	_data2_ = NULL;
	return result;
}

TunerPlayerController*
tuner_player_controller_construct (GType object_type)
{
	TunerPlayerController * self = NULL;
	self = (TunerPlayerController*) g_object_new (object_type, NULL);
	return self;
}

TunerPlayerController*
tuner_player_controller_new (void)
{
	return tuner_player_controller_construct (TUNER_TYPE_PLAYER_CONTROLLER);
}

GstPlayerState*
tuner_player_controller_get_current_state (TunerPlayerController* self)
{
	GstPlayerState* result;
	GstPlayerState* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_current_state;
	result = _tmp0_;
	return result;
}

void
tuner_player_controller_set_current_state (TunerPlayerController* self,
                                           GstPlayerState* value)
{
	GstPlayerState* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = __gst_player_state_dup0 (value);
	_g_free0 (self->priv->_current_state);
	self->priv->_current_state = _tmp0_;
	g_object_notify_by_pspec ((GObject *) self, tuner_player_controller_properties[TUNER_PLAYER_CONTROLLER_CURRENT_STATE_PROPERTY]);
}

TunerModelStation*
tuner_player_controller_get_station (TunerPlayerController* self)
{
	TunerModelStation* result;
	TunerModelStation* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_station;
	result = _tmp0_;
	return result;
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

void
tuner_player_controller_set_station (TunerPlayerController* self,
                                     TunerModelStation* value)
{
	TunerModelStation* _tmp0_;
	TunerModelStation* _tmp1_;
	g_return_if_fail (self != NULL);
	_tmp0_ = _g_object_ref0 (value);
	_g_object_unref0 (self->priv->_station);
	self->priv->_station = _tmp0_;
	_tmp1_ = self->priv->_station;
	tuner_player_controller_play_station (self, _tmp1_);
	g_object_notify_by_pspec ((GObject *) self, tuner_player_controller_properties[TUNER_PLAYER_CONTROLLER_STATION_PROPERTY]);
}

gdouble
tuner_player_controller_get_volume (TunerPlayerController* self)
{
	gdouble result;
	GstPlayer* _tmp0_;
	gdouble _tmp1_;
	gdouble _tmp2_;
	g_return_val_if_fail (self != NULL, 0.0);
	_tmp0_ = self->player;
	_tmp1_ = gst_player_get_volume (_tmp0_);
	_tmp2_ = _tmp1_;
	result = _tmp2_;
	return result;
}

void
tuner_player_controller_set_volume (TunerPlayerController* self,
                                    gdouble value)
{
	GstPlayer* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->player;
	gst_player_set_volume (_tmp0_, value);
	g_object_notify_by_pspec ((GObject *) self, tuner_player_controller_properties[TUNER_PLAYER_CONTROLLER_VOLUME_PROPERTY]);
}

static gboolean
_gst_player_state_equal (const GstPlayerState * s1,
                         const GstPlayerState * s2)
{
	if (s1 == s2) {
		return TRUE;
	}
	if (s1 == NULL) {
		return FALSE;
	}
	if (s2 == NULL) {
		return FALSE;
	}
	return (*s1) == (*s2);
}

static void
_tuner_player_controller___lambda5_ (TunerPlayerController* self,
                                     GstPlayerState state)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	GstPlayerState* _tmp2_;
	GstPlayerState* _tmp3_;
	GstPlayerState _tmp4_;
	_tmp2_ = tuner_player_controller_get_current_state (self);
	_tmp3_ = _tmp2_;
	_tmp4_ = GST_PLAYER_STATE_PLAYING;
	if (_gst_player_state_equal (_tmp3_, &_tmp4_) == TRUE) {
		_tmp1_ = state == GST_PLAYER_STATE_BUFFERING;
	} else {
		_tmp1_ = FALSE;
	}
	if (!_tmp1_) {
		GstPlayerState* _tmp5_;
		GstPlayerState* _tmp6_;
		_tmp5_ = tuner_player_controller_get_current_state (self);
		_tmp6_ = _tmp5_;
		_tmp0_ = !(_gst_player_state_equal (&state, _tmp6_) == TRUE);
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		g_signal_emit (self, tuner_player_controller_signals[TUNER_PLAYER_CONTROLLER_STATE_CHANGED_SIGNAL], 0, state);
		tuner_player_controller_set_current_state (self, &state);
	}
}

static void
__tuner_player_controller___lambda5__gst_player_state_changed (GstPlayer* _sender,
                                                               GstPlayerState object,
                                                               gpointer self)
{
	_tuner_player_controller___lambda5_ ((TunerPlayerController*) self, object);
}

static const gchar*
string_to_string (const gchar* self)
{
	const gchar* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	result = self;
	return result;
}

static void
_tuner_player_controller___lambda6_ (TunerPlayerController* self,
                                     GstPlayerMediaInfo* obj)
{
	gchar* title = NULL;
	gchar* _tmp0_;
	const gchar* _tmp1_;
	g_return_if_fail (obj != NULL);
	_tmp0_ = tuner_player_controller_extract_title_from_stream (self, obj);
	title = _tmp0_;
	_tmp1_ = title;
	if (_tmp1_ != NULL) {
		const gchar* _tmp2_;
		const gchar* _tmp3_;
		gchar* _tmp4_;
		gchar* _tmp5_;
		const gchar* _tmp6_;
		_tmp2_ = title;
		_tmp3_ = string_to_string (_tmp2_);
		_tmp4_ = g_strconcat ("Got new title from station: ", _tmp3_, NULL);
		_tmp5_ = _tmp4_;
		g_debug ("PlayerController.vala:29: %s", _tmp5_);
		_g_free0 (_tmp5_);
		_tmp6_ = title;
		g_signal_emit (self, tuner_player_controller_signals[TUNER_PLAYER_CONTROLLER_TITLE_CHANGED_SIGNAL], 0, _tmp6_);
	}
	_g_free0 (title);
}

static void
__tuner_player_controller___lambda6__gst_player_media_info_updated (GstPlayer* _sender,
                                                                    GstPlayerMediaInfo* object,
                                                                    gpointer self)
{
	_tuner_player_controller___lambda6_ ((TunerPlayerController*) self, object);
}

static void
_tuner_player_controller___lambda7_ (TunerPlayerController* self,
                                     GstPlayer* obj)
{
	gdouble _tmp0_;
	gdouble _tmp1_;
	g_return_if_fail (obj != NULL);
	_tmp0_ = gst_player_get_volume (obj);
	_tmp1_ = _tmp0_;
	g_signal_emit (self, tuner_player_controller_signals[TUNER_PLAYER_CONTROLLER_VOLUME_CHANGED_SIGNAL], 0, _tmp1_);
}

static void
__tuner_player_controller___lambda7__gst_player_volume_changed (GstPlayer* _sender,
                                                                gpointer self)
{
	_tuner_player_controller___lambda7_ ((TunerPlayerController*) self, _sender);
}

static GObject *
tuner_player_controller_constructor (GType type,
                                     guint n_construct_properties,
                                     GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	TunerPlayerController * self;
	GstPlayer* _tmp0_;
	GstPlayer* _tmp1_;
	GstPlayer* _tmp2_;
	GstPlayer* _tmp3_;
	parent_class = G_OBJECT_CLASS (tuner_player_controller_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TUNER_TYPE_PLAYER_CONTROLLER, TunerPlayerController);
	_tmp0_ = gst_player_new (NULL, NULL);
	g_object_ref_sink (_tmp0_);
	_g_object_unref0 (self->player);
	self->player = _tmp0_;
	_tmp1_ = self->player;
	g_signal_connect_object (_tmp1_, "state-changed", (GCallback) __tuner_player_controller___lambda5__gst_player_state_changed, self, 0);
	_tmp2_ = self->player;
	g_signal_connect_object (_tmp2_, "media-info-updated", (GCallback) __tuner_player_controller___lambda6__gst_player_media_info_updated, self, 0);
	_tmp3_ = self->player;
	g_signal_connect_object (_tmp3_, "volume-changed", (GCallback) __tuner_player_controller___lambda7__gst_player_volume_changed, self, 0);
	return obj;
}

static void
tuner_player_controller_class_init (TunerPlayerControllerClass * klass,
                                    gpointer klass_data)
{
	tuner_player_controller_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &TunerPlayerController_private_offset);
	G_OBJECT_CLASS (klass)->get_property = _vala_tuner_player_controller_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_tuner_player_controller_set_property;
	G_OBJECT_CLASS (klass)->constructor = tuner_player_controller_constructor;
	G_OBJECT_CLASS (klass)->finalize = tuner_player_controller_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), TUNER_PLAYER_CONTROLLER_CURRENT_STATE_PROPERTY, tuner_player_controller_properties[TUNER_PLAYER_CONTROLLER_CURRENT_STATE_PROPERTY] = g_param_spec_enum ("current-state", "current-state", "current-state", gst_player_state_get_type (), 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), TUNER_PLAYER_CONTROLLER_STATION_PROPERTY, tuner_player_controller_properties[TUNER_PLAYER_CONTROLLER_STATION_PROPERTY] = g_param_spec_object ("station", "station", "station", TUNER_MODEL_TYPE_STATION, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), TUNER_PLAYER_CONTROLLER_VOLUME_PROPERTY, tuner_player_controller_properties[TUNER_PLAYER_CONTROLLER_VOLUME_PROPERTY] = g_param_spec_double ("volume", "volume", "volume", -G_MAXDOUBLE, G_MAXDOUBLE, 0.0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	tuner_player_controller_signals[TUNER_PLAYER_CONTROLLER_STATION_CHANGED_SIGNAL] = g_signal_new ("station-changed", TUNER_TYPE_PLAYER_CONTROLLER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, TUNER_MODEL_TYPE_STATION);
	tuner_player_controller_signals[TUNER_PLAYER_CONTROLLER_STATE_CHANGED_SIGNAL] = g_signal_new ("state-changed", TUNER_TYPE_PLAYER_CONTROLLER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__ENUM, G_TYPE_NONE, 1, gst_player_state_get_type ());
	tuner_player_controller_signals[TUNER_PLAYER_CONTROLLER_TITLE_CHANGED_SIGNAL] = g_signal_new ("title-changed", TUNER_TYPE_PLAYER_CONTROLLER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__STRING, G_TYPE_NONE, 1, G_TYPE_STRING);
	tuner_player_controller_signals[TUNER_PLAYER_CONTROLLER_VOLUME_CHANGED_SIGNAL] = g_signal_new ("volume-changed", TUNER_TYPE_PLAYER_CONTROLLER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__DOUBLE, G_TYPE_NONE, 1, G_TYPE_DOUBLE);
}

static void
tuner_player_controller_instance_init (TunerPlayerController * self,
                                       gpointer klass)
{
	GstPlayerState _tmp0_;
	GstPlayerState* _tmp1_;
	self->priv = tuner_player_controller_get_instance_private (self);
	_tmp0_ = GST_PLAYER_STATE_STOPPED;
	_tmp1_ = __gst_player_state_dup0 (&_tmp0_);
	self->priv->_current_state = _tmp1_;
}

static void
tuner_player_controller_finalize (GObject * obj)
{
	TunerPlayerController * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TUNER_TYPE_PLAYER_CONTROLLER, TunerPlayerController);
	_g_object_unref0 (self->priv->_station);
	_g_free0 (self->priv->_current_state);
	_g_object_unref0 (self->player);
	G_OBJECT_CLASS (tuner_player_controller_parent_class)->finalize (obj);
}

static GType
tuner_player_controller_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (TunerPlayerControllerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) tuner_player_controller_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (TunerPlayerController), 0, (GInstanceInitFunc) tuner_player_controller_instance_init, NULL };
	GType tuner_player_controller_type_id;
	tuner_player_controller_type_id = g_type_register_static (G_TYPE_OBJECT, "TunerPlayerController", &g_define_type_info, 0);
	TunerPlayerController_private_offset = g_type_add_instance_private (tuner_player_controller_type_id, sizeof (TunerPlayerControllerPrivate));
	return tuner_player_controller_type_id;
}

GType
tuner_player_controller_get_type (void)
{
	static volatile gsize tuner_player_controller_type_id__volatile = 0;
	if (g_once_init_enter (&tuner_player_controller_type_id__volatile)) {
		GType tuner_player_controller_type_id;
		tuner_player_controller_type_id = tuner_player_controller_get_type_once ();
		g_once_init_leave (&tuner_player_controller_type_id__volatile, tuner_player_controller_type_id);
	}
	return tuner_player_controller_type_id__volatile;
}

static void
_vala_tuner_player_controller_get_property (GObject * object,
                                            guint property_id,
                                            GValue * value,
                                            GParamSpec * pspec)
{
	TunerPlayerController * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TUNER_TYPE_PLAYER_CONTROLLER, TunerPlayerController);
	switch (property_id) {
		case TUNER_PLAYER_CONTROLLER_CURRENT_STATE_PROPERTY:
		g_value_set_enum (value, tuner_player_controller_get_current_state (self));
		break;
		case TUNER_PLAYER_CONTROLLER_STATION_PROPERTY:
		g_value_set_object (value, tuner_player_controller_get_station (self));
		break;
		case TUNER_PLAYER_CONTROLLER_VOLUME_PROPERTY:
		g_value_set_double (value, tuner_player_controller_get_volume (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_tuner_player_controller_set_property (GObject * object,
                                            guint property_id,
                                            const GValue * value,
                                            GParamSpec * pspec)
{
	TunerPlayerController * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TUNER_TYPE_PLAYER_CONTROLLER, TunerPlayerController);
	switch (property_id) {
		case TUNER_PLAYER_CONTROLLER_CURRENT_STATE_PROPERTY:
		tuner_player_controller_set_current_state (self, g_value_get_enum (value));
		break;
		case TUNER_PLAYER_CONTROLLER_STATION_PROPERTY:
		tuner_player_controller_set_station (self, g_value_get_object (value));
		break;
		case TUNER_PLAYER_CONTROLLER_VOLUME_PROPERTY:
		tuner_player_controller_set_volume (self, g_value_get_double (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

