/* StationStore.c generated by valac 0.54.8, the Vala compiler
 * generated from StationStore.vala, do not modify */

/*
 * SPDX-License-Identifier: GPL-3.0-or-later
 * SPDX-FileCopyrightText: 2020-2022 Louis Brauer <louis@brauer.family>
 */
/* StationStore can store and retrieve a collection of stations*/
/* in a JSON file*/

#include <glib-object.h>
#include <gee.h>
#include <gio/gio.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <json-glib/json-glib.h>

#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define TUNER_MODEL_TYPE_STATION_STORE (tuner_model_station_store_get_type ())
#define TUNER_MODEL_STATION_STORE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TUNER_MODEL_TYPE_STATION_STORE, TunerModelStationStore))
#define TUNER_MODEL_STATION_STORE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TUNER_MODEL_TYPE_STATION_STORE, TunerModelStationStoreClass))
#define TUNER_MODEL_IS_STATION_STORE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TUNER_MODEL_TYPE_STATION_STORE))
#define TUNER_MODEL_IS_STATION_STORE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TUNER_MODEL_TYPE_STATION_STORE))
#define TUNER_MODEL_STATION_STORE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TUNER_MODEL_TYPE_STATION_STORE, TunerModelStationStoreClass))

typedef struct _TunerModelStationStore TunerModelStationStore;
typedef struct _TunerModelStationStoreClass TunerModelStationStoreClass;
typedef struct _TunerModelStationStorePrivate TunerModelStationStorePrivate;

#define TUNER_MODEL_TYPE_STATION (tuner_model_station_get_type ())
#define TUNER_MODEL_STATION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TUNER_MODEL_TYPE_STATION, TunerModelStation))
#define TUNER_MODEL_STATION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TUNER_MODEL_TYPE_STATION, TunerModelStationClass))
#define TUNER_MODEL_IS_STATION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TUNER_MODEL_TYPE_STATION))
#define TUNER_MODEL_IS_STATION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TUNER_MODEL_TYPE_STATION))
#define TUNER_MODEL_STATION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TUNER_MODEL_TYPE_STATION, TunerModelStationClass))

typedef struct _TunerModelStation TunerModelStation;
typedef struct _TunerModelStationClass TunerModelStationClass;
enum  {
	TUNER_MODEL_STATION_STORE_0_PROPERTY,
	TUNER_MODEL_STATION_STORE_NUM_PROPERTIES
};
static GParamSpec* tuner_model_station_store_properties[TUNER_MODEL_STATION_STORE_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
typedef struct _Block3Data Block3Data;
#define _json_array_unref0(var) ((var == NULL) ? NULL : (var = (json_array_unref (var), NULL)))
#define __vala_JsonNode_free0(var) ((var == NULL) ? NULL : (var = (_vala_JsonNode_free (var), NULL)))

struct _TunerModelStationStore {
	GObject parent_instance;
	TunerModelStationStorePrivate * priv;
};

struct _TunerModelStationStoreClass {
	GObjectClass parent_class;
};

struct _TunerModelStationStorePrivate {
	GeeArrayList* _store;
	GFile* _data_file;
};

struct _Block3Data {
	int _ref_count_;
	TunerModelStationStore* self;
	TunerModelStation* station;
};

static gint TunerModelStationStore_private_offset;
static gpointer tuner_model_station_store_parent_class = NULL;

VALA_EXTERN GType tuner_model_station_store_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (TunerModelStationStore, g_object_unref)
VALA_EXTERN GType tuner_model_station_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (TunerModelStation, g_object_unref)
VALA_EXTERN TunerModelStationStore* tuner_model_station_store_new (const gchar* data_path);
VALA_EXTERN TunerModelStationStore* tuner_model_station_store_construct (GType object_type,
                                                             const gchar* data_path);
static void tuner_model_station_store_ensure (TunerModelStationStore* self);
static void tuner_model_station_store_load (TunerModelStationStore* self);
VALA_EXTERN void tuner_model_station_store_add (TunerModelStationStore* self,
                                    TunerModelStation* station);
static void _tuner_model_station_store_add (TunerModelStationStore* self,
                                     TunerModelStation* station);
static void tuner_model_station_store_persist (TunerModelStationStore* self);
VALA_EXTERN void tuner_model_station_store_remove (TunerModelStationStore* self,
                                       TunerModelStation* station);
static JsonNode* _vala_JsonNode_copy (JsonNode* self);
static void __lambda32_ (TunerModelStationStore* self,
                  JsonArray* a,
                  guint i,
                  JsonNode* elem);
static Block3Data* block3_data_ref (Block3Data* _data3_);
static void block3_data_unref (void * _userdata_);
static void __lambda33_ (Block3Data* _data3_,
                  GObject* sender,
                  GParamSpec* property);
VALA_EXTERN gboolean tuner_model_station_get_starred (TunerModelStation* self);
static void ___lambda33__g_object_notify (GObject* _sender,
                                   GParamSpec* pspec,
                                   gpointer self);
static void ___lambda32__json_array_foreach (JsonArray* array,
                                      guint index_,
                                      JsonNode* element_node,
                                      gpointer self);
static void _vala_JsonNode_free (JsonNode* self);
VALA_EXTERN gchar* tuner_model_station_store_serialize (TunerModelStationStore* self);
VALA_EXTERN GeeArrayList* tuner_model_station_store_get_all (TunerModelStationStore* self);
VALA_EXTERN gboolean tuner_model_station_store_contains (TunerModelStationStore* self,
                                             TunerModelStation* station);
VALA_EXTERN const gchar* tuner_model_station_get_id (TunerModelStation* self);
static void tuner_model_station_store_finalize (GObject * obj);
static GType tuner_model_station_store_get_type_once (void);

static inline gpointer
tuner_model_station_store_get_instance_private (TunerModelStationStore* self)
{
	return G_STRUCT_MEMBER_P (self, TunerModelStationStore_private_offset);
}

static const gchar*
string_to_string (const gchar* self)
{
	const gchar* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	result = self;
	return result;
}

TunerModelStationStore*
tuner_model_station_store_construct (GType object_type,
                                     const gchar* data_path)
{
	TunerModelStationStore * self = NULL;
	GeeArrayList* _tmp0_;
	GFile* _tmp1_;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	g_return_val_if_fail (data_path != NULL, NULL);
	self = (TunerModelStationStore*) g_object_new (object_type, NULL);
	_tmp0_ = gee_array_list_new (TUNER_MODEL_TYPE_STATION, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
	_g_object_unref0 (self->priv->_store);
	self->priv->_store = _tmp0_;
	_tmp1_ = g_file_new_for_path (data_path);
	_g_object_unref0 (self->priv->_data_file);
	self->priv->_data_file = _tmp1_;
	tuner_model_station_store_ensure (self);
	tuner_model_station_store_load (self);
	_tmp2_ = string_to_string (data_path);
	_tmp3_ = g_strconcat ("store initialized in path ", _tmp2_, NULL);
	_tmp4_ = _tmp3_;
	g_debug ("StationStore.vala:24: %s", _tmp4_);
	_g_free0 (_tmp4_);
	return self;
}

TunerModelStationStore*
tuner_model_station_store_new (const gchar* data_path)
{
	return tuner_model_station_store_construct (TUNER_MODEL_TYPE_STATION_STORE, data_path);
}

void
tuner_model_station_store_add (TunerModelStationStore* self,
                               TunerModelStation* station)
{
	g_return_if_fail (self != NULL);
	g_return_if_fail (station != NULL);
	_tuner_model_station_store_add (self, station);
	tuner_model_station_store_persist (self);
}

static void
_tuner_model_station_store_add (TunerModelStationStore* self,
                                TunerModelStation* station)
{
	GeeArrayList* _tmp0_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (station != NULL);
	_tmp0_ = self->priv->_store;
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp0_, station);
}

void
tuner_model_station_store_remove (TunerModelStationStore* self,
                                  TunerModelStation* station)
{
	GeeArrayList* _tmp0_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (station != NULL);
	_tmp0_ = self->priv->_store;
	gee_abstract_collection_remove ((GeeAbstractCollection*) _tmp0_, station);
	tuner_model_station_store_persist (self);
}

static void
tuner_model_station_store_ensure (TunerModelStationStore* self)
{
	GError* _inner_error0_ = NULL;
	g_return_if_fail (self != NULL);
	{
		GFileOutputStream* df = NULL;
		GFile* _tmp0_;
		GFileOutputStream* _tmp1_;
		GFileOutputStream* _tmp2_;
		_tmp0_ = self->priv->_data_file;
		_tmp1_ = g_file_create (_tmp0_, G_FILE_CREATE_PRIVATE, NULL, &_inner_error0_);
		df = _tmp1_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			goto __catch0_g_error;
		}
		_tmp2_ = df;
		g_output_stream_close ((GOutputStream*) _tmp2_, NULL, &_inner_error0_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			_g_object_unref0 (df);
			goto __catch0_g_error;
		}
		g_debug ("StationStore.vala:48: %s", "store created");
		_g_object_unref0 (df);
	}
	goto __finally0;
	__catch0_g_error:
	{
		g_clear_error (&_inner_error0_);
	}
	__finally0:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return;
	}
}

static JsonNode*
_vala_JsonNode_copy (JsonNode* self)
{
	return g_boxed_copy (json_node_get_type (), self);
}

static gpointer
__vala_JsonNode_copy0 (gpointer self)
{
	return self ? _vala_JsonNode_copy (self) : NULL;
}

static gpointer
_json_array_ref0 (gpointer self)
{
	return self ? json_array_ref (self) : NULL;
}

static Block3Data*
block3_data_ref (Block3Data* _data3_)
{
	g_atomic_int_inc (&_data3_->_ref_count_);
	return _data3_;
}

static void
block3_data_unref (void * _userdata_)
{
	Block3Data* _data3_;
	_data3_ = (Block3Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data3_->_ref_count_)) {
		TunerModelStationStore* self;
		self = _data3_->self;
		_g_object_unref0 (_data3_->station);
		_g_object_unref0 (self);
		g_slice_free (Block3Data, _data3_);
	}
}

static void
__lambda33_ (Block3Data* _data3_,
             GObject* sender,
             GParamSpec* property)
{
	TunerModelStationStore* self;
	gboolean _tmp0_;
	gboolean _tmp1_;
	self = _data3_->self;
	g_return_if_fail (sender != NULL);
	g_return_if_fail (property != NULL);
	_tmp0_ = tuner_model_station_get_starred (_data3_->station);
	_tmp1_ = _tmp0_;
	if (_tmp1_) {
		tuner_model_station_store_add (self, _data3_->station);
	} else {
		tuner_model_station_store_remove (self, _data3_->station);
	}
}

static void
___lambda33__g_object_notify (GObject* _sender,
                              GParamSpec* pspec,
                              gpointer self)
{
	__lambda33_ (self, _sender, pspec);
}

static void
__lambda32_ (TunerModelStationStore* self,
             JsonArray* a,
             guint i,
             JsonNode* elem)
{
	Block3Data* _data3_;
	GObject* _tmp0_;
	TunerModelStation* _tmp1_;
	g_return_if_fail (a != NULL);
	g_return_if_fail (elem != NULL);
	_data3_ = g_slice_new0 (Block3Data);
	_data3_->_ref_count_ = 1;
	_data3_->self = g_object_ref (self);
	_tmp0_ = json_gobject_deserialize (TUNER_MODEL_TYPE_STATION, elem);
	_tmp1_ = TUNER_MODEL_IS_STATION (_tmp0_) ? ((TunerModelStation*) _tmp0_) : NULL;
	if (_tmp1_ == NULL) {
		_g_object_unref0 (_tmp0_);
	}
	_data3_->station = _tmp1_;
	g_signal_connect_data ((GObject*) _data3_->station, "notify::starred", (GCallback) ___lambda33__g_object_notify, block3_data_ref (_data3_), (GClosureNotify) block3_data_unref, 0);
	_tuner_model_station_store_add (self, _data3_->station);
	block3_data_unref (_data3_);
	_data3_ = NULL;
}

static void
___lambda32__json_array_foreach (JsonArray* array,
                                 guint index_,
                                 JsonNode* element_node,
                                 gpointer self)
{
	__lambda32_ ((TunerModelStationStore*) self, array, index_, element_node);
}

static void
_vala_JsonNode_free (JsonNode* self)
{
	g_boxed_free (json_node_get_type (), self);
}

static void
tuner_model_station_store_load (TunerModelStationStore* self)
{
	JsonParser* parser = NULL;
	JsonParser* _tmp0_;
	JsonNode* node = NULL;
	JsonParser* _tmp11_;
	JsonNode* _tmp12_;
	JsonNode* _tmp13_;
	JsonArray* array = NULL;
	JsonArray* _tmp14_;
	JsonArray* _tmp15_;
	GeeArrayList* _tmp16_;
	gint _tmp17_;
	gint _tmp18_;
	gchar* _tmp19_;
	gchar* _tmp20_;
	gchar* _tmp21_;
	gchar* _tmp22_;
	GError* _inner_error0_ = NULL;
	g_return_if_fail (self != NULL);
	g_debug ("StationStore.vala:55: loading store");
	_tmp0_ = json_parser_new ();
	parser = _tmp0_;
	{
		GFileInputStream* stream = NULL;
		GFile* _tmp1_;
		GFileInputStream* _tmp2_;
		JsonParser* _tmp3_;
		GFileInputStream* _tmp4_;
		GFileInputStream* _tmp5_;
		_tmp1_ = self->priv->_data_file;
		_tmp2_ = g_file_read (_tmp1_, NULL, &_inner_error0_);
		stream = _tmp2_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			goto __catch0_g_error;
		}
		_tmp3_ = parser;
		_tmp4_ = stream;
		json_parser_load_from_stream (_tmp3_, (GInputStream*) _tmp4_, NULL, &_inner_error0_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			_g_object_unref0 (stream);
			goto __catch0_g_error;
		}
		_tmp5_ = stream;
		g_input_stream_close ((GInputStream*) _tmp5_, NULL, &_inner_error0_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			_g_object_unref0 (stream);
			goto __catch0_g_error;
		}
		_g_object_unref0 (stream);
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp6_;
		const gchar* _tmp7_;
		const gchar* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp6_ = e;
		_tmp7_ = _tmp6_->message;
		_tmp8_ = string_to_string (_tmp7_);
		_tmp9_ = g_strconcat ("store: unable to load data, does it exist? ", _tmp8_, NULL);
		_tmp10_ = _tmp9_;
		g_warning ("StationStore.vala:63: %s", _tmp10_);
		_g_free0 (_tmp10_);
		_g_error_free0 (e);
	}
	__finally0:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		_g_object_unref0 (parser);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return;
	}
	_tmp11_ = parser;
	_tmp12_ = json_parser_get_root (_tmp11_);
	_tmp13_ = __vala_JsonNode_copy0 (_tmp12_);
	node = _tmp13_;
	_tmp14_ = json_node_get_array (node);
	_tmp15_ = _json_array_ref0 (_tmp14_);
	array = _tmp15_;
	json_array_foreach_element (array, ___lambda32__json_array_foreach, self);
	_tmp16_ = self->priv->_store;
	_tmp17_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp16_);
	_tmp18_ = _tmp17_;
	_tmp19_ = g_strdup_printf ("%i", _tmp18_);
	_tmp20_ = _tmp19_;
	_tmp21_ = g_strconcat ("loaded store size: ", _tmp20_, NULL);
	_tmp22_ = _tmp21_;
	g_debug ("StationStore.vala:83: %s", _tmp22_);
	_g_free0 (_tmp22_);
	_g_free0 (_tmp20_);
	_json_array_unref0 (array);
	__vala_JsonNode_free0 (node);
	_g_object_unref0 (parser);
}

static void
tuner_model_station_store_persist (TunerModelStationStore* self)
{
	gchar* data = NULL;
	gchar* _tmp0_;
	GError* _inner_error0_ = NULL;
	g_return_if_fail (self != NULL);
	g_debug ("StationStore.vala:87: persisting store");
	_tmp0_ = tuner_model_station_store_serialize (self);
	data = _tmp0_;
	{
		GFile* _tmp1_;
		GFileOutputStream* stream = NULL;
		GFile* _tmp2_;
		GFileOutputStream* _tmp3_;
		GDataOutputStream* s = NULL;
		GFileOutputStream* _tmp4_;
		GDataOutputStream* _tmp5_;
		GDataOutputStream* _tmp6_;
		const gchar* _tmp7_;
		GDataOutputStream* _tmp8_;
		GDataOutputStream* _tmp9_;
		_tmp1_ = self->priv->_data_file;
		g_file_delete (_tmp1_, NULL, &_inner_error0_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			goto __catch0_g_error;
		}
		_tmp2_ = self->priv->_data_file;
		_tmp3_ = g_file_create (_tmp2_, G_FILE_CREATE_REPLACE_DESTINATION | G_FILE_CREATE_PRIVATE, NULL, &_inner_error0_);
		stream = _tmp3_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			goto __catch0_g_error;
		}
		_tmp4_ = stream;
		_tmp5_ = g_data_output_stream_new ((GOutputStream*) _tmp4_);
		s = _tmp5_;
		_tmp6_ = s;
		_tmp7_ = data;
		g_data_output_stream_put_string (_tmp6_, _tmp7_, NULL, &_inner_error0_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			_g_object_unref0 (s);
			_g_object_unref0 (stream);
			goto __catch0_g_error;
		}
		_tmp8_ = s;
		g_output_stream_flush ((GOutputStream*) _tmp8_, NULL, &_inner_error0_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			_g_object_unref0 (s);
			_g_object_unref0 (stream);
			goto __catch0_g_error;
		}
		_tmp9_ = s;
		g_output_stream_close ((GOutputStream*) _tmp9_, NULL, &_inner_error0_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			_g_object_unref0 (s);
			_g_object_unref0 (stream);
			goto __catch0_g_error;
		}
		_g_object_unref0 (s);
		_g_object_unref0 (stream);
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp10_;
		const gchar* _tmp11_;
		const gchar* _tmp12_;
		gchar* _tmp13_;
		gchar* _tmp14_;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp10_ = e;
		_tmp11_ = _tmp10_->message;
		_tmp12_ = string_to_string (_tmp11_);
		_tmp13_ = g_strconcat ("store: unable to persist store: ", _tmp12_, NULL);
		_tmp14_ = _tmp13_;
		g_warning ("StationStore.vala:100: %s", _tmp14_);
		_g_free0 (_tmp14_);
		_g_error_free0 (e);
	}
	__finally0:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		_g_free0 (data);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return;
	}
	_g_free0 (data);
}

gchar*
tuner_model_station_store_serialize (TunerModelStationStore* self)
{
	JsonBuilder* builder = NULL;
	JsonBuilder* _tmp0_;
	JsonBuilder* _tmp1_;
	JsonBuilder* _tmp15_;
	JsonGenerator* generator = NULL;
	JsonGenerator* _tmp16_;
	JsonBuilder* _tmp17_;
	JsonNode* _tmp18_;
	JsonNode* _tmp19_;
	gchar* data = NULL;
	gchar* _tmp20_;
	gchar* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = json_builder_new ();
	builder = _tmp0_;
	_tmp1_ = builder;
	json_builder_begin_array (_tmp1_);
	{
		GeeArrayList* _station_list = NULL;
		GeeArrayList* _tmp2_;
		gint _station_size = 0;
		GeeArrayList* _tmp3_;
		gint _tmp4_;
		gint _tmp5_;
		gint _station_index = 0;
		_tmp2_ = self->priv->_store;
		_station_list = _tmp2_;
		_tmp3_ = _station_list;
		_tmp4_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp3_);
		_tmp5_ = _tmp4_;
		_station_size = _tmp5_;
		_station_index = -1;
		while (TRUE) {
			gint _tmp6_;
			gint _tmp7_;
			TunerModelStation* station = NULL;
			GeeArrayList* _tmp8_;
			gpointer _tmp9_;
			JsonNode* node = NULL;
			TunerModelStation* _tmp10_;
			JsonNode* _tmp11_;
			JsonBuilder* _tmp12_;
			JsonNode* _tmp13_;
			JsonNode* _tmp14_;
			_station_index = _station_index + 1;
			_tmp6_ = _station_index;
			_tmp7_ = _station_size;
			if (!(_tmp6_ < _tmp7_)) {
				break;
			}
			_tmp8_ = _station_list;
			_tmp9_ = gee_abstract_list_get ((GeeAbstractList*) _tmp8_, _station_index);
			station = (TunerModelStation*) _tmp9_;
			_tmp10_ = station;
			_tmp11_ = json_gobject_serialize ((GObject*) _tmp10_);
			node = _tmp11_;
			_tmp12_ = builder;
			_tmp13_ = node;
			_tmp14_ = __vala_JsonNode_copy0 (_tmp13_);
			json_builder_add_value (_tmp12_, _tmp14_);
			__vala_JsonNode_free0 (node);
			_g_object_unref0 (station);
		}
	}
	_tmp15_ = builder;
	json_builder_end_array (_tmp15_);
	_tmp16_ = json_generator_new ();
	generator = _tmp16_;
	_tmp17_ = builder;
	_tmp18_ = json_builder_get_root (_tmp17_);
	_tmp19_ = _tmp18_;
	json_generator_set_root (generator, _tmp19_);
	__vala_JsonNode_free0 (_tmp19_);
	_tmp20_ = json_generator_to_data (generator, NULL);
	data = _tmp20_;
	result = data;
	_g_object_unref0 (generator);
	_g_object_unref0 (builder);
	return result;
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

GeeArrayList*
tuner_model_station_store_get_all (TunerModelStationStore* self)
{
	GeeArrayList* _tmp0_;
	GeeArrayList* _tmp1_;
	GeeArrayList* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_store;
	_tmp1_ = _g_object_ref0 (_tmp0_);
	result = _tmp1_;
	return result;
}

gboolean
tuner_model_station_store_contains (TunerModelStationStore* self,
                                    TunerModelStation* station)
{
	gboolean result = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (station != NULL, FALSE);
	{
		GeeArrayList* _s_list = NULL;
		GeeArrayList* _tmp0_;
		gint _s_size = 0;
		GeeArrayList* _tmp1_;
		gint _tmp2_;
		gint _tmp3_;
		gint _s_index = 0;
		_tmp0_ = self->priv->_store;
		_s_list = _tmp0_;
		_tmp1_ = _s_list;
		_tmp2_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp1_);
		_tmp3_ = _tmp2_;
		_s_size = _tmp3_;
		_s_index = -1;
		while (TRUE) {
			gint _tmp4_;
			gint _tmp5_;
			TunerModelStation* s = NULL;
			GeeArrayList* _tmp6_;
			gpointer _tmp7_;
			TunerModelStation* _tmp8_;
			const gchar* _tmp9_;
			const gchar* _tmp10_;
			const gchar* _tmp11_;
			const gchar* _tmp12_;
			_s_index = _s_index + 1;
			_tmp4_ = _s_index;
			_tmp5_ = _s_size;
			if (!(_tmp4_ < _tmp5_)) {
				break;
			}
			_tmp6_ = _s_list;
			_tmp7_ = gee_abstract_list_get ((GeeAbstractList*) _tmp6_, _s_index);
			s = (TunerModelStation*) _tmp7_;
			_tmp8_ = s;
			_tmp9_ = tuner_model_station_get_id (_tmp8_);
			_tmp10_ = _tmp9_;
			_tmp11_ = tuner_model_station_get_id (station);
			_tmp12_ = _tmp11_;
			if (g_strcmp0 (_tmp10_, _tmp12_) == 0) {
				result = TRUE;
				_g_object_unref0 (s);
				return result;
			}
			_g_object_unref0 (s);
		}
	}
	result = FALSE;
	return result;
}

static void
tuner_model_station_store_class_init (TunerModelStationStoreClass * klass,
                                      gpointer klass_data)
{
	tuner_model_station_store_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &TunerModelStationStore_private_offset);
	G_OBJECT_CLASS (klass)->finalize = tuner_model_station_store_finalize;
}

static void
tuner_model_station_store_instance_init (TunerModelStationStore * self,
                                         gpointer klass)
{
	self->priv = tuner_model_station_store_get_instance_private (self);
}

static void
tuner_model_station_store_finalize (GObject * obj)
{
	TunerModelStationStore * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TUNER_MODEL_TYPE_STATION_STORE, TunerModelStationStore);
	_g_object_unref0 (self->priv->_store);
	_g_object_unref0 (self->priv->_data_file);
	G_OBJECT_CLASS (tuner_model_station_store_parent_class)->finalize (obj);
}

static GType
tuner_model_station_store_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (TunerModelStationStoreClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) tuner_model_station_store_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (TunerModelStationStore), 0, (GInstanceInitFunc) tuner_model_station_store_instance_init, NULL };
	GType tuner_model_station_store_type_id;
	tuner_model_station_store_type_id = g_type_register_static (G_TYPE_OBJECT, "TunerModelStationStore", &g_define_type_info, 0);
	TunerModelStationStore_private_offset = g_type_add_instance_private (tuner_model_station_store_type_id, sizeof (TunerModelStationStorePrivate));
	return tuner_model_station_store_type_id;
}

GType
tuner_model_station_store_get_type (void)
{
	static volatile gsize tuner_model_station_store_type_id__volatile = 0;
	if (g_once_init_enter (&tuner_model_station_store_type_id__volatile)) {
		GType tuner_model_station_store_type_id;
		tuner_model_station_store_type_id = tuner_model_station_store_get_type_once ();
		g_once_init_leave (&tuner_model_station_store_type_id__volatile, tuner_model_station_store_type_id);
	}
	return tuner_model_station_store_type_id__volatile;
}

