/* Theme.c generated by valac 0.54.8, the Vala compiler
 * generated from Theme.vala, do not modify */

/*
 * SPDX-License-Identifier: GPL-3.0-or-later
 * SPDX-FileCopyrightText: 2020-2022 Louis Brauer <louis@brauer.family>
 */

#include <gtk/gtk.h>
#include <glib-object.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <gdk/gdk.h>

#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define TUNER_TYPE_THEME (tuner_theme_get_type ())
#define TUNER_THEME(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TUNER_TYPE_THEME, TunerTheme))
#define TUNER_THEME_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TUNER_TYPE_THEME, TunerThemeClass))
#define TUNER_IS_THEME(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TUNER_TYPE_THEME))
#define TUNER_IS_THEME_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TUNER_TYPE_THEME))
#define TUNER_THEME_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TUNER_TYPE_THEME, TunerThemeClass))

typedef struct _TunerTheme TunerTheme;
typedef struct _TunerThemeClass TunerThemeClass;
typedef struct _TunerThemePrivate TunerThemePrivate;
enum  {
	TUNER_THEME_0_PROPERTY,
	TUNER_THEME_NUM_PROPERTIES
};
static GParamSpec* tuner_theme_properties[TUNER_THEME_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

struct _TunerTheme {
	GtkWidget parent_instance;
	TunerThemePrivate * priv;
};

struct _TunerThemeClass {
	GtkWidgetClass parent_class;
};

static gpointer tuner_theme_parent_class = NULL;
static GOnce tuner_theme__instance;
static GOnce tuner_theme__instance = (GOnce) G_ONCE_INIT;

VALA_EXTERN GType tuner_theme_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (TunerTheme, g_object_unref)
VALA_EXTERN TunerTheme* tuner_theme_instance (void);
static TunerTheme* __lambda59_ (void);
VALA_EXTERN TunerTheme* tuner_theme_new (void);
VALA_EXTERN TunerTheme* tuner_theme_construct (GType object_type);
static gpointer ___lambda59__gthread_func (gpointer self);
VALA_EXTERN gboolean tuner_theme_is_theme_dark (TunerTheme* self);
static void tuner_theme_finalize (GObject * obj);
static GType tuner_theme_get_type_once (void);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

static TunerTheme*
__lambda59_ (void)
{
	TunerTheme* _tmp0_;
	TunerTheme* result = NULL;
	_tmp0_ = tuner_theme_new ();
	g_object_ref_sink (_tmp0_);
	result = _tmp0_;
	return result;
}

static gpointer
___lambda59__gthread_func (gpointer self)
{
	gpointer result;
	result = __lambda59_ ();
	return result;
}

TunerTheme*
tuner_theme_instance (void)
{
	gconstpointer _tmp0_;
	TunerTheme* result = NULL;
	_tmp0_ = g_once (&tuner_theme__instance, ___lambda59__gthread_func, NULL);
	result = (TunerTheme*) _tmp0_;
	return result;
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

gboolean
tuner_theme_is_theme_dark (TunerTheme* self)
{
	GtkSettings* settings = NULL;
	GtkSettings* _tmp0_;
	GtkSettings* _tmp1_;
	gchar* theme = NULL;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	gboolean _tmp4_ = FALSE;
	GtkSettings* _tmp5_;
	gboolean _tmp6_;
	gboolean _tmp7_;
	gboolean dark = FALSE;
	gboolean result = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = gtk_settings_get_default ();
	_tmp1_ = _g_object_ref0 (_tmp0_);
	settings = _tmp1_;
	_tmp2_ = g_getenv ("GTK_THEME");
	_tmp3_ = g_strdup (_tmp2_);
	theme = _tmp3_;
	_tmp5_ = settings;
	g_object_get (_tmp5_, "gtk-application-prefer-dark-theme", &_tmp6_, NULL);
	_tmp7_ = _tmp6_;
	if (_tmp7_) {
		_tmp4_ = TRUE;
	} else {
		gboolean _tmp8_ = FALSE;
		const gchar* _tmp9_;
		_tmp9_ = theme;
		if (_tmp9_ != NULL) {
			const gchar* _tmp10_;
			_tmp10_ = theme;
			_tmp8_ = g_str_has_suffix (_tmp10_, ":dark");
		} else {
			_tmp8_ = FALSE;
		}
		_tmp4_ = _tmp8_;
	}
	dark = _tmp4_;
	if (!dark) {
		GtkStyleContext* stylecontext = NULL;
		GtkStyleContext* _tmp11_;
		GtkStyleContext* _tmp12_;
		GdkRGBA rgba = {0};
		gboolean background_set = FALSE;
		GtkStyleContext* _tmp13_;
		GdkRGBA _tmp14_ = {0};
		gboolean _tmp15_;
		gboolean _tmp16_ = FALSE;
		_tmp11_ = gtk_widget_get_style_context ((GtkWidget*) self);
		_tmp12_ = _g_object_ref0 (_tmp11_);
		stylecontext = _tmp12_;
		_tmp13_ = stylecontext;
		_tmp15_ = gtk_style_context_lookup_color (_tmp13_, "theme_bg_color", &_tmp14_);
		rgba = _tmp14_;
		background_set = _tmp15_;
		if (background_set) {
			GdkRGBA _tmp17_;
			GdkRGBA _tmp18_;
			GdkRGBA _tmp19_;
			_tmp17_ = rgba;
			_tmp18_ = rgba;
			_tmp19_ = rgba;
			_tmp16_ = ((_tmp17_.red + _tmp18_.green) + _tmp19_.blue) < 1.0;
		} else {
			_tmp16_ = FALSE;
		}
		if (_tmp16_) {
			dark = TRUE;
		}
		_g_object_unref0 (stylecontext);
	}
	result = dark;
	_g_free0 (theme);
	_g_object_unref0 (settings);
	return result;
}

TunerTheme*
tuner_theme_construct (GType object_type)
{
	TunerTheme * self = NULL;
	self = (TunerTheme*) gtk_widget_new (object_type, NULL);
	return self;
}

TunerTheme*
tuner_theme_new (void)
{
	return tuner_theme_construct (TUNER_TYPE_THEME);
}

static void
tuner_theme_class_init (TunerThemeClass * klass,
                        gpointer klass_data)
{
	tuner_theme_parent_class = g_type_class_peek_parent (klass);
	G_OBJECT_CLASS (klass)->finalize = tuner_theme_finalize;
}

static void
tuner_theme_instance_init (TunerTheme * self,
                           gpointer klass)
{
}

static void
tuner_theme_finalize (GObject * obj)
{
	TunerTheme * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TUNER_TYPE_THEME, TunerTheme);
	G_OBJECT_CLASS (tuner_theme_parent_class)->finalize (obj);
}

static GType
tuner_theme_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (TunerThemeClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) tuner_theme_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (TunerTheme), 0, (GInstanceInitFunc) tuner_theme_instance_init, NULL };
	GType tuner_theme_type_id;
	tuner_theme_type_id = g_type_register_static (gtk_widget_get_type (), "TunerTheme", &g_define_type_info, 0);
	return tuner_theme_type_id;
}

GType
tuner_theme_get_type (void)
{
	static volatile gsize tuner_theme_type_id__volatile = 0;
	if (g_once_init_enter (&tuner_theme_type_id__volatile)) {
		GType tuner_theme_type_id;
		tuner_theme_type_id = tuner_theme_get_type_once ();
		g_once_init_leave (&tuner_theme_type_id__volatile, tuner_theme_type_id);
	}
	return tuner_theme_type_id__volatile;
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

