/* Window.c generated by valac 0.54.8, the Vala compiler
 * generated from Window.vala, do not modify */

/*
 * SPDX-License-Identifier: GPL-3.0-or-later
 * SPDX-FileCopyrightText: 2020-2022 Louis Brauer <louis@brauer.family>
 */

#include <gtk/gtk.h>
#include <glib-object.h>
#include <gio/gio.h>
#include <granite.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gst/player/player.h>
#include <gdk/gdk.h>
#include <float.h>
#include <math.h>
#include <glib/gi18n-lib.h>
#include <gee.h>
#include <pango/pango.h>

#define TUNER_WINDOW_WindowName "Tuner"
#define TUNER_WINDOW_ACTION_PREFIX "win."
#define TUNER_WINDOW_ACTION_PAUSE "action_pause"
#define TUNER_WINDOW_ACTION_QUIT "action_quit"
#define TUNER_WINDOW_ACTION_HIDE "action_hide"
#define TUNER_WINDOW_ACTION_ABOUT "action_about"
#define TUNER_WINDOW_ACTION_DISABLE_TRACKING "action_disable_tracking"
#define TUNER_WINDOW_ACTION_ENABLE_AUTOPLAY "action_enable_autoplay"
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define TUNER_TYPE_WINDOW (tuner_window_get_type ())
#define TUNER_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TUNER_TYPE_WINDOW, TunerWindow))
#define TUNER_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TUNER_TYPE_WINDOW, TunerWindowClass))
#define TUNER_IS_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TUNER_TYPE_WINDOW))
#define TUNER_IS_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TUNER_TYPE_WINDOW))
#define TUNER_WINDOW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TUNER_TYPE_WINDOW, TunerWindowClass))

typedef struct _TunerWindow TunerWindow;
typedef struct _TunerWindowClass TunerWindowClass;
typedef struct _TunerWindowPrivate TunerWindowPrivate;

#define TUNER_TYPE_PLAYER_CONTROLLER (tuner_player_controller_get_type ())
#define TUNER_PLAYER_CONTROLLER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TUNER_TYPE_PLAYER_CONTROLLER, TunerPlayerController))
#define TUNER_PLAYER_CONTROLLER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TUNER_TYPE_PLAYER_CONTROLLER, TunerPlayerControllerClass))
#define TUNER_IS_PLAYER_CONTROLLER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TUNER_TYPE_PLAYER_CONTROLLER))
#define TUNER_IS_PLAYER_CONTROLLER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TUNER_TYPE_PLAYER_CONTROLLER))
#define TUNER_PLAYER_CONTROLLER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TUNER_TYPE_PLAYER_CONTROLLER, TunerPlayerControllerClass))

typedef struct _TunerPlayerController TunerPlayerController;
typedef struct _TunerPlayerControllerClass TunerPlayerControllerClass;

#define TUNER_TYPE_DIRECTORY_CONTROLLER (tuner_directory_controller_get_type ())
#define TUNER_DIRECTORY_CONTROLLER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TUNER_TYPE_DIRECTORY_CONTROLLER, TunerDirectoryController))
#define TUNER_DIRECTORY_CONTROLLER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TUNER_TYPE_DIRECTORY_CONTROLLER, TunerDirectoryControllerClass))
#define TUNER_IS_DIRECTORY_CONTROLLER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TUNER_TYPE_DIRECTORY_CONTROLLER))
#define TUNER_IS_DIRECTORY_CONTROLLER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TUNER_TYPE_DIRECTORY_CONTROLLER))
#define TUNER_DIRECTORY_CONTROLLER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TUNER_TYPE_DIRECTORY_CONTROLLER, TunerDirectoryControllerClass))

typedef struct _TunerDirectoryController TunerDirectoryController;
typedef struct _TunerDirectoryControllerClass TunerDirectoryControllerClass;

#define TUNER_TYPE_HEADER_BAR (tuner_header_bar_get_type ())
#define TUNER_HEADER_BAR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TUNER_TYPE_HEADER_BAR, TunerHeaderBar))
#define TUNER_HEADER_BAR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TUNER_TYPE_HEADER_BAR, TunerHeaderBarClass))
#define TUNER_IS_HEADER_BAR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TUNER_TYPE_HEADER_BAR))
#define TUNER_IS_HEADER_BAR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TUNER_TYPE_HEADER_BAR))
#define TUNER_HEADER_BAR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TUNER_TYPE_HEADER_BAR, TunerHeaderBarClass))

typedef struct _TunerHeaderBar TunerHeaderBar;
typedef struct _TunerHeaderBarClass TunerHeaderBarClass;
enum  {
	TUNER_WINDOW_0_PROPERTY,
	TUNER_WINDOW_SETTINGS_PROPERTY,
	TUNER_WINDOW_STACK_PROPERTY,
	TUNER_WINDOW_PLAYER_PROPERTY,
	TUNER_WINDOW_NUM_PROPERTIES
};
static GParamSpec* tuner_window_properties[TUNER_WINDOW_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

#define TUNER_TYPE_APPLICATION (tuner_application_get_type ())
#define TUNER_APPLICATION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TUNER_TYPE_APPLICATION, TunerApplication))
#define TUNER_APPLICATION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TUNER_TYPE_APPLICATION, TunerApplicationClass))
#define TUNER_IS_APPLICATION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TUNER_TYPE_APPLICATION))
#define TUNER_IS_APPLICATION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TUNER_TYPE_APPLICATION))
#define TUNER_APPLICATION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TUNER_TYPE_APPLICATION, TunerApplicationClass))

typedef struct _TunerApplication TunerApplication;
typedef struct _TunerApplicationClass TunerApplicationClass;

#define TUNER_TYPE_CONTENT_BOX (tuner_content_box_get_type ())
#define TUNER_CONTENT_BOX(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TUNER_TYPE_CONTENT_BOX, TunerContentBox))
#define TUNER_CONTENT_BOX_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TUNER_TYPE_CONTENT_BOX, TunerContentBoxClass))
#define TUNER_IS_CONTENT_BOX(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TUNER_TYPE_CONTENT_BOX))
#define TUNER_IS_CONTENT_BOX_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TUNER_TYPE_CONTENT_BOX))
#define TUNER_CONTENT_BOX_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TUNER_TYPE_CONTENT_BOX, TunerContentBoxClass))

typedef struct _TunerContentBox TunerContentBox;
typedef struct _TunerContentBoxClass TunerContentBoxClass;
typedef struct _Block10Data Block10Data;

#define TUNER_TYPE_ABSTRACT_CONTENT_LIST (tuner_abstract_content_list_get_type ())
#define TUNER_ABSTRACT_CONTENT_LIST(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TUNER_TYPE_ABSTRACT_CONTENT_LIST, TunerAbstractContentList))
#define TUNER_ABSTRACT_CONTENT_LIST_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TUNER_TYPE_ABSTRACT_CONTENT_LIST, TunerAbstractContentListClass))
#define TUNER_IS_ABSTRACT_CONTENT_LIST(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TUNER_TYPE_ABSTRACT_CONTENT_LIST))
#define TUNER_IS_ABSTRACT_CONTENT_LIST_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TUNER_TYPE_ABSTRACT_CONTENT_LIST))
#define TUNER_ABSTRACT_CONTENT_LIST_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TUNER_TYPE_ABSTRACT_CONTENT_LIST, TunerAbstractContentListClass))

typedef struct _TunerAbstractContentList TunerAbstractContentList;
typedef struct _TunerAbstractContentListClass TunerAbstractContentListClass;
#define _g_free0(var) (var = (g_free (var), NULL))

#define TUNER_TYPE_ABOUT_DIALOG (tuner_about_dialog_get_type ())
#define TUNER_ABOUT_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TUNER_TYPE_ABOUT_DIALOG, TunerAboutDialog))
#define TUNER_ABOUT_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TUNER_TYPE_ABOUT_DIALOG, TunerAboutDialogClass))
#define TUNER_IS_ABOUT_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TUNER_TYPE_ABOUT_DIALOG))
#define TUNER_IS_ABOUT_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TUNER_TYPE_ABOUT_DIALOG))
#define TUNER_ABOUT_DIALOG_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TUNER_TYPE_ABOUT_DIALOG, TunerAboutDialogClass))

typedef struct _TunerAboutDialog TunerAboutDialog;
typedef struct _TunerAboutDialogClass TunerAboutDialogClass;

#define TUNER_MODEL_TYPE_STATION (tuner_model_station_get_type ())
#define TUNER_MODEL_STATION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TUNER_MODEL_TYPE_STATION, TunerModelStation))
#define TUNER_MODEL_STATION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TUNER_MODEL_TYPE_STATION, TunerModelStationClass))
#define TUNER_MODEL_IS_STATION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TUNER_MODEL_TYPE_STATION))
#define TUNER_MODEL_IS_STATION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TUNER_MODEL_TYPE_STATION))
#define TUNER_MODEL_STATION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TUNER_MODEL_TYPE_STATION, TunerModelStationClass))

typedef struct _TunerModelStation TunerModelStation;
typedef struct _TunerModelStationClass TunerModelStationClass;
#define _g_variant_unref0(var) ((var == NULL) ? NULL : (var = (g_variant_unref (var), NULL)))
typedef enum  {
	TUNER_HEADER_BAR_PLAY_STATE_PAUSE_ACTIVE,
	TUNER_HEADER_BAR_PLAY_STATE_PAUSE_INACTIVE,
	TUNER_HEADER_BAR_PLAY_STATE_PLAY_ACTIVE,
	TUNER_HEADER_BAR_PLAY_STATE_PLAY_INACTIVE
} TunerHeaderBarPlayState;

#define TUNER_HEADER_BAR_TYPE_PLAY_STATE (tuner_header_bar_play_state_get_type ())

#define TUNER_TYPE_STATION_SOURCE (tuner_station_source_get_type ())
#define TUNER_STATION_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TUNER_TYPE_STATION_SOURCE, TunerStationSource))
#define TUNER_STATION_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TUNER_TYPE_STATION_SOURCE, TunerStationSourceClass))
#define TUNER_IS_STATION_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TUNER_TYPE_STATION_SOURCE))
#define TUNER_IS_STATION_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TUNER_TYPE_STATION_SOURCE))
#define TUNER_STATION_SOURCE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TUNER_TYPE_STATION_SOURCE, TunerStationSourceClass))

typedef struct _TunerStationSource TunerStationSource;
typedef struct _TunerStationSourceClass TunerStationSourceClass;

#define TUNER_TYPE_STATION_LIST (tuner_station_list_get_type ())
#define TUNER_STATION_LIST(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TUNER_TYPE_STATION_LIST, TunerStationList))
#define TUNER_STATION_LIST_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TUNER_TYPE_STATION_LIST, TunerStationListClass))
#define TUNER_IS_STATION_LIST(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TUNER_TYPE_STATION_LIST))
#define TUNER_IS_STATION_LIST_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TUNER_TYPE_STATION_LIST))
#define TUNER_STATION_LIST_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TUNER_TYPE_STATION_LIST, TunerStationListClass))

typedef struct _TunerStationList TunerStationList;
typedef struct _TunerStationListClass TunerStationListClass;
typedef struct _Block11Data Block11Data;
typedef struct _TunerHeaderBarPrivate TunerHeaderBarPrivate;

#define TUNER_MODEL_TYPE_STATION_STORE (tuner_model_station_store_get_type ())
#define TUNER_MODEL_STATION_STORE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TUNER_MODEL_TYPE_STATION_STORE, TunerModelStationStore))
#define TUNER_MODEL_STATION_STORE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TUNER_MODEL_TYPE_STATION_STORE, TunerModelStationStoreClass))
#define TUNER_MODEL_IS_STATION_STORE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TUNER_MODEL_TYPE_STATION_STORE))
#define TUNER_MODEL_IS_STATION_STORE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TUNER_MODEL_TYPE_STATION_STORE))
#define TUNER_MODEL_STATION_STORE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TUNER_MODEL_TYPE_STATION_STORE, TunerModelStationStoreClass))

typedef struct _TunerModelStationStore TunerModelStationStore;
typedef struct _TunerModelStationStoreClass TunerModelStationStoreClass;
typedef struct _Block12Data Block12Data;
typedef struct _TunerContentBoxPrivate TunerContentBoxPrivate;

#define TUNER_TYPE_HEADER_LABEL (tuner_header_label_get_type ())
#define TUNER_HEADER_LABEL(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TUNER_TYPE_HEADER_LABEL, TunerHeaderLabel))
#define TUNER_HEADER_LABEL_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TUNER_TYPE_HEADER_LABEL, TunerHeaderLabelClass))
#define TUNER_IS_HEADER_LABEL(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TUNER_TYPE_HEADER_LABEL))
#define TUNER_IS_HEADER_LABEL_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TUNER_TYPE_HEADER_LABEL))
#define TUNER_HEADER_LABEL_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TUNER_TYPE_HEADER_LABEL, TunerHeaderLabelClass))

typedef struct _TunerHeaderLabel TunerHeaderLabel;
typedef struct _TunerHeaderLabelClass TunerHeaderLabelClass;

#define TUNER_MODEL_TYPE_GENRE (tuner_model_genre_get_type ())
#define TUNER_MODEL_GENRE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TUNER_MODEL_TYPE_GENRE, TunerModelGenre))
#define TUNER_MODEL_GENRE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TUNER_MODEL_TYPE_GENRE, TunerModelGenreClass))
#define TUNER_MODEL_IS_GENRE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TUNER_MODEL_TYPE_GENRE))
#define TUNER_MODEL_IS_GENRE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TUNER_MODEL_TYPE_GENRE))
#define TUNER_MODEL_GENRE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TUNER_MODEL_TYPE_GENRE, TunerModelGenreClass))

typedef struct _TunerModelGenre TunerModelGenre;
typedef struct _TunerModelGenreClass TunerModelGenreClass;
typedef struct _Block13Data Block13Data;
typedef struct _TunerModelGenrePrivate TunerModelGenrePrivate;
#define _tuner_model_genre_unref0(var) ((var == NULL) ? NULL : (var = (tuner_model_genre_unref (var), NULL)))
enum  {
	TUNER_WINDOW_REFRESH_FAVOURITES_SIGNAL,
	TUNER_WINDOW_NUM_SIGNALS
};
static guint tuner_window_signals[TUNER_WINDOW_NUM_SIGNALS] = {0};

struct _TunerWindow {
	GtkApplicationWindow parent_instance;
	TunerWindowPrivate * priv;
};

struct _TunerWindowClass {
	GtkApplicationWindowClass parent_class;
};

struct _TunerWindowPrivate {
	GSettings* _settings;
	GtkStack* _stack;
	TunerPlayerController* _player;
	TunerDirectoryController* _directory;
	TunerHeaderBar* headerbar;
	GraniteWidgetsSourceList* source_list;
};

struct _Block10Data {
	int _ref_count_;
	TunerWindow* self;
	TunerContentBox* c;
	GraniteWidgetsSourceListItem* item;
	GraniteWidgetsSourceList* source_list;
};

struct _Block11Data {
	int _ref_count_;
	TunerWindow* self;
	GtkStack* stack;
	GraniteWidgetsSourceListExpandableItem* selections_category;
	TunerContentBox* c1;
	TunerStationSource* s1;
	TunerContentBox* c2;
	TunerStationSource* s2;
	TunerContentBox* c3;
	TunerStationSource* s3;
	GraniteWidgetsSourceListItem* item4;
	TunerContentBox* c_country;
	TunerStationList* c_slist;
	TunerContentBox* c4;
	TunerContentBox* c5;
};

struct _TunerHeaderBar {
	GtkHeaderBar parent_instance;
	TunerHeaderBarPrivate * priv;
	GtkVolumeButton* volume_button;
};

struct _TunerHeaderBarClass {
	GtkHeaderBarClass parent_class;
};

typedef enum  {
	SOURCE_ERROR_UNAVAILABLE
} SourceError;
#define SOURCE_ERROR source_error_quark ()
struct _Block12Data {
	int _ref_count_;
	Block11Data * _data11_;
	TunerStationSource* s_country;
};

struct _TunerContentBox {
	GtkBox parent_instance;
	TunerContentBoxPrivate * priv;
	TunerHeaderLabel* header_label;
};

struct _TunerContentBoxClass {
	GtkBoxClass parent_class;
};

struct _Block13Data {
	int _ref_count_;
	Block11Data * _data11_;
	TunerContentBox* cb;
	TunerStationSource* ds;
};

struct _TunerModelGenre {
	GTypeInstance parent_instance;
	volatile int ref_count;
	TunerModelGenrePrivate * priv;
	gchar* name;
	gchar** tags;
	gint tags_length1;
};

struct _TunerModelGenreClass {
	GTypeClass parent_class;
	void (*finalize) (TunerModelGenre *self);
};

static gint TunerWindow_private_offset;
static gpointer tuner_window_parent_class = NULL;

VALA_EXTERN GType tuner_window_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (TunerWindow, g_object_unref)
VALA_EXTERN GType tuner_player_controller_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (TunerPlayerController, g_object_unref)
VALA_EXTERN GType tuner_directory_controller_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (TunerDirectoryController, g_object_unref)
VALA_EXTERN GType tuner_header_bar_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (TunerHeaderBar, g_object_unref)
VALA_EXTERN void tuner_window_on_toggle_playback (TunerWindow* self);
static void _tuner_window_on_toggle_playback_gsimple_action_activate_callback (GSimpleAction* action,
                                                                        GVariant* parameter,
                                                                        gpointer self);
static void tuner_window_on_action_quit (TunerWindow* self);
static void _tuner_window_on_action_quit_gsimple_action_activate_callback (GSimpleAction* action,
                                                                    GVariant* parameter,
                                                                    gpointer self);
static void tuner_window_on_action_about (TunerWindow* self);
static void _tuner_window_on_action_about_gsimple_action_activate_callback (GSimpleAction* action,
                                                                     GVariant* parameter,
                                                                     gpointer self);
VALA_EXTERN void tuner_window_on_action_disable_tracking (TunerWindow* self,
                                              GSimpleAction* action,
                                              GVariant* parameter);
static void _tuner_window_on_action_disable_tracking_gsimple_action_activate_callback (GSimpleAction* action,
                                                                                GVariant* parameter,
                                                                                gpointer self);
VALA_EXTERN void tuner_window_on_action_enable_autoplay (TunerWindow* self,
                                             GSimpleAction* action,
                                             GVariant* parameter);
static void _tuner_window_on_action_enable_autoplay_gsimple_action_activate_callback (GSimpleAction* action,
                                                                               GVariant* parameter,
                                                                               gpointer self);
VALA_EXTERN GType tuner_application_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (TunerApplication, g_object_unref)
VALA_EXTERN TunerWindow* tuner_window_new (TunerApplication* app,
                               TunerPlayerController* player);
VALA_EXTERN TunerWindow* tuner_window_construct (GType object_type,
                                     TunerApplication* app,
                                     TunerPlayerController* player);
VALA_EXTERN TunerApplication* tuner_application_get_instance (void);
VALA_EXTERN GSettings* tuner_application_get_settings (TunerApplication* self);
VALA_EXTERN GType tuner_content_box_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (TunerContentBox, g_object_unref)
static TunerContentBox* tuner_window_create_content_box (TunerWindow* self,
                                                  const gchar* name,
                                                  GraniteWidgetsSourceListItem* item,
                                                  const gchar* full_title,
                                                  const gchar* action_icon_name,
                                                  const gchar* action_tooltip_text,
                                                  GtkStack* stack,
                                                  GraniteWidgetsSourceList* source_list,
                                                  gboolean enable_count);
static Block10Data* block10_data_ref (Block10Data* _data10_);
static void block10_data_unref (void * _userdata_);
VALA_EXTERN TunerContentBox* tuner_content_box_new (GtkImage* icon,
                                        const gchar* title,
                                        const gchar* subtitle,
                                        const gchar* action_icon_name,
                                        const gchar* action_tooltip_text);
VALA_EXTERN TunerContentBox* tuner_content_box_construct (GType object_type,
                                              GtkImage* icon,
                                              const gchar* title,
                                              const gchar* subtitle,
                                              const gchar* action_icon_name,
                                              const gchar* action_tooltip_text);
static void __lambda20_ (Block10Data* _data10_);
static void ___lambda20__gtk_widget_map (GtkWidget* _sender,
                                  gpointer self);
static void ___lambda21_ (Block10Data* _data10_);
VALA_EXTERN GType tuner_abstract_content_list_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (TunerAbstractContentList, g_object_unref)
VALA_EXTERN TunerAbstractContentList* tuner_content_box_get_content (TunerContentBox* self);
VALA_EXTERN guint tuner_abstract_content_list_get_item_count (TunerAbstractContentList* self);
static void ____lambda21__tuner_content_box_content_changed (TunerContentBox* _sender,
                                                      gpointer self);
static void tuner_window_adjust_theme (void);
VALA_EXTERN GType tuner_about_dialog_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (TunerAboutDialog, g_object_unref)
VALA_EXTERN TunerAboutDialog* tuner_about_dialog_new (GtkWindow* window);
VALA_EXTERN TunerAboutDialog* tuner_about_dialog_construct (GType object_type,
                                                GtkWindow* window);
VALA_EXTERN GType tuner_model_station_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (TunerModelStation, g_object_unref)
VALA_EXTERN void tuner_window_handle_station_click (TunerWindow* self,
                                        TunerModelStation* station);
VALA_EXTERN const gchar* tuner_model_station_get_title (TunerModelStation* self);
VALA_EXTERN void tuner_directory_controller_count_station_click (TunerDirectoryController* self,
                                                     TunerModelStation* station);
VALA_EXTERN TunerPlayerController* tuner_window_get_player (TunerWindow* self);
VALA_EXTERN void tuner_player_controller_set_station (TunerPlayerController* self,
                                          TunerModelStation* value);
VALA_EXTERN const gchar* tuner_model_station_get_id (TunerModelStation* self);
VALA_EXTERN GSettings* tuner_window_get_settings (TunerWindow* self);
VALA_EXTERN void tuner_window_handle_favourites_changed (TunerWindow* self);
VALA_EXTERN void tuner_player_controller_play_pause (TunerPlayerController* self);
static GVariant* _variant_new6 (gboolean value);
static GVariant* _variant_new7 (gboolean value);
VALA_EXTERN void tuner_window_handleplayer_state_changed (TunerWindow* self,
                                              GstPlayerState state);
static gboolean ___lambda22_ (TunerWindow* self);
VALA_EXTERN GType tuner_header_bar_play_state_get_type (void) G_GNUC_CONST ;
VALA_EXTERN void tuner_header_bar_set_playstate (TunerHeaderBar* self,
                                     TunerHeaderBarPlayState state);
static gboolean ____lambda22__gsource_func (gpointer self);
static gboolean ___lambda23_ (TunerWindow* self);
VALA_EXTERN gboolean tuner_player_controller_can_play (TunerPlayerController* self);
static gboolean ____lambda23__gsource_func (gpointer self);
static gboolean ___lambda24_ (TunerWindow* self);
static gboolean ____lambda24__gsource_func (gpointer self);
static gboolean ___lambda25_ (TunerWindow* self);
static gboolean ____lambda25__gsource_func (gpointer self);
VALA_EXTERN gboolean tuner_window_before_destroy (TunerWindow* self);
VALA_EXTERN GstPlayerState* tuner_player_controller_get_current_state (TunerPlayerController* self);
static gboolean _gst_player_state_equal (const GstPlayerState * s1,
                                  const GstPlayerState * s2);
static void tuner_window_set_settings (TunerWindow* self,
                                GSettings* value);
VALA_EXTERN GtkStack* tuner_window_get_stack (TunerWindow* self);
VALA_EXTERN void tuner_window_set_stack (TunerWindow* self,
                             GtkStack* value);
static void tuner_window_set_player (TunerWindow* self,
                              TunerPlayerController* value);
static GObject * tuner_window_constructor (GType type,
                                    guint n_construct_properties,
                                    GObjectConstructParam * construct_properties);
VALA_EXTERN GType tuner_station_source_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (TunerStationSource, g_object_unref)
VALA_EXTERN GType tuner_station_list_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (TunerStationList, g_object_unref)
static Block11Data* block11_data_ref (Block11Data* _data11_);
static void block11_data_unref (void * _userdata_);
VALA_EXTERN TunerHeaderBar* tuner_header_bar_new (void);
VALA_EXTERN TunerHeaderBar* tuner_header_bar_construct (GType object_type);
static void _tuner_window_handleplayer_state_changed_tuner_player_controller_state_changed (TunerPlayerController* _sender,
                                                                                     GstPlayerState state,
                                                                                     gpointer self);
VALA_EXTERN void tuner_header_bar_update_from_station (TunerHeaderBar* self,
                                           TunerModelStation* station);
static void _tuner_header_bar_update_from_station_tuner_player_controller_station_changed (TunerPlayerController* _sender,
                                                                                    TunerModelStation* station,
                                                                                    gpointer self);
static void _tuner_window___lambda26_ (TunerWindow* self,
                                const gchar* title);
VALA_EXTERN void tuner_header_bar_set_subtitle (TunerHeaderBar* self,
                                    const gchar* value);
static void __tuner_window___lambda26__tuner_player_controller_title_changed (TunerPlayerController* _sender,
                                                                       const gchar* title,
                                                                       gpointer self);
static void _tuner_window___lambda27_ (TunerWindow* self,
                                gdouble volume);
static void __tuner_window___lambda27__tuner_player_controller_volume_changed (TunerPlayerController* _sender,
                                                                        gdouble volume,
                                                                        gpointer self);
static void _tuner_window___lambda28_ (TunerWindow* self,
                                gdouble value);
VALA_EXTERN void tuner_player_controller_set_volume (TunerPlayerController* self,
                                         gdouble value);
static void __tuner_window___lambda28__gtk_scale_button_value_changed (GtkScaleButton* _sender,
                                                                gdouble value,
                                                                gpointer self);
static void _tuner_window___lambda29_ (TunerWindow* self,
                                const gchar* key);
static void __tuner_window___lambda29__g_settings_changed (GSettings* _sender,
                                                    const gchar* key,
                                                    gpointer self);
static void _tuner_window___lambda30_ (TunerWindow* self,
                                GParamSpec* key);
static void __tuner_window___lambda30__g_object_notify (GObject* _sender,
                                                 GParamSpec* pspec,
                                                 gpointer self);
static GVariant* _variant_new8 (gboolean value);
static GVariant* _variant_new9 (gboolean value);
static gboolean _tuner_window___lambda31_ (TunerWindow* self,
                                    GdkEventAny* e);
static gboolean __tuner_window___lambda31__gtk_widget_delete_event (GtkWidget* _sender,
                                                             GdkEventAny* event,
                                                             gpointer self);
VALA_EXTERN const gchar* tuner_application_get_data_dir (TunerApplication* self);
VALA_EXTERN GType tuner_model_station_store_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (TunerModelStationStore, g_object_unref)
VALA_EXTERN TunerModelStationStore* tuner_model_station_store_new (const gchar* data_path);
VALA_EXTERN TunerModelStationStore* tuner_model_station_store_construct (GType object_type,
                                                             const gchar* data_path);
VALA_EXTERN TunerDirectoryController* tuner_directory_controller_new (TunerModelStationStore* store);
VALA_EXTERN TunerDirectoryController* tuner_directory_controller_construct (GType object_type,
                                                                TunerModelStationStore* store);
VALA_EXTERN TunerStationSource* tuner_directory_controller_load_random_stations (TunerDirectoryController* self,
                                                                     guint limit);
static void _tuner_window___lambda36_ (Block11Data* _data11_);
VALA_EXTERN GQuark source_error_quark (void);
VALA_EXTERN GeeArrayList* tuner_station_source_next (TunerStationSource* self,
                                         GError** error);
VALA_EXTERN TunerStationList* tuner_station_list_new_with_stations (GeeArrayList* stations);
VALA_EXTERN TunerStationList* tuner_station_list_construct_with_stations (GType object_type,
                                                              GeeArrayList* stations);
static void _tuner_window_handle_station_click_tuner_station_list_selection_changed (TunerStationList* _sender,
                                                                              TunerModelStation* station,
                                                                              gpointer self);
static void _tuner_window_handle_favourites_changed_tuner_station_list_favourites_changed (TunerStationList* _sender,
                                                                                    gpointer self);
VALA_EXTERN void tuner_content_box_set_content (TunerContentBox* self,
                                    TunerAbstractContentList* value);
VALA_EXTERN void tuner_content_box_show_alert (TunerContentBox* self);
static void __tuner_window___lambda36__gtk_widget_realize (GtkWidget* _sender,
                                                    gpointer self);
static void _tuner_window___lambda43_ (Block11Data* _data11_);
static void __tuner_window___lambda43__tuner_content_box_action_activated (TunerContentBox* _sender,
                                                                    gpointer self);
VALA_EXTERN TunerStationSource* tuner_directory_controller_load_trending_stations (TunerDirectoryController* self,
                                                                       guint limit);
static void _tuner_window___lambda44_ (Block11Data* _data11_);
static void __tuner_window___lambda44__gtk_widget_realize (GtkWidget* _sender,
                                                    gpointer self);
VALA_EXTERN TunerStationSource* tuner_directory_controller_load_popular_stations (TunerDirectoryController* self,
                                                                      guint limit);
static void _tuner_window___lambda45_ (Block11Data* _data11_);
static void __tuner_window___lambda45__gtk_widget_realize (GtkWidget* _sender,
                                                    gpointer self);
VALA_EXTERN TunerStationList* tuner_station_list_new (void);
VALA_EXTERN TunerStationList* tuner_station_list_construct (GType object_type);
VALA_EXTERN void tuner_location_discovery_country_code (GAsyncReadyCallback _callback_,
                                            gpointer _user_data_);
VALA_EXTERN gchar* tuner_location_discovery_country_code_finish (GAsyncResult* _res_,
                                                     GError** error);
static void _tuner_window___lambda46_ (Block11Data* _data11_,
                                GObject* obj,
                                GAsyncResult* res);
static Block12Data* block12_data_ref (Block12Data* _data12_);
static void block12_data_unref (void * _userdata_);
VALA_EXTERN gchar* tuner_model_countries_get_by_code (const gchar* code,
                                          const gchar* fallback);
VALA_EXTERN GType tuner_header_label_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (TunerHeaderLabel, g_object_unref)
VALA_EXTERN TunerStationSource* tuner_directory_controller_load_by_country (TunerDirectoryController* self,
                                                                guint limit,
                                                                const gchar* countrycode);
static void __lambda47_ (Block12Data* _data12_);
VALA_EXTERN void tuner_station_list_set_stations (TunerStationList* self,
                                      GeeArrayList* value);
static void ___lambda47__gtk_widget_realize (GtkWidget* _sender,
                                      gpointer self);
static void __tuner_window___lambda46__gasync_ready_callback (GObject* source_object,
                                                       GAsyncResult* res,
                                                       gpointer self);
VALA_EXTERN GeeArrayList* tuner_directory_controller_get_stored (TunerDirectoryController* self);
VALA_EXTERN gpointer tuner_model_genre_ref (gpointer instance);
VALA_EXTERN void tuner_model_genre_unref (gpointer instance);
VALA_EXTERN GParamSpec* tuner_model_param_spec_genre (const gchar* name,
                                          const gchar* nick,
                                          const gchar* blurb,
                                          GType object_type,
                                          GParamFlags flags);
VALA_EXTERN void tuner_model_value_set_genre (GValue* value,
                                  gpointer v_object);
VALA_EXTERN void tuner_model_value_take_genre (GValue* value,
                                   gpointer v_object);
VALA_EXTERN gpointer tuner_model_value_get_genre (const GValue* value);
VALA_EXTERN GType tuner_model_genre_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (TunerModelGenre, tuner_model_genre_unref)
VALA_EXTERN TunerModelGenre** tuner_model_genres (gint* result_length1);
static Block13Data* block13_data_ref (Block13Data* _data13_);
static void block13_data_unref (void * _userdata_);
static gchar** _vala_array_dup8 (gchar** self,
                          gssize length);
VALA_EXTERN TunerStationSource* tuner_directory_controller_load_by_tags (TunerDirectoryController* self,
                                                             GeeArrayList* utags);
static void _tuner_window_____lambda48_ (Block13Data* _data13_);
static void __tuner_window_____lambda48__gtk_widget_realize (GtkWidget* _sender,
                                                      gpointer self);
static void _tuner_window___lambda49_ (TunerWindow* self,
                                gboolean starred);
VALA_EXTERN TunerModelStation* tuner_player_controller_get_station (TunerPlayerController* self);
VALA_EXTERN void tuner_model_station_toggle_starred (TunerModelStation* self);
static void __tuner_window___lambda49__tuner_header_bar_star_clicked (TunerHeaderBar* _sender,
                                                               gboolean starred,
                                                               gpointer self);
static void _tuner_window___lambda50_ (Block11Data* _data11_);
static void __tuner_window___lambda50__tuner_window_refresh_favourites (TunerWindow* _sender,
                                                                 gpointer self);
static void _tuner_window___lambda51_ (Block11Data* _data11_,
                                GraniteWidgetsSourceListItem* item);
static void __tuner_window___lambda51__granite_widgets_source_list_item_selected (GraniteWidgetsSourceList* _sender,
                                                                           GraniteWidgetsSourceListItem* item,
                                                                           gpointer self);
static void _tuner_window___lambda52_ (Block11Data* _data11_,
                                const gchar* text);
VALA_EXTERN TunerStationSource* tuner_directory_controller_load_search_stations (TunerDirectoryController* self,
                                                                     gchar* utext,
                                                                     guint limit);
VALA_EXTERN void tuner_content_box_show_nothing_found (TunerContentBox* self);
static void __tuner_window___lambda52__tuner_header_bar_searched_for (TunerHeaderBar* _sender,
                                                               const gchar* text,
                                                               gpointer self);
static void _tuner_window___lambda53_ (Block11Data* _data11_);
static void __tuner_window___lambda53__tuner_header_bar_search_focused (TunerHeaderBar* _sender,
                                                                 gpointer self);
VALA_EXTERN TunerStationSource* tuner_directory_controller_load_station_uuid (TunerDirectoryController* self,
                                                                  const gchar* uuid);
static void tuner_window_finalize (GObject * obj);
static GType tuner_window_get_type_once (void);
static void _vala_tuner_window_get_property (GObject * object,
                                      guint property_id,
                                      GValue * value,
                                      GParamSpec * pspec);
static void _vala_tuner_window_set_property (GObject * object,
                                      guint property_id,
                                      const GValue * value,
                                      GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

static const GActionEntry TUNER_WINDOW_ACTION_ENTRIES[5] = {{TUNER_WINDOW_ACTION_PAUSE, _tuner_window_on_toggle_playback_gsimple_action_activate_callback}, {TUNER_WINDOW_ACTION_QUIT, _tuner_window_on_action_quit_gsimple_action_activate_callback}, {TUNER_WINDOW_ACTION_ABOUT, _tuner_window_on_action_about_gsimple_action_activate_callback}, {TUNER_WINDOW_ACTION_DISABLE_TRACKING, _tuner_window_on_action_disable_tracking_gsimple_action_activate_callback, NULL, "false"}, {TUNER_WINDOW_ACTION_ENABLE_AUTOPLAY, _tuner_window_on_action_enable_autoplay_gsimple_action_activate_callback, NULL, "false"}};

static inline gpointer
tuner_window_get_instance_private (TunerWindow* self)
{
	return G_STRUCT_MEMBER_P (self, TunerWindow_private_offset);
}

static void
_tuner_window_on_toggle_playback_gsimple_action_activate_callback (GSimpleAction* action,
                                                                   GVariant* parameter,
                                                                   gpointer self)
{
	tuner_window_on_toggle_playback ((TunerWindow*) self);
}

static void
_tuner_window_on_action_quit_gsimple_action_activate_callback (GSimpleAction* action,
                                                               GVariant* parameter,
                                                               gpointer self)
{
	tuner_window_on_action_quit ((TunerWindow*) self);
}

static void
_tuner_window_on_action_about_gsimple_action_activate_callback (GSimpleAction* action,
                                                                GVariant* parameter,
                                                                gpointer self)
{
	tuner_window_on_action_about ((TunerWindow*) self);
}

static void
_tuner_window_on_action_disable_tracking_gsimple_action_activate_callback (GSimpleAction* action,
                                                                           GVariant* parameter,
                                                                           gpointer self)
{
	tuner_window_on_action_disable_tracking ((TunerWindow*) self, action, parameter);
}

static void
_tuner_window_on_action_enable_autoplay_gsimple_action_activate_callback (GSimpleAction* action,
                                                                          GVariant* parameter,
                                                                          gpointer self)
{
	tuner_window_on_action_enable_autoplay ((TunerWindow*) self, action, parameter);
}

TunerWindow*
tuner_window_construct (GType object_type,
                        TunerApplication* app,
                        TunerPlayerController* player)
{
	TunerWindow * self = NULL;
	TunerApplication* _tmp0_;
	TunerApplication* _tmp1_;
	GSettings* _tmp2_;
	GSettings* _tmp3_;
	GtkApplication* _tmp4_;
	GtkApplication* _tmp5_;
	gchar* _tmp6_;
	gchar** _tmp7_;
	gchar** _tmp8_;
	gint _tmp8__length1;
	GtkApplication* _tmp9_;
	GtkApplication* _tmp10_;
	gchar* _tmp11_;
	gchar** _tmp12_;
	gchar** _tmp13_;
	gint _tmp13__length1;
	GtkApplication* _tmp14_;
	GtkApplication* _tmp15_;
	gchar* _tmp16_;
	gchar** _tmp17_;
	gchar** _tmp18_;
	gint _tmp18__length1;
	g_return_val_if_fail (app != NULL, NULL);
	g_return_val_if_fail (player != NULL, NULL);
	_tmp0_ = tuner_application_get_instance ();
	_tmp1_ = _tmp0_;
	_tmp2_ = tuner_application_get_settings (_tmp1_);
	_tmp3_ = _tmp2_;
	self = (TunerWindow*) g_object_new (object_type, "application", app, "player", player, "settings", _tmp3_, NULL);
	_tmp4_ = gtk_window_get_application ((GtkWindow*) self);
	_tmp5_ = _tmp4_;
	_tmp6_ = g_strdup ("<Control>5");
	_tmp7_ = g_new0 (gchar*, 1 + 1);
	_tmp7_[0] = _tmp6_;
	_tmp8_ = _tmp7_;
	_tmp8__length1 = 1;
	gtk_application_set_accels_for_action (_tmp5_, TUNER_WINDOW_ACTION_PREFIX TUNER_WINDOW_ACTION_PAUSE, _tmp8_);
	_tmp8_ = (_vala_array_free (_tmp8_, _tmp8__length1, (GDestroyNotify) g_free), NULL);
	_tmp9_ = gtk_window_get_application ((GtkWindow*) self);
	_tmp10_ = _tmp9_;
	_tmp11_ = g_strdup ("<Control>q");
	_tmp12_ = g_new0 (gchar*, 1 + 1);
	_tmp12_[0] = _tmp11_;
	_tmp13_ = _tmp12_;
	_tmp13__length1 = 1;
	gtk_application_set_accels_for_action (_tmp10_, TUNER_WINDOW_ACTION_PREFIX TUNER_WINDOW_ACTION_QUIT, _tmp13_);
	_tmp13_ = (_vala_array_free (_tmp13_, _tmp13__length1, (GDestroyNotify) g_free), NULL);
	_tmp14_ = gtk_window_get_application ((GtkWindow*) self);
	_tmp15_ = _tmp14_;
	_tmp16_ = g_strdup ("<Control>w");
	_tmp17_ = g_new0 (gchar*, 1 + 1);
	_tmp17_[0] = _tmp16_;
	_tmp18_ = _tmp17_;
	_tmp18__length1 = 1;
	gtk_application_set_accels_for_action (_tmp15_, TUNER_WINDOW_ACTION_PREFIX TUNER_WINDOW_ACTION_QUIT, _tmp18_);
	_tmp18_ = (_vala_array_free (_tmp18_, _tmp18__length1, (GDestroyNotify) g_free), NULL);
	return self;
}

TunerWindow*
tuner_window_new (TunerApplication* app,
                  TunerPlayerController* player)
{
	return tuner_window_construct (TUNER_TYPE_WINDOW, app, player);
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

static Block10Data*
block10_data_ref (Block10Data* _data10_)
{
	g_atomic_int_inc (&_data10_->_ref_count_);
	return _data10_;
}

static void
block10_data_unref (void * _userdata_)
{
	Block10Data* _data10_;
	_data10_ = (Block10Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data10_->_ref_count_)) {
		TunerWindow* self;
		self = _data10_->self;
		_g_object_unref0 (_data10_->c);
		_g_object_unref0 (_data10_->item);
		_g_object_unref0 (_data10_->source_list);
		_g_object_unref0 (self);
		g_slice_free (Block10Data, _data10_);
	}
}

static void
__lambda20_ (Block10Data* _data10_)
{
	TunerWindow* self;
	self = _data10_->self;
	granite_widgets_source_list_set_selected (_data10_->source_list, _data10_->item);
}

static void
___lambda20__gtk_widget_map (GtkWidget* _sender,
                             gpointer self)
{
	__lambda20_ (self);
}

static void
___lambda21_ (Block10Data* _data10_)
{
	TunerWindow* self;
	TunerContentBox* _tmp0_;
	TunerAbstractContentList* _tmp1_;
	TunerAbstractContentList* _tmp2_;
	guint count = 0U;
	TunerContentBox* _tmp3_;
	TunerAbstractContentList* _tmp4_;
	TunerAbstractContentList* _tmp5_;
	guint _tmp6_;
	guint _tmp7_;
	gchar* _tmp8_;
	gchar* _tmp9_;
	self = _data10_->self;
	_tmp0_ = _data10_->c;
	_tmp1_ = tuner_content_box_get_content (_tmp0_);
	_tmp2_ = _tmp1_;
	if (_tmp2_ == NULL) {
		return;
	}
	_tmp3_ = _data10_->c;
	_tmp4_ = tuner_content_box_get_content (_tmp3_);
	_tmp5_ = _tmp4_;
	_tmp6_ = tuner_abstract_content_list_get_item_count (_tmp5_);
	_tmp7_ = _tmp6_;
	count = _tmp7_;
	_tmp8_ = g_strdup_printf ("%u", count);
	_tmp9_ = _tmp8_;
	granite_widgets_source_list_item_set_badge (_data10_->item, _tmp9_);
	_g_free0 (_tmp9_);
}

static void
____lambda21__tuner_content_box_content_changed (TunerContentBox* _sender,
                                                 gpointer self)
{
	___lambda21_ (self);
}

static TunerContentBox*
tuner_window_create_content_box (TunerWindow* self,
                                 const gchar* name,
                                 GraniteWidgetsSourceListItem* item,
                                 const gchar* full_title,
                                 const gchar* action_icon_name,
                                 const gchar* action_tooltip_text,
                                 GtkStack* stack,
                                 GraniteWidgetsSourceList* source_list,
                                 gboolean enable_count)
{
	Block10Data* _data10_;
	GraniteWidgetsSourceListItem* _tmp0_;
	GraniteWidgetsSourceList* _tmp1_;
	gchar* _tmp2_;
	TunerContentBox* _tmp3_;
	TunerContentBox* _tmp4_;
	TunerContentBox* _tmp6_;
	TunerContentBox* _tmp7_;
	TunerContentBox* _tmp8_;
	TunerContentBox* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (name != NULL, NULL);
	g_return_val_if_fail (item != NULL, NULL);
	g_return_val_if_fail (full_title != NULL, NULL);
	g_return_val_if_fail (stack != NULL, NULL);
	g_return_val_if_fail (source_list != NULL, NULL);
	_data10_ = g_slice_new0 (Block10Data);
	_data10_->_ref_count_ = 1;
	_data10_->self = g_object_ref (self);
	_tmp0_ = _g_object_ref0 (item);
	_g_object_unref0 (_data10_->item);
	_data10_->item = _tmp0_;
	_tmp1_ = _g_object_ref0 (source_list);
	_g_object_unref0 (_data10_->source_list);
	_data10_->source_list = _tmp1_;
	_tmp2_ = g_strdup (name);
	g_object_set_data_full ((GObject*) _data10_->item, "stack_child", _tmp2_, g_free);
	_tmp3_ = tuner_content_box_new (NULL, full_title, NULL, action_icon_name, action_tooltip_text);
	g_object_ref_sink (_tmp3_);
	_data10_->c = _tmp3_;
	_tmp4_ = _data10_->c;
	g_signal_connect_data ((GtkWidget*) _tmp4_, "map", (GCallback) ___lambda20__gtk_widget_map, block10_data_ref (_data10_), (GClosureNotify) block10_data_unref, 0);
	if (enable_count) {
		TunerContentBox* _tmp5_;
		_tmp5_ = _data10_->c;
		g_signal_connect_data (_tmp5_, "content-changed", (GCallback) ____lambda21__tuner_content_box_content_changed, block10_data_ref (_data10_), (GClosureNotify) block10_data_unref, 0);
	}
	_tmp6_ = _data10_->c;
	gtk_stack_add_named (stack, (GtkWidget*) _tmp6_, name);
	_tmp7_ = _data10_->c;
	_tmp8_ = _g_object_ref0 (_tmp7_);
	result = _tmp8_;
	block10_data_unref (_data10_);
	_data10_ = NULL;
	return result;
}

static const gchar*
string_to_string (const gchar* self)
{
	const gchar* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	result = self;
	return result;
}

static void
tuner_window_adjust_theme (void)
{
	gchar* theme = NULL;
	TunerApplication* _tmp0_;
	TunerApplication* _tmp1_;
	GSettings* _tmp2_;
	GSettings* _tmp3_;
	gchar* _tmp4_;
	const gchar* _tmp5_;
	const gchar* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	GtkSettings* gtk_settings = NULL;
	GtkSettings* _tmp9_;
	GtkSettings* _tmp10_;
	GraniteSettings* granite_settings = NULL;
	GraniteSettings* _tmp11_;
	GraniteSettings* _tmp12_;
	const gchar* _tmp13_;
	_tmp0_ = tuner_application_get_instance ();
	_tmp1_ = _tmp0_;
	_tmp2_ = tuner_application_get_settings (_tmp1_);
	_tmp3_ = _tmp2_;
	_tmp4_ = g_settings_get_string (_tmp3_, "theme-mode");
	theme = _tmp4_;
	_tmp5_ = theme;
	_tmp6_ = string_to_string (_tmp5_);
	_tmp7_ = g_strconcat ("current theme: ", _tmp6_, NULL);
	_tmp8_ = _tmp7_;
	g_warning ("Window.vala:398: %s", _tmp8_);
	_g_free0 (_tmp8_);
	_tmp9_ = gtk_settings_get_default ();
	_tmp10_ = _g_object_ref0 (_tmp9_);
	gtk_settings = _tmp10_;
	_tmp11_ = granite_settings_get_default ();
	_tmp12_ = _g_object_ref0 (_tmp11_);
	granite_settings = _tmp12_;
	_tmp13_ = theme;
	if (g_strcmp0 (_tmp13_, "system") != 0) {
		GtkSettings* _tmp14_;
		const gchar* _tmp15_;
		_tmp14_ = gtk_settings;
		_tmp15_ = theme;
		g_object_set (_tmp14_, "gtk-application-prefer-dark-theme", g_strcmp0 (_tmp15_, "dark") == 0, NULL);
	} else {
		GtkSettings* _tmp16_;
		GraniteSettings* _tmp17_;
		GraniteSettingsColorScheme _tmp18_;
		GraniteSettingsColorScheme _tmp19_;
		_tmp16_ = gtk_settings;
		_tmp17_ = granite_settings;
		_tmp18_ = granite_settings_get_prefers_color_scheme (_tmp17_);
		_tmp19_ = _tmp18_;
		g_object_set (_tmp16_, "gtk-application-prefer-dark-theme", _tmp19_ == GRANITE_SETTINGS_COLOR_SCHEME_DARK, NULL);
	}
	_g_object_unref0 (granite_settings);
	_g_object_unref0 (gtk_settings);
	_g_free0 (theme);
}

static void
tuner_window_on_action_quit (TunerWindow* self)
{
	g_return_if_fail (self != NULL);
	gtk_window_close ((GtkWindow*) self);
}

static void
tuner_window_on_action_about (TunerWindow* self)
{
	TunerAboutDialog* dialog = NULL;
	TunerAboutDialog* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = tuner_about_dialog_new ((GtkWindow*) self);
	g_object_ref_sink (_tmp0_);
	dialog = _tmp0_;
	gtk_window_present ((GtkWindow*) dialog);
	_g_object_unref0 (dialog);
}

void
tuner_window_handle_station_click (TunerWindow* self,
                                   TunerModelStation* station)
{
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	TunerDirectoryController* _tmp5_;
	TunerPlayerController* _tmp6_;
	const gchar* _tmp7_;
	const gchar* _tmp8_;
	const gchar* _tmp9_;
	gchar* _tmp10_;
	gchar* _tmp11_;
	GSettings* _tmp12_;
	const gchar* _tmp13_;
	const gchar* _tmp14_;
	const gchar* _tmp15_;
	const gchar* _tmp16_;
	gchar* _tmp17_;
	gchar* _tmp18_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (station != NULL);
	_tmp0_ = tuner_model_station_get_title (station);
	_tmp1_ = _tmp0_;
	_tmp2_ = string_to_string (_tmp1_);
	_tmp3_ = g_strconcat ("handle station click for ", _tmp2_, NULL);
	_tmp4_ = _tmp3_;
	g_info ("Window.vala:419: %s", _tmp4_);
	_g_free0 (_tmp4_);
	_tmp5_ = self->priv->_directory;
	tuner_directory_controller_count_station_click (_tmp5_, station);
	_tmp6_ = self->priv->_player;
	tuner_player_controller_set_station (_tmp6_, station);
	_tmp7_ = tuner_model_station_get_id (station);
	_tmp8_ = _tmp7_;
	_tmp9_ = string_to_string (_tmp8_);
	_tmp10_ = g_strconcat ("storing last played station: ", _tmp9_, NULL);
	_tmp11_ = _tmp10_;
	g_warning ("Window.vala:423: %s", _tmp11_);
	_g_free0 (_tmp11_);
	_tmp12_ = self->priv->_settings;
	_tmp13_ = tuner_model_station_get_id (station);
	_tmp14_ = _tmp13_;
	g_settings_set_string (_tmp12_, "last-played-station", _tmp14_);
	_tmp15_ = tuner_model_station_get_title (station);
	_tmp16_ = _tmp15_;
	_tmp17_ = g_strconcat (TUNER_WINDOW_WindowName ": ", _tmp16_, NULL);
	_tmp18_ = _tmp17_;
	gtk_window_set_title ((GtkWindow*) self, _tmp18_);
	_g_free0 (_tmp18_);
}

void
tuner_window_handle_favourites_changed (TunerWindow* self)
{
	g_return_if_fail (self != NULL);
	g_signal_emit (self, tuner_window_signals[TUNER_WINDOW_REFRESH_FAVOURITES_SIGNAL], 0);
}

void
tuner_window_on_toggle_playback (TunerWindow* self)
{
	TunerPlayerController* _tmp0_;
	g_return_if_fail (self != NULL);
	g_info ("Window.vala:434: Stop Playback requested");
	_tmp0_ = self->priv->_player;
	tuner_player_controller_play_pause (_tmp0_);
}

static GVariant*
_variant_new6 (gboolean value)
{
	return g_variant_ref_sink (g_variant_new_boolean (value));
}

static gchar*
bool_to_string (gboolean self)
{
	gchar* result = NULL;
	if (self) {
		gchar* _tmp0_;
		_tmp0_ = g_strdup ("true");
		result = _tmp0_;
		return result;
	} else {
		gchar* _tmp1_;
		_tmp1_ = g_strdup ("false");
		result = _tmp1_;
		return result;
	}
}

void
tuner_window_on_action_disable_tracking (TunerWindow* self,
                                         GSimpleAction* action,
                                         GVariant* parameter)
{
	gboolean new_state = FALSE;
	GSettings* _tmp0_;
	GVariant* _tmp1_;
	GSettings* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (action != NULL);
	_tmp0_ = self->priv->_settings;
	new_state = !g_settings_get_boolean (_tmp0_, "do-not-track");
	_tmp1_ = _variant_new6 (new_state);
	g_simple_action_set_state (action, _tmp1_);
	_g_variant_unref0 (_tmp1_);
	_tmp2_ = self->priv->_settings;
	g_settings_set_boolean (_tmp2_, "do-not-track", new_state);
	_tmp3_ = bool_to_string (new_state);
	_tmp4_ = _tmp3_;
	_tmp5_ = g_strconcat ("on_action_disable_tracking: ", _tmp4_, NULL);
	_tmp6_ = _tmp5_;
	g_debug ("Window.vala:442: %s", _tmp6_);
	_g_free0 (_tmp6_);
	_g_free0 (_tmp4_);
}

static GVariant*
_variant_new7 (gboolean value)
{
	return g_variant_ref_sink (g_variant_new_boolean (value));
}

void
tuner_window_on_action_enable_autoplay (TunerWindow* self,
                                        GSimpleAction* action,
                                        GVariant* parameter)
{
	gboolean new_state = FALSE;
	GSettings* _tmp0_;
	GVariant* _tmp1_;
	GSettings* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (action != NULL);
	_tmp0_ = self->priv->_settings;
	new_state = !g_settings_get_boolean (_tmp0_, "auto-play");
	_tmp1_ = _variant_new7 (new_state);
	g_simple_action_set_state (action, _tmp1_);
	_g_variant_unref0 (_tmp1_);
	_tmp2_ = self->priv->_settings;
	g_settings_set_boolean (_tmp2_, "auto-play", new_state);
	_tmp3_ = bool_to_string (new_state);
	_tmp4_ = _tmp3_;
	_tmp5_ = g_strconcat ("on_action_enable_autoplay: ", _tmp4_, NULL);
	_tmp6_ = _tmp5_;
	g_debug ("Window.vala:449: %s", _tmp6_);
	_g_free0 (_tmp6_);
	_g_free0 (_tmp4_);
}

static gboolean
___lambda22_ (TunerWindow* self)
{
	TunerHeaderBar* _tmp0_;
	gboolean result = FALSE;
	_tmp0_ = self->priv->headerbar;
	tuner_header_bar_set_playstate (_tmp0_, TUNER_HEADER_BAR_PLAY_STATE_PAUSE_ACTIVE);
	result = FALSE;
	return result;
}

static gboolean
____lambda22__gsource_func (gpointer self)
{
	gboolean result;
	result = ___lambda22_ ((TunerWindow*) self);
	return result;
}

static gboolean
___lambda23_ (TunerWindow* self)
{
	TunerPlayerController* _tmp0_;
	gboolean result = FALSE;
	_tmp0_ = self->priv->_player;
	if (tuner_player_controller_can_play (_tmp0_)) {
		TunerHeaderBar* _tmp1_;
		_tmp1_ = self->priv->headerbar;
		tuner_header_bar_set_playstate (_tmp1_, TUNER_HEADER_BAR_PLAY_STATE_PLAY_ACTIVE);
	} else {
		TunerHeaderBar* _tmp2_;
		_tmp2_ = self->priv->headerbar;
		tuner_header_bar_set_playstate (_tmp2_, TUNER_HEADER_BAR_PLAY_STATE_PLAY_INACTIVE);
	}
	result = FALSE;
	return result;
}

static gboolean
____lambda23__gsource_func (gpointer self)
{
	gboolean result;
	result = ___lambda23_ ((TunerWindow*) self);
	return result;
}

static gboolean
___lambda24_ (TunerWindow* self)
{
	TunerHeaderBar* _tmp0_;
	gboolean result = FALSE;
	_tmp0_ = self->priv->headerbar;
	tuner_header_bar_set_playstate (_tmp0_, TUNER_HEADER_BAR_PLAY_STATE_PAUSE_ACTIVE);
	result = FALSE;
	return result;
}

static gboolean
____lambda24__gsource_func (gpointer self)
{
	gboolean result;
	result = ___lambda24_ ((TunerWindow*) self);
	return result;
}

static gboolean
___lambda25_ (TunerWindow* self)
{
	TunerPlayerController* _tmp0_;
	gboolean result = FALSE;
	_tmp0_ = self->priv->_player;
	if (tuner_player_controller_can_play (_tmp0_)) {
		TunerHeaderBar* _tmp1_;
		_tmp1_ = self->priv->headerbar;
		tuner_header_bar_set_playstate (_tmp1_, TUNER_HEADER_BAR_PLAY_STATE_PLAY_ACTIVE);
	} else {
		TunerHeaderBar* _tmp2_;
		_tmp2_ = self->priv->headerbar;
		tuner_header_bar_set_playstate (_tmp2_, TUNER_HEADER_BAR_PLAY_STATE_PLAY_INACTIVE);
	}
	result = FALSE;
	return result;
}

static gboolean
____lambda25__gsource_func (gpointer self)
{
	gboolean result;
	result = ___lambda25_ ((TunerWindow*) self);
	return result;
}

void
tuner_window_handleplayer_state_changed (TunerWindow* self,
                                         GstPlayerState state)
{
	g_return_if_fail (self != NULL);
	switch (state) {
		case GST_PLAYER_STATE_BUFFERING:
		{
			g_debug ("Window.vala:455: player state changed to Buffering");
			gdk_threads_add_idle (____lambda22__gsource_func, self);
			break;
		}
		case GST_PLAYER_STATE_PAUSED:
		{
			g_debug ("Window.vala:462: player state changed to Paused");
			gdk_threads_add_idle (____lambda23__gsource_func, self);
			break;
		}
		case GST_PLAYER_STATE_PLAYING:
		{
			g_debug ("Window.vala:473: player state changed to Playing");
			gdk_threads_add_idle (____lambda24__gsource_func, self);
			break;
		}
		case GST_PLAYER_STATE_STOPPED:
		{
			g_debug ("Window.vala:480: player state changed to Stopped");
			gdk_threads_add_idle (____lambda25__gsource_func, self);
			break;
		}
		default:
		break;
	}
	return;
}

static gboolean
_gst_player_state_equal (const GstPlayerState * s1,
                         const GstPlayerState * s2)
{
	if (s1 == s2) {
		return TRUE;
	}
	if (s1 == NULL) {
		return FALSE;
	}
	if (s2 == NULL) {
		return FALSE;
	}
	return (*s1) == (*s2);
}

gboolean
tuner_window_before_destroy (TunerWindow* self)
{
	gint width = 0;
	gint height = 0;
	gint x = 0;
	gint y = 0;
	gint _tmp0_ = 0;
	gint _tmp1_ = 0;
	gint _tmp2_ = 0;
	gint _tmp3_ = 0;
	GSettings* _tmp4_;
	GSettings* _tmp5_;
	GSettings* _tmp6_;
	GSettings* _tmp7_;
	TunerPlayerController* _tmp8_;
	GstPlayerState* _tmp9_;
	GstPlayerState* _tmp10_;
	GstPlayerState _tmp11_;
	gboolean result = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	gtk_window_get_size ((GtkWindow*) self, &_tmp0_, &_tmp1_);
	width = _tmp0_;
	height = _tmp1_;
	gtk_window_get_position ((GtkWindow*) self, &_tmp2_, &_tmp3_);
	x = _tmp2_;
	y = _tmp3_;
	_tmp4_ = self->priv->_settings;
	g_settings_set_int (_tmp4_, "pos-x", x);
	_tmp5_ = self->priv->_settings;
	g_settings_set_int (_tmp5_, "pos-y", y);
	_tmp6_ = self->priv->_settings;
	g_settings_set_int (_tmp6_, "window-height", height);
	_tmp7_ = self->priv->_settings;
	g_settings_set_int (_tmp7_, "window-width", width);
	_tmp8_ = self->priv->_player;
	_tmp9_ = tuner_player_controller_get_current_state (_tmp8_);
	_tmp10_ = _tmp9_;
	_tmp11_ = GST_PLAYER_STATE_PLAYING;
	if (_gst_player_state_equal (_tmp10_, &_tmp11_) == TRUE) {
		GNotification* notification = NULL;
		GNotification* _tmp12_;
		GNotification* _tmp13_;
		GNotification* _tmp14_;
		TunerApplication* _tmp15_;
		TunerApplication* _tmp16_;
		GNotification* _tmp17_;
		gtk_widget_hide_on_delete ((GtkWidget*) self);
		_tmp12_ = g_notification_new ("Playing in background");
		notification = _tmp12_;
		_tmp13_ = notification;
		g_notification_set_body (_tmp13_, "Click here to resume window. To quit Tuner, pause playback and close t" \
"he window.");
		_tmp14_ = notification;
		g_notification_set_default_action (_tmp14_, "app.resume-window");
		_tmp15_ = tuner_application_get_instance ();
		_tmp16_ = _tmp15_;
		_tmp17_ = notification;
		g_application_send_notification ((GApplication*) _tmp16_, "continue-playing", _tmp17_);
		result = TRUE;
		_g_object_unref0 (notification);
		return result;
	}
	result = FALSE;
	return result;
}

GSettings*
tuner_window_get_settings (TunerWindow* self)
{
	GSettings* result;
	GSettings* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_settings;
	result = _tmp0_;
	return result;
}

static void
tuner_window_set_settings (TunerWindow* self,
                           GSettings* value)
{
	GSettings* old_value;
	g_return_if_fail (self != NULL);
	old_value = tuner_window_get_settings (self);
	if (old_value != value) {
		GSettings* _tmp0_;
		_tmp0_ = _g_object_ref0 (value);
		_g_object_unref0 (self->priv->_settings);
		self->priv->_settings = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, tuner_window_properties[TUNER_WINDOW_SETTINGS_PROPERTY]);
	}
}

GtkStack*
tuner_window_get_stack (TunerWindow* self)
{
	GtkStack* result;
	GtkStack* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_stack;
	result = _tmp0_;
	return result;
}

void
tuner_window_set_stack (TunerWindow* self,
                        GtkStack* value)
{
	GtkStack* old_value;
	g_return_if_fail (self != NULL);
	old_value = tuner_window_get_stack (self);
	if (old_value != value) {
		GtkStack* _tmp0_;
		_tmp0_ = _g_object_ref0 (value);
		_g_object_unref0 (self->priv->_stack);
		self->priv->_stack = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, tuner_window_properties[TUNER_WINDOW_STACK_PROPERTY]);
	}
}

TunerPlayerController*
tuner_window_get_player (TunerWindow* self)
{
	TunerPlayerController* result;
	TunerPlayerController* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_player;
	result = _tmp0_;
	return result;
}

static void
tuner_window_set_player (TunerWindow* self,
                         TunerPlayerController* value)
{
	TunerPlayerController* old_value;
	g_return_if_fail (self != NULL);
	old_value = tuner_window_get_player (self);
	if (old_value != value) {
		TunerPlayerController* _tmp0_;
		_tmp0_ = _g_object_ref0 (value);
		_g_object_unref0 (self->priv->_player);
		self->priv->_player = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, tuner_window_properties[TUNER_WINDOW_PLAYER_PROPERTY]);
	}
}

static Block11Data*
block11_data_ref (Block11Data* _data11_)
{
	g_atomic_int_inc (&_data11_->_ref_count_);
	return _data11_;
}

static void
block11_data_unref (void * _userdata_)
{
	Block11Data* _data11_;
	_data11_ = (Block11Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data11_->_ref_count_)) {
		TunerWindow* self;
		self = _data11_->self;
		_g_object_unref0 (_data11_->c5);
		_g_object_unref0 (_data11_->c4);
		_g_object_unref0 (_data11_->c_slist);
		_g_object_unref0 (_data11_->c_country);
		_g_object_unref0 (_data11_->item4);
		_g_object_unref0 (_data11_->s3);
		_g_object_unref0 (_data11_->c3);
		_g_object_unref0 (_data11_->s2);
		_g_object_unref0 (_data11_->c2);
		_g_object_unref0 (_data11_->s1);
		_g_object_unref0 (_data11_->c1);
		_g_object_unref0 (_data11_->selections_category);
		_g_object_unref0 (_data11_->stack);
		_g_object_unref0 (self);
		g_slice_free (Block11Data, _data11_);
	}
}

static void
_tuner_window_handleplayer_state_changed_tuner_player_controller_state_changed (TunerPlayerController* _sender,
                                                                                GstPlayerState state,
                                                                                gpointer self)
{
	tuner_window_handleplayer_state_changed ((TunerWindow*) self, state);
}

static void
_tuner_header_bar_update_from_station_tuner_player_controller_station_changed (TunerPlayerController* _sender,
                                                                               TunerModelStation* station,
                                                                               gpointer self)
{
	tuner_header_bar_update_from_station ((TunerHeaderBar*) self, station);
}

static void
_tuner_window___lambda26_ (TunerWindow* self,
                           const gchar* title)
{
	TunerHeaderBar* _tmp0_;
	g_return_if_fail (title != NULL);
	_tmp0_ = self->priv->headerbar;
	tuner_header_bar_set_subtitle (_tmp0_, title);
}

static void
__tuner_window___lambda26__tuner_player_controller_title_changed (TunerPlayerController* _sender,
                                                                  const gchar* title,
                                                                  gpointer self)
{
	_tuner_window___lambda26_ ((TunerWindow*) self, title);
}

static void
_tuner_window___lambda27_ (TunerWindow* self,
                           gdouble volume)
{
	TunerHeaderBar* _tmp0_;
	GtkVolumeButton* _tmp1_;
	_tmp0_ = self->priv->headerbar;
	_tmp1_ = _tmp0_->volume_button;
	gtk_scale_button_set_value ((GtkScaleButton*) _tmp1_, volume);
}

static void
__tuner_window___lambda27__tuner_player_controller_volume_changed (TunerPlayerController* _sender,
                                                                   gdouble volume,
                                                                   gpointer self)
{
	_tuner_window___lambda27_ ((TunerWindow*) self, volume);
}

static void
_tuner_window___lambda28_ (TunerWindow* self,
                           gdouble value)
{
	TunerPlayerController* _tmp0_;
	_tmp0_ = self->priv->_player;
	tuner_player_controller_set_volume (_tmp0_, value);
}

static void
__tuner_window___lambda28__gtk_scale_button_value_changed (GtkScaleButton* _sender,
                                                           gdouble value,
                                                           gpointer self)
{
	_tuner_window___lambda28_ ((TunerWindow*) self, value);
}

static void
_tuner_window___lambda29_ (TunerWindow* self,
                           const gchar* key)
{
	g_return_if_fail (key != NULL);
	if (g_strcmp0 (key, "theme-mode") == 0) {
		g_warning ("Window.vala:79: theme-mode changed");
		tuner_window_adjust_theme ();
	}
}

static void
__tuner_window___lambda29__g_settings_changed (GSettings* _sender,
                                               const gchar* key,
                                               gpointer self)
{
	_tuner_window___lambda29_ ((TunerWindow*) self, key);
}

static void
_tuner_window___lambda30_ (TunerWindow* self,
                           GParamSpec* key)
{
	g_return_if_fail (key != NULL);
	g_warning ("Window.vala:87: theme-mode changed");
	tuner_window_adjust_theme ();
}

static void
__tuner_window___lambda30__g_object_notify (GObject* _sender,
                                            GParamSpec* pspec,
                                            gpointer self)
{
	_tuner_window___lambda30_ ((TunerWindow*) self, pspec);
}

static GVariant*
_variant_new8 (gboolean value)
{
	return g_variant_ref_sink (g_variant_new_boolean (value));
}

static GVariant*
_variant_new9 (gboolean value)
{
	return g_variant_ref_sink (g_variant_new_boolean (value));
}

static gboolean
_tuner_window___lambda31_ (TunerWindow* self,
                           GdkEventAny* e)
{
	gboolean result = FALSE;
	g_return_val_if_fail (e != NULL, FALSE);
	result = tuner_window_before_destroy (self);
	return result;
}

static gboolean
__tuner_window___lambda31__gtk_widget_delete_event (GtkWidget* _sender,
                                                    GdkEventAny* event,
                                                    gpointer self)
{
	gboolean result;
	result = _tuner_window___lambda31_ ((TunerWindow*) self, event);
	return result;
}

static void
_tuner_window_handle_station_click_tuner_station_list_selection_changed (TunerStationList* _sender,
                                                                         TunerModelStation* station,
                                                                         gpointer self)
{
	tuner_window_handle_station_click ((TunerWindow*) self, station);
}

static void
_tuner_window_handle_favourites_changed_tuner_station_list_favourites_changed (TunerStationList* _sender,
                                                                               gpointer self)
{
	tuner_window_handle_favourites_changed ((TunerWindow*) self);
}

static void
_tuner_window___lambda36_ (Block11Data* _data11_)
{
	TunerWindow* self;
	GError* _inner_error0_ = NULL;
	self = _data11_->self;
	{
		GeeArrayList* _tmp0_ = NULL;
		TunerStationSource* _tmp1_;
		GeeArrayList* _tmp2_;
		TunerStationList* slist = NULL;
		TunerStationList* _tmp3_;
		TunerStationList* _tmp4_;
		TunerStationList* _tmp5_;
		TunerContentBox* _tmp6_;
		TunerStationList* _tmp7_;
		_tmp1_ = _data11_->s1;
		_tmp2_ = tuner_station_source_next (_tmp1_, &_inner_error0_);
		_tmp0_ = _tmp2_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			if (_inner_error0_->domain == SOURCE_ERROR) {
				goto __catch0_source_error;
			}
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return;
		}
		_tmp3_ = tuner_station_list_new_with_stations (_tmp0_);
		g_object_ref_sink (_tmp3_);
		slist = _tmp3_;
		_tmp4_ = slist;
		g_signal_connect_object (_tmp4_, "selection-changed", (GCallback) _tuner_window_handle_station_click_tuner_station_list_selection_changed, self, 0);
		_tmp5_ = slist;
		g_signal_connect_object (_tmp5_, "favourites-changed", (GCallback) _tuner_window_handle_favourites_changed_tuner_station_list_favourites_changed, self, 0);
		_tmp6_ = _data11_->c1;
		_tmp7_ = slist;
		tuner_content_box_set_content (_tmp6_, (TunerAbstractContentList*) _tmp7_);
		_g_object_unref0 (slist);
		_g_object_unref0 (_tmp0_);
	}
	goto __finally0;
	__catch0_source_error:
	{
		TunerContentBox* _tmp8_;
		g_clear_error (&_inner_error0_);
		_tmp8_ = _data11_->c1;
		tuner_content_box_show_alert (_tmp8_);
	}
	__finally0:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return;
	}
}

static void
__tuner_window___lambda36__gtk_widget_realize (GtkWidget* _sender,
                                               gpointer self)
{
	_tuner_window___lambda36_ (self);
}

static void
_tuner_window___lambda43_ (Block11Data* _data11_)
{
	TunerWindow* self;
	GError* _inner_error0_ = NULL;
	self = _data11_->self;
	{
		GeeArrayList* _tmp0_ = NULL;
		TunerStationSource* _tmp1_;
		GeeArrayList* _tmp2_;
		TunerStationList* slist = NULL;
		TunerStationList* _tmp3_;
		TunerStationList* _tmp4_;
		TunerStationList* _tmp5_;
		TunerContentBox* _tmp6_;
		TunerStationList* _tmp7_;
		_tmp1_ = _data11_->s1;
		_tmp2_ = tuner_station_source_next (_tmp1_, &_inner_error0_);
		_tmp0_ = _tmp2_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			if (_inner_error0_->domain == SOURCE_ERROR) {
				goto __catch0_source_error;
			}
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return;
		}
		_tmp3_ = tuner_station_list_new_with_stations (_tmp0_);
		g_object_ref_sink (_tmp3_);
		slist = _tmp3_;
		_tmp4_ = slist;
		g_signal_connect_object (_tmp4_, "selection-changed", (GCallback) _tuner_window_handle_station_click_tuner_station_list_selection_changed, self, 0);
		_tmp5_ = slist;
		g_signal_connect_object (_tmp5_, "favourites-changed", (GCallback) _tuner_window_handle_favourites_changed_tuner_station_list_favourites_changed, self, 0);
		_tmp6_ = _data11_->c1;
		_tmp7_ = slist;
		tuner_content_box_set_content (_tmp6_, (TunerAbstractContentList*) _tmp7_);
		_g_object_unref0 (slist);
		_g_object_unref0 (_tmp0_);
	}
	goto __finally0;
	__catch0_source_error:
	{
		TunerContentBox* _tmp8_;
		g_clear_error (&_inner_error0_);
		_tmp8_ = _data11_->c1;
		tuner_content_box_show_alert (_tmp8_);
	}
	__finally0:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return;
	}
}

static void
__tuner_window___lambda43__tuner_content_box_action_activated (TunerContentBox* _sender,
                                                               gpointer self)
{
	_tuner_window___lambda43_ (self);
}

static void
_tuner_window___lambda44_ (Block11Data* _data11_)
{
	TunerWindow* self;
	GError* _inner_error0_ = NULL;
	self = _data11_->self;
	{
		GeeArrayList* _tmp0_ = NULL;
		TunerStationSource* _tmp1_;
		GeeArrayList* _tmp2_;
		TunerStationList* slist = NULL;
		TunerStationList* _tmp3_;
		TunerStationList* _tmp4_;
		TunerStationList* _tmp5_;
		TunerContentBox* _tmp6_;
		TunerStationList* _tmp7_;
		_tmp1_ = _data11_->s2;
		_tmp2_ = tuner_station_source_next (_tmp1_, &_inner_error0_);
		_tmp0_ = _tmp2_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			if (_inner_error0_->domain == SOURCE_ERROR) {
				goto __catch0_source_error;
			}
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return;
		}
		_tmp3_ = tuner_station_list_new_with_stations (_tmp0_);
		g_object_ref_sink (_tmp3_);
		slist = _tmp3_;
		_tmp4_ = slist;
		g_signal_connect_object (_tmp4_, "selection-changed", (GCallback) _tuner_window_handle_station_click_tuner_station_list_selection_changed, self, 0);
		_tmp5_ = slist;
		g_signal_connect_object (_tmp5_, "favourites-changed", (GCallback) _tuner_window_handle_favourites_changed_tuner_station_list_favourites_changed, self, 0);
		_tmp6_ = _data11_->c2;
		_tmp7_ = slist;
		tuner_content_box_set_content (_tmp6_, (TunerAbstractContentList*) _tmp7_);
		_g_object_unref0 (slist);
		_g_object_unref0 (_tmp0_);
	}
	goto __finally0;
	__catch0_source_error:
	{
		TunerContentBox* _tmp8_;
		g_clear_error (&_inner_error0_);
		_tmp8_ = _data11_->c2;
		tuner_content_box_show_alert (_tmp8_);
	}
	__finally0:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return;
	}
}

static void
__tuner_window___lambda44__gtk_widget_realize (GtkWidget* _sender,
                                               gpointer self)
{
	_tuner_window___lambda44_ (self);
}

static void
_tuner_window___lambda45_ (Block11Data* _data11_)
{
	TunerWindow* self;
	GError* _inner_error0_ = NULL;
	self = _data11_->self;
	{
		GeeArrayList* _tmp0_ = NULL;
		TunerStationSource* _tmp1_;
		GeeArrayList* _tmp2_;
		TunerStationList* slist = NULL;
		TunerStationList* _tmp3_;
		TunerStationList* _tmp4_;
		TunerStationList* _tmp5_;
		TunerContentBox* _tmp6_;
		TunerStationList* _tmp7_;
		_tmp1_ = _data11_->s3;
		_tmp2_ = tuner_station_source_next (_tmp1_, &_inner_error0_);
		_tmp0_ = _tmp2_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			if (_inner_error0_->domain == SOURCE_ERROR) {
				goto __catch0_source_error;
			}
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return;
		}
		_tmp3_ = tuner_station_list_new_with_stations (_tmp0_);
		g_object_ref_sink (_tmp3_);
		slist = _tmp3_;
		_tmp4_ = slist;
		g_signal_connect_object (_tmp4_, "selection-changed", (GCallback) _tuner_window_handle_station_click_tuner_station_list_selection_changed, self, 0);
		_tmp5_ = slist;
		g_signal_connect_object (_tmp5_, "favourites-changed", (GCallback) _tuner_window_handle_favourites_changed_tuner_station_list_favourites_changed, self, 0);
		_tmp6_ = _data11_->c3;
		_tmp7_ = slist;
		tuner_content_box_set_content (_tmp6_, (TunerAbstractContentList*) _tmp7_);
		_g_object_unref0 (slist);
		_g_object_unref0 (_tmp0_);
	}
	goto __finally0;
	__catch0_source_error:
	{
		TunerContentBox* _tmp8_;
		g_clear_error (&_inner_error0_);
		_tmp8_ = _data11_->c3;
		tuner_content_box_show_alert (_tmp8_);
	}
	__finally0:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return;
	}
}

static void
__tuner_window___lambda45__gtk_widget_realize (GtkWidget* _sender,
                                               gpointer self)
{
	_tuner_window___lambda45_ (self);
}

static Block12Data*
block12_data_ref (Block12Data* _data12_)
{
	g_atomic_int_inc (&_data12_->_ref_count_);
	return _data12_;
}

static void
block12_data_unref (void * _userdata_)
{
	Block12Data* _data12_;
	_data12_ = (Block12Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data12_->_ref_count_)) {
		TunerWindow* self;
		self = _data12_->_data11_->self;
		_g_object_unref0 (_data12_->s_country);
		block11_data_unref (_data12_->_data11_);
		_data12_->_data11_ = NULL;
		g_slice_free (Block12Data, _data12_);
	}
}

static void
__lambda47_ (Block12Data* _data12_)
{
	Block11Data* _data11_;
	TunerWindow* self;
	GError* _inner_error0_ = NULL;
	_data11_ = _data12_->_data11_;
	self = _data11_->self;
	{
		GeeArrayList* stations = NULL;
		TunerStationSource* _tmp0_;
		GeeArrayList* _tmp1_;
		TunerStationList* _tmp2_;
		GeeArrayList* _tmp3_;
		GeeArrayList* _tmp4_;
		gint _tmp5_;
		gint _tmp6_;
		gchar* _tmp7_;
		gchar* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
		TunerContentBox* _tmp11_;
		TunerStationList* _tmp12_;
		_tmp0_ = _data12_->s_country;
		_tmp1_ = tuner_station_source_next (_tmp0_, &_inner_error0_);
		stations = _tmp1_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			if (_inner_error0_->domain == SOURCE_ERROR) {
				goto __catch0_source_error;
			}
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return;
		}
		_tmp2_ = _data11_->c_slist;
		_tmp3_ = stations;
		tuner_station_list_set_stations (_tmp2_, _tmp3_);
		_tmp4_ = stations;
		_tmp5_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp4_);
		_tmp6_ = _tmp5_;
		_tmp7_ = g_strdup_printf ("%i", _tmp6_);
		_tmp8_ = _tmp7_;
		_tmp9_ = g_strconcat ("Length of country stations: ", _tmp8_, NULL);
		_tmp10_ = _tmp9_;
		g_warning ("Window.vala:232: %s", _tmp10_);
		_g_free0 (_tmp10_);
		_g_free0 (_tmp8_);
		_tmp11_ = _data11_->c_country;
		_tmp12_ = _data11_->c_slist;
		tuner_content_box_set_content (_tmp11_, (TunerAbstractContentList*) _tmp12_);
		_g_object_unref0 (stations);
	}
	goto __finally0;
	__catch0_source_error:
	{
		TunerContentBox* _tmp13_;
		g_clear_error (&_inner_error0_);
		_tmp13_ = _data11_->c_country;
		tuner_content_box_show_alert (_tmp13_);
	}
	__finally0:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return;
	}
}

static void
___lambda47__gtk_widget_realize (GtkWidget* _sender,
                                 gpointer self)
{
	__lambda47_ (self);
}

static void
_tuner_window___lambda46_ (Block11Data* _data11_,
                           GObject* obj,
                           GAsyncResult* res)
{
	TunerWindow* self;
	Block12Data* _data12_;
	gchar* country = NULL;
	gchar* country_name = NULL;
	const gchar* _tmp3_;
	gchar* _tmp4_;
	GraniteWidgetsSourceListItem* _tmp5_;
	const gchar* _tmp6_;
	TunerContentBox* _tmp7_;
	TunerHeaderLabel* _tmp8_;
	gchar* _tmp9_;
	gchar* _tmp10_;
	const gchar* _tmp11_;
	gchar* _tmp12_;
	gchar* _tmp13_;
	TunerDirectoryController* _tmp14_;
	const gchar* _tmp15_;
	TunerStationSource* _tmp16_;
	GraniteWidgetsSourceListExpandableItem* _tmp17_;
	GraniteWidgetsSourceListItem* _tmp18_;
	TunerContentBox* _tmp19_;
	GError* _inner_error0_ = NULL;
	self = _data11_->self;
	g_return_if_fail (res != NULL);
	_data12_ = g_slice_new0 (Block12Data);
	_data12_->_ref_count_ = 1;
	_data12_->_data11_ = block11_data_ref (_data11_);
	{
		gchar* _tmp0_ = NULL;
		gchar* _tmp1_;
		gchar* _tmp2_;
		_tmp1_ = tuner_location_discovery_country_code_finish (res, &_inner_error0_);
		_tmp0_ = _tmp1_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			goto __catch0_g_error;
		}
		_tmp2_ = _tmp0_;
		_tmp0_ = NULL;
		_g_free0 (country);
		country = _tmp2_;
		_g_free0 (_tmp0_);
	}
	goto __finally0;
	__catch0_g_error:
	{
		g_clear_error (&_inner_error0_);
		_g_free0 (country);
		block12_data_unref (_data12_);
		_data12_ = NULL;
		return;
	}
	__finally0:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		_g_free0 (country);
		block12_data_unref (_data12_);
		_data12_ = NULL;
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return;
	}
	_tmp3_ = country;
	_tmp4_ = tuner_model_countries_get_by_code (_tmp3_, "");
	country_name = _tmp4_;
	_tmp5_ = _data11_->item4;
	_tmp6_ = country_name;
	granite_widgets_source_list_item_set_name (_tmp5_, _tmp6_);
	_tmp7_ = _data11_->c_country;
	_tmp8_ = _tmp7_->header_label;
	_tmp9_ = g_strconcat (_ ("Top 100 in"), " ", NULL);
	_tmp10_ = _tmp9_;
	_tmp11_ = country_name;
	_tmp12_ = g_strconcat (_tmp10_, _tmp11_, NULL);
	_tmp13_ = _tmp12_;
	gtk_label_set_label ((GtkLabel*) _tmp8_, _tmp13_);
	_g_free0 (_tmp13_);
	_g_free0 (_tmp10_);
	_tmp14_ = self->priv->_directory;
	_tmp15_ = country;
	_tmp16_ = tuner_directory_controller_load_by_country (_tmp14_, (guint) 100, _tmp15_);
	_data12_->s_country = _tmp16_;
	_tmp17_ = _data11_->selections_category;
	_tmp18_ = _data11_->item4;
	granite_widgets_source_list_expandable_item_add (_tmp17_, _tmp18_);
	_tmp19_ = _data11_->c_country;
	g_signal_connect_data ((GtkWidget*) _tmp19_, "realize", (GCallback) ___lambda47__gtk_widget_realize, block12_data_ref (_data12_), (GClosureNotify) block12_data_unref, 0);
	_g_free0 (country_name);
	_g_free0 (country);
	block12_data_unref (_data12_);
	_data12_ = NULL;
}

static void
__tuner_window___lambda46__gasync_ready_callback (GObject* source_object,
                                                  GAsyncResult* res,
                                                  gpointer self)
{
	_tuner_window___lambda46_ (self, source_object, res);
	block11_data_unref (self);
}

static gpointer
_tuner_model_genre_ref0 (gpointer self)
{
	return self ? tuner_model_genre_ref (self) : NULL;
}

static Block13Data*
block13_data_ref (Block13Data* _data13_)
{
	g_atomic_int_inc (&_data13_->_ref_count_);
	return _data13_;
}

static void
block13_data_unref (void * _userdata_)
{
	Block13Data* _data13_;
	_data13_ = (Block13Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data13_->_ref_count_)) {
		TunerWindow* self;
		self = _data13_->_data11_->self;
		_g_object_unref0 (_data13_->ds);
		_g_object_unref0 (_data13_->cb);
		block11_data_unref (_data13_->_data11_);
		_data13_->_data11_ = NULL;
		g_slice_free (Block13Data, _data13_);
	}
}

static gchar**
_vala_array_dup8 (gchar** self,
                  gssize length)
{
	if (length >= 0) {
		gchar** result;
		gssize i;
		result = g_new0 (gchar*, length + 1);
		for (i = 0; i < length; i++) {
			gchar* _tmp0_;
			_tmp0_ = g_strdup (self[i]);
			result[i] = _tmp0_;
		}
		return result;
	}
	return NULL;
}

static void
_tuner_window_____lambda48_ (Block13Data* _data13_)
{
	Block11Data* _data11_;
	TunerWindow* self;
	GError* _inner_error0_ = NULL;
	_data11_ = _data13_->_data11_;
	self = _data11_->self;
	{
		GeeArrayList* _tmp0_ = NULL;
		TunerStationSource* _tmp1_;
		GeeArrayList* _tmp2_;
		TunerStationList* slist1 = NULL;
		TunerStationList* _tmp3_;
		TunerStationList* _tmp4_;
		TunerStationList* _tmp5_;
		TunerContentBox* _tmp6_;
		TunerStationList* _tmp7_;
		_tmp1_ = _data13_->ds;
		_tmp2_ = tuner_station_source_next (_tmp1_, &_inner_error0_);
		_tmp0_ = _tmp2_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			if (_inner_error0_->domain == SOURCE_ERROR) {
				goto __catch0_source_error;
			}
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return;
		}
		_tmp3_ = tuner_station_list_new_with_stations (_tmp0_);
		g_object_ref_sink (_tmp3_);
		slist1 = _tmp3_;
		_tmp4_ = slist1;
		g_signal_connect_object (_tmp4_, "selection-changed", (GCallback) _tuner_window_handle_station_click_tuner_station_list_selection_changed, self, 0);
		_tmp5_ = slist1;
		g_signal_connect_object (_tmp5_, "favourites-changed", (GCallback) _tuner_window_handle_favourites_changed_tuner_station_list_favourites_changed, self, 0);
		_tmp6_ = _data13_->cb;
		_tmp7_ = slist1;
		tuner_content_box_set_content (_tmp6_, (TunerAbstractContentList*) _tmp7_);
		_g_object_unref0 (slist1);
		_g_object_unref0 (_tmp0_);
	}
	goto __finally0;
	__catch0_source_error:
	{
		TunerContentBox* _tmp8_;
		g_clear_error (&_inner_error0_);
		_tmp8_ = _data13_->cb;
		tuner_content_box_show_alert (_tmp8_);
	}
	__finally0:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return;
	}
}

static void
__tuner_window_____lambda48__gtk_widget_realize (GtkWidget* _sender,
                                                 gpointer self)
{
	_tuner_window_____lambda48_ (self);
}

static void
_tuner_window___lambda49_ (TunerWindow* self,
                           gboolean starred)
{
	TunerPlayerController* _tmp0_;
	TunerModelStation* _tmp1_;
	TunerModelStation* _tmp2_;
	_tmp0_ = self->priv->_player;
	_tmp1_ = tuner_player_controller_get_station (_tmp0_);
	_tmp2_ = _tmp1_;
	tuner_model_station_toggle_starred (_tmp2_);
}

static void
__tuner_window___lambda49__tuner_header_bar_star_clicked (TunerHeaderBar* _sender,
                                                          gboolean starred,
                                                          gpointer self)
{
	_tuner_window___lambda49_ ((TunerWindow*) self, starred);
}

static void
_tuner_window___lambda50_ (Block11Data* _data11_)
{
	TunerWindow* self;
	TunerStationList* _slist = NULL;
	TunerDirectoryController* _tmp0_;
	GeeArrayList* _tmp1_;
	GeeArrayList* _tmp2_;
	TunerStationList* _tmp3_;
	TunerStationList* _tmp4_;
	TunerStationList* _tmp5_;
	TunerStationList* _tmp6_;
	TunerContentBox* _tmp7_;
	TunerStationList* _tmp8_;
	self = _data11_->self;
	_tmp0_ = self->priv->_directory;
	_tmp1_ = tuner_directory_controller_get_stored (_tmp0_);
	_tmp2_ = _tmp1_;
	_tmp3_ = tuner_station_list_new_with_stations (_tmp2_);
	g_object_ref_sink (_tmp3_);
	_tmp4_ = _tmp3_;
	_g_object_unref0 (_tmp2_);
	_slist = _tmp4_;
	_tmp5_ = _slist;
	g_signal_connect_object (_tmp5_, "selection-changed", (GCallback) _tuner_window_handle_station_click_tuner_station_list_selection_changed, self, 0);
	_tmp6_ = _slist;
	g_signal_connect_object (_tmp6_, "favourites-changed", (GCallback) _tuner_window_handle_favourites_changed_tuner_station_list_favourites_changed, self, 0);
	_tmp7_ = _data11_->c4;
	_tmp8_ = _slist;
	tuner_content_box_set_content (_tmp7_, (TunerAbstractContentList*) _tmp8_);
	_g_object_unref0 (_slist);
}

static void
__tuner_window___lambda50__tuner_window_refresh_favourites (TunerWindow* _sender,
                                                            gpointer self)
{
	_tuner_window___lambda50_ (self);
}

static void
_tuner_window___lambda51_ (Block11Data* _data11_,
                           GraniteWidgetsSourceListItem* item)
{
	TunerWindow* self;
	gchar* selected_item = NULL;
	gconstpointer _tmp0_;
	gchar* _tmp1_;
	GtkStack* _tmp2_;
	const gchar* _tmp3_;
	self = _data11_->self;
	_tmp0_ = g_object_get_data ((GObject*) item, "stack_child");
	_tmp1_ = g_strdup ((const gchar*) _tmp0_);
	selected_item = _tmp1_;
	_tmp2_ = _data11_->stack;
	_tmp3_ = selected_item;
	gtk_stack_set_visible_child_name (_tmp2_, _tmp3_);
	_g_free0 (selected_item);
}

static void
__tuner_window___lambda51__granite_widgets_source_list_item_selected (GraniteWidgetsSourceList* _sender,
                                                                      GraniteWidgetsSourceListItem* item,
                                                                      gpointer self)
{
	_tuner_window___lambda51_ (self, item);
}

static void
_tuner_window___lambda52_ (Block11Data* _data11_,
                           const gchar* text)
{
	TunerWindow* self;
	gint _tmp0_;
	gint _tmp1_;
	GError* _inner_error0_ = NULL;
	self = _data11_->self;
	g_return_if_fail (text != NULL);
	_tmp0_ = strlen (text);
	_tmp1_ = _tmp0_;
	if (_tmp1_ > 0) {
		gchar* mytext = NULL;
		gchar* _tmp2_;
		TunerStationSource* s5 = NULL;
		TunerDirectoryController* _tmp3_;
		const gchar* _tmp4_;
		gchar* _tmp5_;
		TunerStationSource* _tmp6_;
		_tmp2_ = g_strdup (text);
		mytext = _tmp2_;
		_tmp3_ = self->priv->_directory;
		_tmp4_ = mytext;
		_tmp5_ = g_strdup (_tmp4_);
		_tmp6_ = tuner_directory_controller_load_search_stations (_tmp3_, _tmp5_, (guint) 100);
		s5 = _tmp6_;
		{
			GeeArrayList* stations = NULL;
			TunerStationSource* _tmp7_;
			GeeArrayList* _tmp8_;
			gboolean _tmp9_ = FALSE;
			GeeArrayList* _tmp10_;
			_tmp7_ = s5;
			_tmp8_ = tuner_station_source_next (_tmp7_, &_inner_error0_);
			stations = _tmp8_;
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
				if (_inner_error0_->domain == SOURCE_ERROR) {
					goto __catch0_source_error;
				}
				_g_object_unref0 (s5);
				_g_free0 (mytext);
				g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
				g_clear_error (&_inner_error0_);
				return;
			}
			_tmp10_ = stations;
			if (_tmp10_ == NULL) {
				_tmp9_ = TRUE;
			} else {
				GeeArrayList* _tmp11_;
				gint _tmp12_;
				gint _tmp13_;
				_tmp11_ = stations;
				_tmp12_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp11_);
				_tmp13_ = _tmp12_;
				_tmp9_ = _tmp13_ == 0;
			}
			if (_tmp9_) {
				TunerContentBox* _tmp14_;
				_tmp14_ = _data11_->c5;
				tuner_content_box_show_nothing_found (_tmp14_);
			} else {
				TunerStationList* _slist = NULL;
				GeeArrayList* _tmp15_;
				TunerStationList* _tmp16_;
				TunerStationList* _tmp17_;
				TunerStationList* _tmp18_;
				TunerContentBox* _tmp19_;
				TunerStationList* _tmp20_;
				_tmp15_ = stations;
				_tmp16_ = tuner_station_list_new_with_stations (_tmp15_);
				g_object_ref_sink (_tmp16_);
				_slist = _tmp16_;
				_tmp17_ = _slist;
				g_signal_connect_object (_tmp17_, "selection-changed", (GCallback) _tuner_window_handle_station_click_tuner_station_list_selection_changed, self, 0);
				_tmp18_ = _slist;
				g_signal_connect_object (_tmp18_, "favourites-changed", (GCallback) _tuner_window_handle_favourites_changed_tuner_station_list_favourites_changed, self, 0);
				_tmp19_ = _data11_->c5;
				_tmp20_ = _slist;
				tuner_content_box_set_content (_tmp19_, (TunerAbstractContentList*) _tmp20_);
				_g_object_unref0 (_slist);
			}
			_g_object_unref0 (stations);
		}
		goto __finally0;
		__catch0_source_error:
		{
			TunerContentBox* _tmp21_;
			g_clear_error (&_inner_error0_);
			_tmp21_ = _data11_->c5;
			tuner_content_box_show_alert (_tmp21_);
		}
		__finally0:
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			_g_object_unref0 (s5);
			_g_free0 (mytext);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return;
		}
		_g_object_unref0 (s5);
		_g_free0 (mytext);
	}
}

static void
__tuner_window___lambda52__tuner_header_bar_searched_for (TunerHeaderBar* _sender,
                                                          const gchar* text,
                                                          gpointer self)
{
	_tuner_window___lambda52_ (self, text);
}

static void
_tuner_window___lambda53_ (Block11Data* _data11_)
{
	TunerWindow* self;
	GtkStack* _tmp0_;
	self = _data11_->self;
	_tmp0_ = _data11_->stack;
	gtk_stack_set_visible_child_name (_tmp0_, "searched");
}

static void
__tuner_window___lambda53__tuner_header_bar_search_focused (TunerHeaderBar* _sender,
                                                            gpointer self)
{
	_tuner_window___lambda53_ (self);
}

static GObject *
tuner_window_constructor (GType type,
                          guint n_construct_properties,
                          GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	TunerWindow * self;
	Block11Data* _data11_;
	TunerHeaderBar* _tmp0_;
	TunerHeaderBar* _tmp1_;
	TunerPlayerController* _tmp2_;
	TunerPlayerController* _tmp3_;
	TunerHeaderBar* _tmp4_;
	TunerPlayerController* _tmp5_;
	TunerPlayerController* _tmp6_;
	TunerHeaderBar* _tmp7_;
	GtkVolumeButton* _tmp8_;
	GSettings* _tmp9_;
	GraniteSettings* granite_settings = NULL;
	GraniteSettings* _tmp10_;
	GraniteSettings* _tmp11_;
	GraniteSettings* _tmp12_;
	GSettings* _tmp13_;
	GVariant* _tmp14_;
	GSettings* _tmp15_;
	GVariant* _tmp16_;
	GSettings* _tmp17_;
	GSettings* _tmp18_;
	GdkGeometry _tmp19_ = {0};
	GSettings* _tmp20_;
	GSettings* _tmp21_;
	GtkStack* _tmp22_;
	GtkStack* _tmp23_;
	gchar* data_file = NULL;
	TunerApplication* _tmp24_;
	TunerApplication* _tmp25_;
	const gchar* _tmp26_;
	const gchar* _tmp27_;
	gchar* _tmp28_;
	TunerModelStationStore* store = NULL;
	const gchar* _tmp29_;
	TunerModelStationStore* _tmp30_;
	TunerModelStationStore* _tmp31_;
	TunerDirectoryController* _tmp32_;
	GtkPaned* primary_box = NULL;
	GtkPaned* _tmp33_;
	GraniteWidgetsSourceListExpandableItem* _tmp34_;
	GraniteWidgetsSourceListExpandableItem* _tmp35_;
	GraniteWidgetsSourceListExpandableItem* _tmp36_;
	GraniteWidgetsSourceListExpandableItem* searched_category = NULL;
	GraniteWidgetsSourceListExpandableItem* _tmp37_;
	GraniteWidgetsSourceListExpandableItem* _tmp38_;
	GraniteWidgetsSourceListExpandableItem* _tmp39_;
	GraniteWidgetsSourceListExpandableItem* genres_category = NULL;
	GraniteWidgetsSourceListExpandableItem* _tmp40_;
	GraniteWidgetsSourceListExpandableItem* _tmp41_;
	GraniteWidgetsSourceListExpandableItem* _tmp42_;
	GraniteWidgetsSourceListExpandableItem* _tmp43_;
	GraniteWidgetsSourceListExpandableItem* _tmp44_;
	GraniteWidgetsSourceList* _tmp45_;
	GraniteWidgetsSourceListItem* item1 = NULL;
	GraniteWidgetsSourceListItem* _tmp46_;
	GraniteWidgetsSourceListItem* _tmp47_;
	GThemedIcon* _tmp48_;
	GThemedIcon* _tmp49_;
	GraniteWidgetsSourceListExpandableItem* _tmp50_;
	GraniteWidgetsSourceListItem* _tmp51_;
	GraniteWidgetsSourceListItem* _tmp52_;
	GtkStack* _tmp53_;
	GraniteWidgetsSourceList* _tmp54_;
	TunerContentBox* _tmp55_;
	TunerDirectoryController* _tmp56_;
	TunerStationSource* _tmp57_;
	TunerContentBox* _tmp58_;
	TunerContentBox* _tmp59_;
	GraniteWidgetsSourceListItem* item2 = NULL;
	GraniteWidgetsSourceListItem* _tmp60_;
	GraniteWidgetsSourceListItem* _tmp61_;
	GThemedIcon* _tmp62_;
	GThemedIcon* _tmp63_;
	GraniteWidgetsSourceListExpandableItem* _tmp64_;
	GraniteWidgetsSourceListItem* _tmp65_;
	GraniteWidgetsSourceListItem* _tmp66_;
	GtkStack* _tmp67_;
	GraniteWidgetsSourceList* _tmp68_;
	TunerContentBox* _tmp69_;
	TunerDirectoryController* _tmp70_;
	TunerStationSource* _tmp71_;
	TunerContentBox* _tmp72_;
	GraniteWidgetsSourceListItem* item3 = NULL;
	GraniteWidgetsSourceListItem* _tmp73_;
	GraniteWidgetsSourceListItem* _tmp74_;
	GThemedIcon* _tmp75_;
	GThemedIcon* _tmp76_;
	GraniteWidgetsSourceListExpandableItem* _tmp77_;
	GraniteWidgetsSourceListItem* _tmp78_;
	GraniteWidgetsSourceListItem* _tmp79_;
	GtkStack* _tmp80_;
	GraniteWidgetsSourceList* _tmp81_;
	TunerContentBox* _tmp82_;
	TunerDirectoryController* _tmp83_;
	TunerStationSource* _tmp84_;
	TunerContentBox* _tmp85_;
	GraniteWidgetsSourceListItem* _tmp86_;
	GraniteWidgetsSourceListItem* _tmp87_;
	GThemedIcon* _tmp88_;
	GThemedIcon* _tmp89_;
	GraniteWidgetsSourceListItem* _tmp90_;
	GtkStack* _tmp91_;
	GraniteWidgetsSourceList* _tmp92_;
	TunerContentBox* _tmp93_;
	TunerStationList* _tmp94_;
	TunerStationList* _tmp95_;
	TunerStationList* _tmp96_;
	GraniteWidgetsSourceListItem* item5 = NULL;
	GraniteWidgetsSourceListItem* _tmp97_;
	GraniteWidgetsSourceListItem* _tmp98_;
	GThemedIcon* _tmp99_;
	GThemedIcon* _tmp100_;
	GraniteWidgetsSourceListExpandableItem* _tmp101_;
	GraniteWidgetsSourceListItem* _tmp102_;
	GraniteWidgetsSourceListItem* _tmp103_;
	GtkStack* _tmp104_;
	GraniteWidgetsSourceList* _tmp105_;
	TunerContentBox* _tmp106_;
	TunerStationList* slist = NULL;
	TunerDirectoryController* _tmp107_;
	GeeArrayList* _tmp108_;
	GeeArrayList* _tmp109_;
	TunerStationList* _tmp110_;
	TunerStationList* _tmp111_;
	TunerStationList* _tmp112_;
	TunerStationList* _tmp113_;
	TunerContentBox* _tmp114_;
	TunerStationList* _tmp115_;
	GraniteWidgetsSourceListItem* item6 = NULL;
	GraniteWidgetsSourceListItem* _tmp116_;
	GraniteWidgetsSourceListItem* _tmp117_;
	GThemedIcon* _tmp118_;
	GThemedIcon* _tmp119_;
	GraniteWidgetsSourceListExpandableItem* _tmp120_;
	GraniteWidgetsSourceListItem* _tmp121_;
	GraniteWidgetsSourceListItem* _tmp122_;
	GtkStack* _tmp123_;
	GraniteWidgetsSourceList* _tmp124_;
	TunerContentBox* _tmp125_;
	gint _tmp126_ = 0;
	TunerModelGenre** _tmp127_;
	TunerHeaderBar* _tmp154_;
	GraniteWidgetsSourceList* _tmp155_;
	GraniteWidgetsSourceListExpandableItem* _tmp156_;
	GraniteWidgetsSourceListExpandableItem* _tmp157_;
	GraniteWidgetsSourceListExpandableItem* _tmp158_;
	GraniteWidgetsSourceList* _tmp159_;
	GraniteWidgetsSourceListExpandableItem* _tmp160_;
	GraniteWidgetsSourceListExpandableItem* _tmp161_;
	GraniteWidgetsSourceListExpandableItem* _tmp162_;
	GraniteWidgetsSourceList* _tmp163_;
	GraniteWidgetsSourceListExpandableItem* _tmp164_;
	GraniteWidgetsSourceListExpandableItem* _tmp165_;
	GraniteWidgetsSourceListExpandableItem* _tmp166_;
	GraniteWidgetsSourceList* _tmp167_;
	GraniteWidgetsSourceList* _tmp168_;
	GraniteWidgetsSourceList* _tmp169_;
	GraniteWidgetsSourceListExpandableItem* _tmp170_;
	GraniteWidgetsSourceListItem* _tmp171_;
	GraniteWidgetsSourceListItem* _tmp172_;
	GraniteWidgetsSourceList* _tmp173_;
	TunerHeaderBar* _tmp174_;
	TunerHeaderBar* _tmp175_;
	GtkPaned* _tmp176_;
	GraniteWidgetsSourceList* _tmp177_;
	GtkPaned* _tmp178_;
	GtkStack* _tmp179_;
	GtkPaned* _tmp180_;
	GSettings* _tmp181_;
	GError* _inner_error0_ = NULL;
	parent_class = G_OBJECT_CLASS (tuner_window_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TUNER_TYPE_WINDOW, TunerWindow);
	_data11_ = g_slice_new0 (Block11Data);
	_data11_->_ref_count_ = 1;
	_data11_->self = g_object_ref (self);
	_tmp0_ = tuner_header_bar_new ();
	g_object_ref_sink (_tmp0_);
	_g_object_unref0 (self->priv->headerbar);
	self->priv->headerbar = _tmp0_;
	_tmp1_ = self->priv->headerbar;
	gtk_window_set_titlebar ((GtkWindow*) self, (GtkWidget*) _tmp1_);
	gtk_window_set_title ((GtkWindow*) self, TUNER_WINDOW_WindowName);
	_tmp2_ = self->priv->_player;
	g_signal_connect_object (_tmp2_, "state-changed", (GCallback) _tuner_window_handleplayer_state_changed_tuner_player_controller_state_changed, self, 0);
	_tmp3_ = self->priv->_player;
	_tmp4_ = self->priv->headerbar;
	g_signal_connect_object (_tmp3_, "station-changed", (GCallback) _tuner_header_bar_update_from_station_tuner_player_controller_station_changed, _tmp4_, 0);
	_tmp5_ = self->priv->_player;
	g_signal_connect_object (_tmp5_, "title-changed", (GCallback) __tuner_window___lambda26__tuner_player_controller_title_changed, self, 0);
	_tmp6_ = self->priv->_player;
	g_signal_connect_object (_tmp6_, "volume-changed", (GCallback) __tuner_window___lambda27__tuner_player_controller_volume_changed, self, 0);
	_tmp7_ = self->priv->headerbar;
	_tmp8_ = _tmp7_->volume_button;
	g_signal_connect_object ((GtkScaleButton*) _tmp8_, "value-changed", (GCallback) __tuner_window___lambda28__gtk_scale_button_value_changed, self, 0);
	tuner_window_adjust_theme ();
	_tmp9_ = self->priv->_settings;
	g_signal_connect_object (_tmp9_, "changed", (GCallback) __tuner_window___lambda29__g_settings_changed, self, 0);
	_tmp10_ = granite_settings_get_default ();
	_tmp11_ = _g_object_ref0 (_tmp10_);
	granite_settings = _tmp11_;
	_tmp12_ = granite_settings;
	g_signal_connect_object ((GObject*) _tmp12_, "notify", (GCallback) __tuner_window___lambda30__g_object_notify, self, 0);
	g_action_map_add_action_entries ((GActionMap*) self, TUNER_WINDOW_ACTION_ENTRIES, (gint) G_N_ELEMENTS (TUNER_WINDOW_ACTION_ENTRIES), self);
	g_object_set ((GtkWindow*) self, "window-position", GTK_WIN_POS_CENTER, NULL);
	gtk_window_set_default_size ((GtkWindow*) self, 800, 540);
	_tmp13_ = self->priv->_settings;
	_tmp14_ = _variant_new8 (g_settings_get_boolean (_tmp13_, "do-not-track"));
	g_action_group_change_action_state ((GActionGroup*) self, TUNER_WINDOW_ACTION_DISABLE_TRACKING, _tmp14_);
	_g_variant_unref0 (_tmp14_);
	_tmp15_ = self->priv->_settings;
	_tmp16_ = _variant_new9 (g_settings_get_boolean (_tmp15_, "auto-play"));
	g_action_group_change_action_state ((GActionGroup*) self, TUNER_WINDOW_ACTION_ENABLE_AUTOPLAY, _tmp16_);
	_g_variant_unref0 (_tmp16_);
	_tmp17_ = self->priv->_settings;
	_tmp18_ = self->priv->_settings;
	gtk_window_move ((GtkWindow*) self, g_settings_get_int (_tmp17_, "pos-x"), g_settings_get_int (_tmp18_, "pos-y"));
	memset (&_tmp19_, 0, sizeof (GdkGeometry));
	_tmp19_.min_height = 440;
	_tmp19_.min_width = 600;
	gtk_window_set_geometry_hints ((GtkWindow*) self, NULL, &_tmp19_, GDK_HINT_MIN_SIZE);
	_tmp20_ = self->priv->_settings;
	_tmp21_ = self->priv->_settings;
	gtk_window_resize ((GtkWindow*) self, g_settings_get_int (_tmp20_, "window-width"), g_settings_get_int (_tmp21_, "window-height"));
	g_signal_connect_object ((GtkWidget*) self, "delete-event", (GCallback) __tuner_window___lambda31__gtk_widget_delete_event, self, 0);
	_tmp22_ = (GtkStack*) gtk_stack_new ();
	g_object_ref_sink (_tmp22_);
	_data11_->stack = _tmp22_;
	_tmp23_ = _data11_->stack;
	gtk_stack_set_transition_type (_tmp23_, GTK_STACK_TRANSITION_TYPE_CROSSFADE);
	_tmp24_ = tuner_application_get_instance ();
	_tmp25_ = _tmp24_;
	_tmp26_ = tuner_application_get_data_dir (_tmp25_);
	_tmp27_ = _tmp26_;
	_tmp28_ = g_build_filename (_tmp27_, "favorites.json", NULL);
	data_file = _tmp28_;
	_tmp29_ = data_file;
	_tmp30_ = tuner_model_station_store_new (_tmp29_);
	store = _tmp30_;
	_tmp31_ = store;
	_tmp32_ = tuner_directory_controller_new (_tmp31_);
	_g_object_unref0 (self->priv->_directory);
	self->priv->_directory = _tmp32_;
	_tmp33_ = (GtkPaned*) gtk_paned_new (GTK_ORIENTATION_HORIZONTAL);
	g_object_ref_sink (_tmp33_);
	primary_box = _tmp33_;
	_tmp34_ = granite_widgets_source_list_expandable_item_new (_ ("Selections"));
	_data11_->selections_category = _tmp34_;
	_tmp35_ = _data11_->selections_category;
	granite_widgets_source_list_expandable_item_set_collapsible (_tmp35_, FALSE);
	_tmp36_ = _data11_->selections_category;
	granite_widgets_source_list_expandable_item_set_expanded (_tmp36_, TRUE);
	_tmp37_ = granite_widgets_source_list_expandable_item_new (_ ("Library"));
	searched_category = _tmp37_;
	_tmp38_ = searched_category;
	granite_widgets_source_list_expandable_item_set_collapsible (_tmp38_, FALSE);
	_tmp39_ = searched_category;
	granite_widgets_source_list_expandable_item_set_expanded (_tmp39_, TRUE);
	_tmp40_ = granite_widgets_source_list_expandable_item_new (_ ("Genres"));
	genres_category = _tmp40_;
	_tmp41_ = genres_category;
	granite_widgets_source_list_expandable_item_set_collapsible (_tmp41_, TRUE);
	_tmp42_ = genres_category;
	granite_widgets_source_list_expandable_item_set_expanded (_tmp42_, TRUE);
	_tmp43_ = granite_widgets_source_list_expandable_item_new ("");
	_tmp44_ = _tmp43_;
	_tmp45_ = granite_widgets_source_list_new (_tmp44_);
	g_object_ref_sink (_tmp45_);
	_g_object_unref0 (self->priv->source_list);
	self->priv->source_list = _tmp45_;
	_g_object_unref0 (_tmp44_);
	_tmp46_ = granite_widgets_source_list_item_new (_ ("Discover"));
	item1 = _tmp46_;
	_tmp47_ = item1;
	_tmp48_ = (GThemedIcon*) g_themed_icon_new ("face-smile");
	_tmp49_ = _tmp48_;
	granite_widgets_source_list_item_set_icon (_tmp47_, (GIcon*) _tmp49_);
	_g_object_unref0 (_tmp49_);
	_tmp50_ = _data11_->selections_category;
	_tmp51_ = item1;
	granite_widgets_source_list_expandable_item_add (_tmp50_, _tmp51_);
	_tmp52_ = item1;
	_tmp53_ = _data11_->stack;
	_tmp54_ = self->priv->source_list;
	_tmp55_ = tuner_window_create_content_box (self, "discover", _tmp52_, _ ("Discover Stations"), "media-playlist-shuffle-symbolic", _ ("Discover more stations"), _tmp53_, _tmp54_, FALSE);
	_data11_->c1 = _tmp55_;
	_tmp56_ = self->priv->_directory;
	_tmp57_ = tuner_directory_controller_load_random_stations (_tmp56_, (guint) 20);
	_data11_->s1 = _tmp57_;
	_tmp58_ = _data11_->c1;
	g_signal_connect_data ((GtkWidget*) _tmp58_, "realize", (GCallback) __tuner_window___lambda36__gtk_widget_realize, block11_data_ref (_data11_), (GClosureNotify) block11_data_unref, 0);
	_tmp59_ = _data11_->c1;
	g_signal_connect_data (_tmp59_, "action-activated", (GCallback) __tuner_window___lambda43__tuner_content_box_action_activated, block11_data_ref (_data11_), (GClosureNotify) block11_data_unref, 0);
	_tmp60_ = granite_widgets_source_list_item_new (_ ("Trending"));
	item2 = _tmp60_;
	_tmp61_ = item2;
	_tmp62_ = (GThemedIcon*) g_themed_icon_new ("playlist-queue");
	_tmp63_ = _tmp62_;
	granite_widgets_source_list_item_set_icon (_tmp61_, (GIcon*) _tmp63_);
	_g_object_unref0 (_tmp63_);
	_tmp64_ = _data11_->selections_category;
	_tmp65_ = item2;
	granite_widgets_source_list_expandable_item_add (_tmp64_, _tmp65_);
	_tmp66_ = item2;
	_tmp67_ = _data11_->stack;
	_tmp68_ = self->priv->source_list;
	_tmp69_ = tuner_window_create_content_box (self, "trending", _tmp66_, _ ("Trending in the last 24 hours"), NULL, NULL, _tmp67_, _tmp68_, FALSE);
	_data11_->c2 = _tmp69_;
	_tmp70_ = self->priv->_directory;
	_tmp71_ = tuner_directory_controller_load_trending_stations (_tmp70_, (guint) 40);
	_data11_->s2 = _tmp71_;
	_tmp72_ = _data11_->c2;
	g_signal_connect_data ((GtkWidget*) _tmp72_, "realize", (GCallback) __tuner_window___lambda44__gtk_widget_realize, block11_data_ref (_data11_), (GClosureNotify) block11_data_unref, 0);
	_tmp73_ = granite_widgets_source_list_item_new (_ ("Popular"));
	item3 = _tmp73_;
	_tmp74_ = item3;
	_tmp75_ = (GThemedIcon*) g_themed_icon_new ("playlist-similar");
	_tmp76_ = _tmp75_;
	granite_widgets_source_list_item_set_icon (_tmp74_, (GIcon*) _tmp76_);
	_g_object_unref0 (_tmp76_);
	_tmp77_ = _data11_->selections_category;
	_tmp78_ = item3;
	granite_widgets_source_list_expandable_item_add (_tmp77_, _tmp78_);
	_tmp79_ = item3;
	_tmp80_ = _data11_->stack;
	_tmp81_ = self->priv->source_list;
	_tmp82_ = tuner_window_create_content_box (self, "popular", _tmp79_, _ ("Most-listened over 24 hours"), NULL, NULL, _tmp80_, _tmp81_, FALSE);
	_data11_->c3 = _tmp82_;
	_tmp83_ = self->priv->_directory;
	_tmp84_ = tuner_directory_controller_load_popular_stations (_tmp83_, (guint) 40);
	_data11_->s3 = _tmp84_;
	_tmp85_ = _data11_->c3;
	g_signal_connect_data ((GtkWidget*) _tmp85_, "realize", (GCallback) __tuner_window___lambda45__gtk_widget_realize, block11_data_ref (_data11_), (GClosureNotify) block11_data_unref, 0);
	_tmp86_ = granite_widgets_source_list_item_new (_ ("Your Country"));
	_data11_->item4 = _tmp86_;
	_tmp87_ = _data11_->item4;
	_tmp88_ = (GThemedIcon*) g_themed_icon_new ("emblem-web");
	_tmp89_ = _tmp88_;
	granite_widgets_source_list_item_set_icon (_tmp87_, (GIcon*) _tmp89_);
	_g_object_unref0 (_tmp89_);
	_tmp90_ = _data11_->item4;
	_tmp91_ = _data11_->stack;
	_tmp92_ = self->priv->source_list;
	_tmp93_ = tuner_window_create_content_box (self, "my-country", _tmp90_, _ ("Your Country"), NULL, NULL, _tmp91_, _tmp92_, TRUE);
	_g_object_unref0 (_data11_->c_country);
	_data11_->c_country = _tmp93_;
	_tmp94_ = tuner_station_list_new ();
	g_object_ref_sink (_tmp94_);
	_data11_->c_slist = _tmp94_;
	_tmp95_ = _data11_->c_slist;
	g_signal_connect_object (_tmp95_, "selection-changed", (GCallback) _tuner_window_handle_station_click_tuner_station_list_selection_changed, self, 0);
	_tmp96_ = _data11_->c_slist;
	g_signal_connect_object (_tmp96_, "favourites-changed", (GCallback) _tuner_window_handle_favourites_changed_tuner_station_list_favourites_changed, self, 0);
	tuner_location_discovery_country_code (__tuner_window___lambda46__gasync_ready_callback, block11_data_ref (_data11_));
	_tmp97_ = granite_widgets_source_list_item_new (_ ("Starred by You"));
	item5 = _tmp97_;
	_tmp98_ = item5;
	_tmp99_ = (GThemedIcon*) g_themed_icon_new ("starred");
	_tmp100_ = _tmp99_;
	granite_widgets_source_list_item_set_icon (_tmp98_, (GIcon*) _tmp100_);
	_g_object_unref0 (_tmp100_);
	_tmp101_ = searched_category;
	_tmp102_ = item5;
	granite_widgets_source_list_expandable_item_add (_tmp101_, _tmp102_);
	_tmp103_ = item5;
	_tmp104_ = _data11_->stack;
	_tmp105_ = self->priv->source_list;
	_tmp106_ = tuner_window_create_content_box (self, "starred", _tmp103_, _ ("Starred by You"), NULL, NULL, _tmp104_, _tmp105_, TRUE);
	_data11_->c4 = _tmp106_;
	_tmp107_ = self->priv->_directory;
	_tmp108_ = tuner_directory_controller_get_stored (_tmp107_);
	_tmp109_ = _tmp108_;
	_tmp110_ = tuner_station_list_new_with_stations (_tmp109_);
	g_object_ref_sink (_tmp110_);
	_tmp111_ = _tmp110_;
	_g_object_unref0 (_tmp109_);
	slist = _tmp111_;
	_tmp112_ = slist;
	g_signal_connect_object (_tmp112_, "selection-changed", (GCallback) _tuner_window_handle_station_click_tuner_station_list_selection_changed, self, 0);
	_tmp113_ = slist;
	g_signal_connect_object (_tmp113_, "favourites-changed", (GCallback) _tuner_window_handle_favourites_changed_tuner_station_list_favourites_changed, self, 0);
	_tmp114_ = _data11_->c4;
	_tmp115_ = slist;
	tuner_content_box_set_content (_tmp114_, (TunerAbstractContentList*) _tmp115_);
	_tmp116_ = granite_widgets_source_list_item_new (_ ("Recent Search"));
	item6 = _tmp116_;
	_tmp117_ = item6;
	_tmp118_ = (GThemedIcon*) g_themed_icon_new ("folder-saved-search");
	_tmp119_ = _tmp118_;
	granite_widgets_source_list_item_set_icon (_tmp117_, (GIcon*) _tmp119_);
	_g_object_unref0 (_tmp119_);
	_tmp120_ = searched_category;
	_tmp121_ = item6;
	granite_widgets_source_list_expandable_item_add (_tmp120_, _tmp121_);
	_tmp122_ = item6;
	_tmp123_ = _data11_->stack;
	_tmp124_ = self->priv->source_list;
	_tmp125_ = tuner_window_create_content_box (self, "searched", _tmp122_, _ ("Search"), NULL, NULL, _tmp123_, _tmp124_, TRUE);
	_data11_->c5 = _tmp125_;
	_tmp127_ = tuner_model_genres (&_tmp126_);
	{
		TunerModelGenre** genre_collection = NULL;
		gint genre_collection_length1 = 0;
		gint _genre_collection_size_ = 0;
		gint genre_it = 0;
		genre_collection = _tmp127_;
		genre_collection_length1 = _tmp126_;
		for (genre_it = 0; genre_it < genre_collection_length1; genre_it = genre_it + 1) {
			TunerModelGenre* _tmp128_;
			TunerModelGenre* genre = NULL;
			_tmp128_ = _tuner_model_genre_ref0 (genre_collection[genre_it]);
			genre = _tmp128_;
			{
				Block13Data* _data13_;
				GraniteWidgetsSourceListItem* item8 = NULL;
				TunerModelGenre* _tmp129_;
				const gchar* _tmp130_;
				GraniteWidgetsSourceListItem* _tmp131_;
				GraniteWidgetsSourceListItem* _tmp132_;
				GThemedIcon* _tmp133_;
				GThemedIcon* _tmp134_;
				GraniteWidgetsSourceListExpandableItem* _tmp135_;
				GraniteWidgetsSourceListItem* _tmp136_;
				TunerModelGenre* _tmp137_;
				const gchar* _tmp138_;
				GraniteWidgetsSourceListItem* _tmp139_;
				TunerModelGenre* _tmp140_;
				const gchar* _tmp141_;
				GtkStack* _tmp142_;
				GraniteWidgetsSourceList* _tmp143_;
				TunerContentBox* _tmp144_;
				GeeArrayList* tags = NULL;
				TunerModelGenre* _tmp145_;
				gchar** _tmp146_;
				gint _tmp146__length1;
				gchar** _tmp147_;
				gint _tmp147__length1;
				GeeArrayList* _tmp148_;
				TunerDirectoryController* _tmp149_;
				GeeArrayList* _tmp150_;
				GeeArrayList* _tmp151_;
				TunerStationSource* _tmp152_;
				TunerContentBox* _tmp153_;
				_data13_ = g_slice_new0 (Block13Data);
				_data13_->_ref_count_ = 1;
				_data13_->_data11_ = block11_data_ref (_data11_);
				_tmp129_ = genre;
				_tmp130_ = _tmp129_->name;
				_tmp131_ = granite_widgets_source_list_item_new (_ (_tmp130_));
				item8 = _tmp131_;
				_tmp132_ = item8;
				_tmp133_ = (GThemedIcon*) g_themed_icon_new ("playlist-symbolic");
				_tmp134_ = _tmp133_;
				granite_widgets_source_list_item_set_icon (_tmp132_, (GIcon*) _tmp134_);
				_g_object_unref0 (_tmp134_);
				_tmp135_ = genres_category;
				_tmp136_ = item8;
				granite_widgets_source_list_expandable_item_add (_tmp135_, _tmp136_);
				_tmp137_ = genre;
				_tmp138_ = _tmp137_->name;
				_tmp139_ = item8;
				_tmp140_ = genre;
				_tmp141_ = _tmp140_->name;
				_tmp142_ = _data11_->stack;
				_tmp143_ = self->priv->source_list;
				_tmp144_ = tuner_window_create_content_box (self, _tmp138_, _tmp139_, _tmp141_, NULL, NULL, _tmp142_, _tmp143_, FALSE);
				_data13_->cb = _tmp144_;
				_tmp145_ = genre;
				_tmp146_ = _tmp145_->tags;
				_tmp146__length1 = _tmp145_->tags_length1;
				_tmp147_ = (_tmp146_ != NULL) ? _vala_array_dup8 (_tmp146_, _tmp146__length1) : _tmp146_;
				_tmp147__length1 = _tmp146__length1;
				_tmp148_ = gee_array_list_new_wrap (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, _tmp147_, _tmp147__length1, NULL, NULL, NULL);
				tags = _tmp148_;
				_tmp149_ = self->priv->_directory;
				_tmp150_ = tags;
				_tmp151_ = _g_object_ref0 (_tmp150_);
				_tmp152_ = tuner_directory_controller_load_by_tags (_tmp149_, _tmp151_);
				_data13_->ds = _tmp152_;
				_tmp153_ = _data13_->cb;
				g_signal_connect_data ((GtkWidget*) _tmp153_, "realize", (GCallback) __tuner_window_____lambda48__gtk_widget_realize, block13_data_ref (_data13_), (GClosureNotify) block13_data_unref, 0);
				_g_object_unref0 (tags);
				_g_object_unref0 (item8);
				_tuner_model_genre_unref0 (genre);
				block13_data_unref (_data13_);
				_data13_ = NULL;
			}
		}
		genre_collection = (_vala_array_free (genre_collection, genre_collection_length1, (GDestroyNotify) tuner_model_genre_unref), NULL);
	}
	_tmp154_ = self->priv->headerbar;
	g_signal_connect_object (_tmp154_, "star-clicked", (GCallback) __tuner_window___lambda49__tuner_header_bar_star_clicked, self, 0);
	g_signal_connect_data (self, "refresh-favourites", (GCallback) __tuner_window___lambda50__tuner_window_refresh_favourites, block11_data_ref (_data11_), (GClosureNotify) block11_data_unref, 0);
	_tmp155_ = self->priv->source_list;
	_tmp156_ = granite_widgets_source_list_get_root (_tmp155_);
	_tmp157_ = _tmp156_;
	_tmp158_ = _data11_->selections_category;
	granite_widgets_source_list_expandable_item_add (_tmp157_, (GraniteWidgetsSourceListItem*) _tmp158_);
	_tmp159_ = self->priv->source_list;
	_tmp160_ = granite_widgets_source_list_get_root (_tmp159_);
	_tmp161_ = _tmp160_;
	_tmp162_ = searched_category;
	granite_widgets_source_list_expandable_item_add (_tmp161_, (GraniteWidgetsSourceListItem*) _tmp162_);
	_tmp163_ = self->priv->source_list;
	_tmp164_ = granite_widgets_source_list_get_root (_tmp163_);
	_tmp165_ = _tmp164_;
	_tmp166_ = genres_category;
	granite_widgets_source_list_expandable_item_add (_tmp165_, (GraniteWidgetsSourceListItem*) _tmp166_);
	_tmp167_ = self->priv->source_list;
	granite_widgets_source_list_set_ellipsize_mode (_tmp167_, PANGO_ELLIPSIZE_NONE);
	_tmp168_ = self->priv->source_list;
	_tmp169_ = self->priv->source_list;
	_tmp170_ = _data11_->selections_category;
	_tmp171_ = granite_widgets_source_list_get_first_child (_tmp169_, _tmp170_);
	_tmp172_ = _tmp171_;
	granite_widgets_source_list_set_selected (_tmp168_, _tmp172_);
	_g_object_unref0 (_tmp172_);
	_tmp173_ = self->priv->source_list;
	g_signal_connect_data (_tmp173_, "item-selected", (GCallback) __tuner_window___lambda51__granite_widgets_source_list_item_selected, block11_data_ref (_data11_), (GClosureNotify) block11_data_unref, 0);
	_tmp174_ = self->priv->headerbar;
	g_signal_connect_data (_tmp174_, "searched-for", (GCallback) __tuner_window___lambda52__tuner_header_bar_searched_for, block11_data_ref (_data11_), (GClosureNotify) block11_data_unref, 0);
	_tmp175_ = self->priv->headerbar;
	g_signal_connect_data (_tmp175_, "search-focused", (GCallback) __tuner_window___lambda53__tuner_header_bar_search_focused, block11_data_ref (_data11_), (GClosureNotify) block11_data_unref, 0);
	_tmp176_ = primary_box;
	_tmp177_ = self->priv->source_list;
	gtk_paned_pack1 (_tmp176_, (GtkWidget*) _tmp177_, FALSE, FALSE);
	_tmp178_ = primary_box;
	_tmp179_ = _data11_->stack;
	gtk_paned_pack2 (_tmp178_, (GtkWidget*) _tmp179_, TRUE, FALSE);
	_tmp180_ = primary_box;
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp180_);
	gtk_widget_show_all ((GtkWidget*) self);
	_tmp181_ = self->priv->_settings;
	if (g_settings_get_boolean (_tmp181_, "auto-play")) {
		gchar* last_played_station = NULL;
		GSettings* _tmp182_;
		gchar* _tmp183_;
		const gchar* _tmp184_;
		const gchar* _tmp185_;
		gchar* _tmp186_;
		gchar* _tmp187_;
		TunerStationSource* source = NULL;
		TunerDirectoryController* _tmp188_;
		const gchar* _tmp189_;
		TunerStationSource* _tmp190_;
		g_warning ("Window.vala:346: %s", "Auto-play enabled");
		_tmp182_ = self->priv->_settings;
		_tmp183_ = g_settings_get_string (_tmp182_, "last-played-station");
		last_played_station = _tmp183_;
		_tmp184_ = last_played_station;
		_tmp185_ = string_to_string (_tmp184_);
		_tmp186_ = g_strconcat ("Last played station is: ", _tmp185_, NULL);
		_tmp187_ = _tmp186_;
		g_warning ("Window.vala:348: %s", _tmp187_);
		_g_free0 (_tmp187_);
		_tmp188_ = self->priv->_directory;
		_tmp189_ = last_played_station;
		_tmp190_ = tuner_directory_controller_load_station_uuid (_tmp188_, _tmp189_);
		source = _tmp190_;
		{
			GeeArrayList* _tmp191_ = NULL;
			TunerStationSource* _tmp192_;
			GeeArrayList* _tmp193_;
			_tmp192_ = source;
			_tmp193_ = tuner_station_source_next (_tmp192_, &_inner_error0_);
			_tmp191_ = _tmp193_;
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
				if (_inner_error0_->domain == SOURCE_ERROR) {
					goto __catch0_source_error;
				}
				_g_object_unref0 (source);
				_g_free0 (last_played_station);
				_g_object_unref0 (item6);
				_g_object_unref0 (slist);
				_g_object_unref0 (item5);
				_g_object_unref0 (item3);
				_g_object_unref0 (item2);
				_g_object_unref0 (item1);
				_g_object_unref0 (genres_category);
				_g_object_unref0 (searched_category);
				_g_object_unref0 (primary_box);
				_g_object_unref0 (store);
				_g_free0 (data_file);
				_g_object_unref0 (granite_settings);
				block11_data_unref (_data11_);
				_data11_ = NULL;
				g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
				g_clear_error (&_inner_error0_);
			}
			{
				GeeArrayList* _station_list = NULL;
				gint _station_size = 0;
				GeeArrayList* _tmp194_;
				gint _tmp195_;
				gint _tmp196_;
				gint _station_index = 0;
				_station_list = _tmp191_;
				_tmp194_ = _station_list;
				_tmp195_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp194_);
				_tmp196_ = _tmp195_;
				_station_size = _tmp196_;
				_station_index = -1;
				while (TRUE) {
					gint _tmp197_;
					gint _tmp198_;
					TunerModelStation* station = NULL;
					GeeArrayList* _tmp199_;
					gpointer _tmp200_;
					TunerModelStation* _tmp201_;
					_station_index = _station_index + 1;
					_tmp197_ = _station_index;
					_tmp198_ = _station_size;
					if (!(_tmp197_ < _tmp198_)) {
						break;
					}
					_tmp199_ = _station_list;
					_tmp200_ = gee_abstract_list_get ((GeeAbstractList*) _tmp199_, _station_index);
					station = (TunerModelStation*) _tmp200_;
					_tmp201_ = station;
					tuner_window_handle_station_click (self, _tmp201_);
					_g_object_unref0 (station);
					break;
				}
			}
			_g_object_unref0 (_tmp191_);
		}
		goto __finally0;
		__catch0_source_error:
		{
			g_clear_error (&_inner_error0_);
			g_warning ("Window.vala:358: Error while trying to autoplay, aborting...");
		}
		__finally0:
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			_g_object_unref0 (source);
			_g_free0 (last_played_station);
			_g_object_unref0 (item6);
			_g_object_unref0 (slist);
			_g_object_unref0 (item5);
			_g_object_unref0 (item3);
			_g_object_unref0 (item2);
			_g_object_unref0 (item1);
			_g_object_unref0 (genres_category);
			_g_object_unref0 (searched_category);
			_g_object_unref0 (primary_box);
			_g_object_unref0 (store);
			_g_free0 (data_file);
			_g_object_unref0 (granite_settings);
			block11_data_unref (_data11_);
			_data11_ = NULL;
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
		}
		_g_object_unref0 (source);
		_g_free0 (last_played_station);
	}
	_g_object_unref0 (item6);
	_g_object_unref0 (slist);
	_g_object_unref0 (item5);
	_g_object_unref0 (item3);
	_g_object_unref0 (item2);
	_g_object_unref0 (item1);
	_g_object_unref0 (genres_category);
	_g_object_unref0 (searched_category);
	_g_object_unref0 (primary_box);
	_g_object_unref0 (store);
	_g_free0 (data_file);
	_g_object_unref0 (granite_settings);
	block11_data_unref (_data11_);
	_data11_ = NULL;
	return obj;
}

static void
tuner_window_class_init (TunerWindowClass * klass,
                         gpointer klass_data)
{
	GtkCssProvider* provider = NULL;
	GtkCssProvider* _tmp0_;
	GtkCssProvider* _tmp1_;
	GdkScreen* _tmp2_;
	GtkCssProvider* _tmp3_;
	tuner_window_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &TunerWindow_private_offset);
	G_OBJECT_CLASS (klass)->get_property = _vala_tuner_window_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_tuner_window_set_property;
	G_OBJECT_CLASS (klass)->constructor = tuner_window_constructor;
	G_OBJECT_CLASS (klass)->finalize = tuner_window_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), TUNER_WINDOW_SETTINGS_PROPERTY, tuner_window_properties[TUNER_WINDOW_SETTINGS_PROPERTY] = g_param_spec_object ("settings", "settings", "settings", g_settings_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
	g_object_class_install_property (G_OBJECT_CLASS (klass), TUNER_WINDOW_STACK_PROPERTY, tuner_window_properties[TUNER_WINDOW_STACK_PROPERTY] = g_param_spec_object ("stack", "stack", "stack", gtk_stack_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), TUNER_WINDOW_PLAYER_PROPERTY, tuner_window_properties[TUNER_WINDOW_PLAYER_PROPERTY] = g_param_spec_object ("player", "player", "player", TUNER_TYPE_PLAYER_CONTROLLER, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
	tuner_window_signals[TUNER_WINDOW_REFRESH_FAVOURITES_SIGNAL] = g_signal_new ("refresh-favourites", TUNER_TYPE_WINDOW, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
	_tmp0_ = gtk_css_provider_new ();
	provider = _tmp0_;
	_tmp1_ = provider;
	gtk_css_provider_load_from_resource (_tmp1_, "com/github/louis77/tuner/Application.css");
	_tmp2_ = gdk_screen_get_default ();
	_tmp3_ = provider;
	gtk_style_context_add_provider_for_screen (_tmp2_, (GtkStyleProvider*) _tmp3_, (guint) GTK_STYLE_PROVIDER_PRIORITY_APPLICATION);
	_g_object_unref0 (provider);
}

static void
tuner_window_instance_init (TunerWindow * self,
                            gpointer klass)
{
	self->priv = tuner_window_get_instance_private (self);
}

static void
tuner_window_finalize (GObject * obj)
{
	TunerWindow * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TUNER_TYPE_WINDOW, TunerWindow);
	_g_object_unref0 (self->priv->_settings);
	_g_object_unref0 (self->priv->_stack);
	_g_object_unref0 (self->priv->_player);
	_g_object_unref0 (self->priv->_directory);
	_g_object_unref0 (self->priv->headerbar);
	_g_object_unref0 (self->priv->source_list);
	G_OBJECT_CLASS (tuner_window_parent_class)->finalize (obj);
}

static GType
tuner_window_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (TunerWindowClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) tuner_window_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (TunerWindow), 0, (GInstanceInitFunc) tuner_window_instance_init, NULL };
	GType tuner_window_type_id;
	tuner_window_type_id = g_type_register_static (gtk_application_window_get_type (), "TunerWindow", &g_define_type_info, 0);
	TunerWindow_private_offset = g_type_add_instance_private (tuner_window_type_id, sizeof (TunerWindowPrivate));
	return tuner_window_type_id;
}

GType
tuner_window_get_type (void)
{
	static volatile gsize tuner_window_type_id__volatile = 0;
	if (g_once_init_enter (&tuner_window_type_id__volatile)) {
		GType tuner_window_type_id;
		tuner_window_type_id = tuner_window_get_type_once ();
		g_once_init_leave (&tuner_window_type_id__volatile, tuner_window_type_id);
	}
	return tuner_window_type_id__volatile;
}

static void
_vala_tuner_window_get_property (GObject * object,
                                 guint property_id,
                                 GValue * value,
                                 GParamSpec * pspec)
{
	TunerWindow * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TUNER_TYPE_WINDOW, TunerWindow);
	switch (property_id) {
		case TUNER_WINDOW_SETTINGS_PROPERTY:
		g_value_set_object (value, tuner_window_get_settings (self));
		break;
		case TUNER_WINDOW_STACK_PROPERTY:
		g_value_set_object (value, tuner_window_get_stack (self));
		break;
		case TUNER_WINDOW_PLAYER_PROPERTY:
		g_value_set_object (value, tuner_window_get_player (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_tuner_window_set_property (GObject * object,
                                 guint property_id,
                                 const GValue * value,
                                 GParamSpec * pspec)
{
	TunerWindow * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TUNER_TYPE_WINDOW, TunerWindow);
	switch (property_id) {
		case TUNER_WINDOW_SETTINGS_PROPERTY:
		tuner_window_set_settings (self, g_value_get_object (value));
		break;
		case TUNER_WINDOW_STACK_PROPERTY:
		tuner_window_set_stack (self, g_value_get_object (value));
		break;
		case TUNER_WINDOW_PLAYER_PROPERTY:
		tuner_window_set_player (self, g_value_get_object (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

